Welcome to Schema Compare for SQL Server

dbforge-schema-compare-header

Thank you for choosing Devart dbForge Schema Compare for SQL Server!

ExpandedToggleIcon(9x12) dbForge Schema Compare for SQL Server Overview

Give the Schema Compare a try, and you will use this tool for any major changes in the database structure. Our tool will help you to:

· Synchronize database schemas with complex object dependencies.
· Detect development errors early.
· Detect drift on production databases.
· Create deployment scripts targeting different SQL Server editions.

ExpandedToggleIcon(9x12) Where to Start

To start using dbForge Schema Compare for SQL Server, see Getting Started section. The guide helps you get started quickly by describing how to setup a new database connection, and provides an explanation of the key steps for basic operations.

ExpandedToggleIcon(9x12) See Also

Copyright Information

© 2009-2017 Devart


What's New in dbForge Schema Compare for SQL Server v4.4

SQL Server Support

· SQL Server 2016 Service Pack 1 (SP1) new syntax support
· SQL Server 2017 CTP2 new syntax support
· Azure SQL Data Warehouse connectivity support

Compatibility

dbForge Schema Compare can be integrated into the latest SQL Server Management Studio v17.2.

Schema Compare

· Support for external objects
· Support for the MASKED columns
· Extended support for Azure v.12
· Support for the SECURITY POLICY objects
· Support for the column encryption keys
· Support for the column master keys
· Extended support for comparison of the SQL Server 2014-2016 backup files
· New database creation through the Schema Comparison wizard
· Redesigned logging in the command line
· Opening the Schema Comparison wizard instead of the comparison autorun when opening the .scomp files

Source Control

· Support for TFS 2017
· Support for SourceGear Vault v9.1
· Support for SourceGear Vault v10.0
· Support for Surround SCM

Command Line Execution File

You can set up and create a command line execution file and use it multiple times for routine schema comparison and synchronization tasks.


Editions

dbForge Schema Compare comes in two editions:

Standard includes essential tools for schema comparison and synchronization;

Professional is a fully-featured software able to complete any schema comparison and synchronization tasks and provide the best professional tricks to easy your database management.

The table below represents comparative data of available editions of dbForge Schema Compare editions.

Features | Standard | Professional
Support for SQL Server 2017 CTP2.0 | yes | yes
Support for SQL Server 2016 SP1 | yes | yes
Support for SQL Server 2016, 2014, 2012, 2008R2, 2008, 2005 (including Express editions), 2000 (including MSDE edition), and Microsoft SQL Azure | yes | yes
Support for SSMS 2016, 2014, 2012, 2008R2, 2008 | yes | yes
Comparison of all SQL Server database objects | yes | yes
Comparison and synchronization of database properties | yes | yes
Creation and comparison of schema snapshots | yes | yes
Rich options to customize schema comparison and synchronization Updated | yes | yes
Generating comparison and synchronization reports | yes | yes
Execution of extra large scripts | yes | yes
Comparison of native SQL Server backups | none | yes
Support for version control schema comparison | none | yes
SVN, TFS, P4, Vault, GIT, Mercurial, Plastic SCM support | none | yes
Creation and comparison of database schema script folder | none | yes
Command line interface | none | yes
Generate Scripts wizard | yes | yes
Custom table mapping | yes | yes

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Requirements


Requirements

dbForge Schema Compare for SQL Server requires the following:

Microsoft SQL Server compatibility

· SQL Server 2017 CTP2.0, 2016SP1, 2016, 2014, 2012, LocalDB
· SQL Server 2008, 2008R2 (including Express edition)
· SQL Server 2005 (including Express edition)
· SQL Server 2000
· SQL Azure

Microsoft SQL Server Management Studio compatibility

· 2016, 2014, 2012, 2008R2, 2008

System Requirements

· .NET Framework 4.5.2 or higher installed. You can download .NET Framework here.

note Note

.NET Framework is pre-installed in Microsoft Windows Vista and Windows 7/8/8.1/10.

· Microsoft Windows 7/8/8.1/10
· Windows Server 2008/2012

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Copyright Information


Copyright Information

Information in this document, including URL and other Internet Web site references, is subject to change without notice. Unless otherwise noted, the example companies, organizations, products, domain names, e-mail addresses, logos, people, places and events depicted herein are fictitious, and no association with any real company, organization, product, domain name, e-mail address, logo, person, place , or event is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user.

Devart may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except, as expressly provided in any written license agreement from Devart, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

Copyright 2009-2017 Devart. All rights reserved.

Microsoft and Windows are either registered trademarks or trademarks of Microsoft Corporation in the United States and/or other countries.

The names of actual companies and products mentioned herein may be the trademarks of their respective owners.

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Previous Releases


Previous Releases

ExpandedToggleIcon(9x12) In This Section

What's New in dbForge Schema Compare for SQL Server, v4.3

What's New in dbForge Schema Compare for SQL Server, v4.2

What's New in dbForge Schema Compare for SQL Server, v4.1

What's New in dbForge Schema Compare for SQL Server, v4.0

What's New in dbForge Schema Compare for SQL Server, v3.80

What's New in dbForge Schema Compare for SQL Server, v3.00

What's New in dbForge Schema Compare for SQL Server, v.2.00

What's New in dbForge Schema Compare for SQL Server, v.1.50

What's New in dbForge Schema Compare for SQL Server, v.1.10

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Getting Started


What's New in dbForge Schema Compare for SQL Server v4.3

New comparison and synchronization options

A bunch of new options was added to make the comparison and synchronization process even more customizable.

Comparing and synchronizing memory-optimized table types

Memory-optimized table variables have a number of advantages over traditional table variables. The option of comparing and synchronizing data in memory-optimized tables has been implemented in dbForge Data Compare for SQL Server.

Command Line Interface for scripts folder

You can create and compare scripts folders with another data sources in Schema Compare for SQL Server using the command line interface.

Creating new database in Schema Comparison wizard

In the New Schema Comparison wizard, when choosing source and target databases you can also create a new database which can be then selected for comparison.

Comparison reports extended functionality

Now you have the ability to quickly generate comparison reports in XML and XML for Excel formats.

Comparing and synchronizing Security Policy objects

Compare, view, and analyze a new type of database objects - security policies.

Specific exit codes are added

Specific exit codes will indicate an error when a task you're running in the command line interface fails and will make troubleshooting more straightforward.

Other improvements

· Trial Product Activation implemented
· Application visual style greatly improved
· FIPS compliance
· Azure Active Directory authentication


What's New in dbForge Schema Compare for SQL Server, v4.2

Support for MS SQL Server 2016 and its backup

dbForge Data Compare for SQL Server now supports the new functionality of SQL Server 2016. Specifically, supported are:

· Query Store providing performance-tuning capabilities allowing you to monitor queries, query plans, runtime statistics, and more;
· Database Scoped Configuration allowing to configure the behavior of the application code at the database level.

Database Scoped Configuration supported

This feature gives you the ability to configure certain database parameters at the database level that before was only possible at a server level.

Improved synchronization logging

On the command line, the /log argument now sends the results of schema synchronization to a log file. Specifically, all errors and informational messages during the command line schema synchronization process are recorded to the file.

DROP IF EXISTS is used instead of DROP on MS SQL Server 2016

This command greatly simplifies routine operations and minimizes written code. What is more, if the object doesn’t exist, you will not get any error and the execution will continue.

Integration into Microsoft Management Studio for SQL Server 2016 supported

dbForge Schema Compare for SQL Server seamlessly integrates into Microsoft SQL Server Management Studio 2016, so you can compare and synchronize SQL databases directly from the most recent SSMS version available.

Command-line client support for Version Control

This feature lets you automate source control operations for any source control system. A preset config file is provided for Plastic SCM and Mercurial (example). You can create your own config file using the Command Line Interacting option.

Synchronization options added

· Use DROP and CREATE instead of ALTER
· Add error handling statements to synchronization script
· COMPRESS BACKUP
· Add WITH ENCRYPTION
· BACKUP TYPE
· Transaction Isolation Level

New comparison options

Many new options were added to the schema comparison wizard so you can customize a comparison process to meet your specific needs.

· Ignore user DEFAULT_LANGUAGE
· Ignore Database Extended Properties
· Ignore replication triggers
· Ignore Replicated Tables
· Ignore users' permissions and role memberships
· Ignore replication procedures
· Ignore replication role
· Ignore replication schema
· Ignore INSTEAD OF triggers
· Ignore database and server name in synonyms
· Ignore Constraint System Names
· Ignore DML and INSTEAD OF triggers present only in Target
· Ignore indexes present only in Target
· Ignore tSQLt Framework And Tests
· Ignore sequences properties
· Ignore next filegroups in partition schemes
· Ignore Triggers State
· Ignore Bound rules and defaults
· Ignore WITH NOCHECK state on constraint
· Ignore Foreign keys actions ON UPDATE and ON DELETE
· Ignore NOT NULL Constraint
· Convert UDTs into SQL Server basic datetypes
· Ignore Table LOCK_ESCLATION
· Ignore WITH ENCRYPTION
· Ignore Semicolons
· Ignore spaces in object names
· Ignore object names in definitions
· Associate column names having similar name options, %
· Ignore Synchronization Script for Databases


What's New in dbForge Schema Compare for SQL Server, v4.1

SSMS Integration Support

· SQL Server Management Studio integration enables starting the schema comparison directly from SSMS

Database script folder

· Database script folder creation and comparison
· Comparison with database script folder in version control

Support for all popular version control systems:

· Subversion (SVN)
· Team Foundation Server (including TFS Cloud)
· Perforce (P4)
· Mercurial (Hg)
· SourceGear Vault

User Interface

· Redesigned Comparison Document UI

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Editions


What's New in dbForge Schema Compare for SQL Server, v4.0

Compatibility

· Windows 10 support

Schema Comparison

· Custom mapping for tables
· Updated Synchronization wizard
· Zooming font size in Text Comparer
· Option for update metadata for the specified non-schema-bound view

SQL Editing and Execution

· Command-line interface for SQL formatting
· Query execution pane
· Easy way to hide data results
· Encoding switch in the /execute command-line operation
· Updated Find&Replace feature for documents and files

Generate Script

· SQL Azure support

Data Editor

· Data Viewer, LOB Editor, and Redirect Data to Output are combined in a single control
· Zooming font size in Data Viewer and Editor Window

User Interface

· Support of multiple monitors
· New skins
· Create Schema Snapshot wizard window works in modeless mode

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Schema Compare for SQL Server, v3.80


What's New in dbForge Schema Compare for SQL Server, v3.80

SQL Server 2014 is supported

Generate Schema Script

· Saving the options setting for future use
· Support of command line interface
· Automatic archiving of schema export scripts
· Writing a report about the process into a log file
· Automatic removing old files based on date or quantity

Code Completion

Schema Compare

· Columnstore index is supported
· Check for object existence option is added to the synchronization wizard
· Ignore column order in indexes option is added
· ALTER SCHEMA feature for objects transferring between the schemas is supported
· Include print comments option is added
· Exclude comments option is added

SQL Profiler

· Query plans can be saved visually
· Results comparison is executed when the required elements are selected
· Various queries plans can be shown vertically in one view when comparing
· Buffer and plans cache refresh options are added
· Zoom menu in the Profiler diagram is available

User Interface

· Switching tabs by the CTRL+ALT+PAGE UP and CTRL+ALT+PAGE DOWN keys combination
· SSMS shortcut schema availability

Other Features and Improvements

· Coloring a database connection according to the document category is possible now
· Database connection properties are expanded
· SET connection options in query execution are added
· Possibility to switch from the wizard page to the main application window is added
· SQL document zooming by holding the CTRL key and rotating the mouse wheel is added
· Restoring the documents opened in the last session is possible now

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Schema Compare for SQL Server, v3.00


What's New in dbForge Schema Compare for SQL Server, v3.00

SQL Server 2012 Support

· Support for comparison and synchronization of new SQL Server objects:
· SEQUENCE
· SEARCH PROPERTY LIST
· FILETABLE
· User accounts synchronization is extended:
· Ability to create a user account with password is added
· DEFAULT_LANGUAGE setting is added
· Ability to create a user account using Windows Principal is added
· New properties for SPATIAL INDEX and FULL TEXT INDEX are supported
· Synchronization of new database properties is added

SQL Azure Support

The new version of Schema Compare for SQL Server makes development and maintenance of databases on SQL Azure services easier and more convenient. Now you can establish a connection with a remote server and perform comparison and synchronization of data schema with your remote server as easily as with a local network server.

New Synchronization Features

· Manual resolving of conflicts on creating NOT NULL restrictions functionality is added
· 'Add constraints and keys to tables using NOCHECK' synchronization option is added
· 'Ignore user DEFAULT_SCHEMA' option is added
· Ability to synchronize assemblies through files on disks is added
· Checking if the USE command was executed correctly is added to synchronization script
· Ability to load synchronization script to SQL Server Management Studio is added
· Information on database properties that can be synchronized shown in Action Plan is extended - now it contains a record on each parameter that can be changed
· Synchronization of changes made to Service Broker for Queue (for SQL Server 2008 R2) is added

UI Improvements

· Ability to search Action Plan is added
· Search in comparison options and comparison document is improved - on entering values into the search field, search results are highlighted
· Description field for options in the comparison and synchronization wizards is added
· Product start page improved

Other Improvements

· Ability to generate snapshots from the command line is added
· Connection timeout property is added to the connection settings

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Schema Compare for SQL Server, v.2.00


What's New in dbForge Schema Compare for SQL Server, v2.00

Support of native SQL Server backups

The users can use native SQL Server backups as a metadata source and compare them. It adds a new way to compare and update database structures without manual work.

Database comparison and synchronization via command line

This is especially useful for the users, who do repeated schema comparison and synchronization. It is enough to set a comparison once and the tool will prepare a file with required command line arguments - Source and Target connection strings, comparison options and settings. The users can schedule the launch time for the processes specified in the file and escape any waiting.

Tracking database changes using version control systems

This prevents several developers from changing database objects simultaneously. Now it is easy to revert to earlier revisions and quickly identify who and when changed the objects. Comparison takes less time as schema snapshots are compared. dbForge Schema Compare uses two most popular version control systems — SVN and TFS.

Generating comparison and synchronization reports

Now publishing differences between databases is automated and offered as clear and professionally looking reports.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Schema Compare for SQL Server, v.1.50


What's New in dbForge Schema Compare for SQL Server, v1.50

Table data verification after synchronization

dbForge Schema Compare for SQL Server 1.50 moves forward in delivering safe synchronization. The present-day market, saturated with all sorts of speedy over-featured tools for schema comparison and synchronization, leaves many developers insecure while managing their schemas. This proves that capability to synchronize any types of schemas does not always guarantee the correct results, and speed is nothing if any data is lost.

Following best practices in database synchronization, dbForge Schema Compare for SQL Server 1.50 checks table data after synchronization and notifies if any data loss has happened. This approach eliminates stumbling blocks on the table modification path giving more control and safety. With data verification capability developers can be sure that table changes as common as table recreation or changing data types in table columns are protected with timely detection of any data losses.

The full comparison and synchronization - all database objects are supported

The latest version of dbForge Schema Compare for SQL Server can compare and synchronize all database objects in SQL Server 2000, 2005, and 2008 databases preserving high performance and safety. The expanded object support facilitates cross-version comparison and exempts developers from limitations based on the list of supported objects.

Support of schema snapshots

One more major novelty in dbForge Schema Compare for SQL Server 1.50 is capability to make schema snapshots and compare them with each other or with a live database. Snapshots open up possibilities to develop databases without a direct connection to SQL Servers saving time and traffic. In addition, snapshots greatly contribute to version control of databases, producing a simple way for any member of the development team to compare and analyze the changes made to the database.

ExpandedToggleIcon(9x12) See Also

Previous Releases

What's New in dbForge Schema Compare for SQL Server, v.1.10


What's New in dbForge Schema Compare for SQL Server, v1.10

Faster comparison of database objects

The tests proved that dbForge Schema Compare for SQL Server 1.10 compares databases twice faster than the previous version did. This improvement is of great value especially for comparison of large databases.

For example, Schema Compare for SQL Server 1.10 compared databases located on SQL Server 2008 and containing 958 tables, 60 views, 3736 stored procedures, and 469 functions in 1:24 min that is 1:56 min faster than comparison with the previous version.

Synchronization of object permissions

Now permissions granted on a specific object can be compared and synchronized along with the object itself.

RULE and DEFAULT support

SQL Server RULE and DEFAULT objects can be compared and synchronized now.

Improved table synchronization

Special processing in table synchronization wad added to prevent data loss in several cases.

ExpandedToggleIcon(9x12) See Also

Previous Releases

Welcome to Schema Compare for SQL Server


Getting Started

In this section you will find basic How To topics that help you getting started with dbForge Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) In This Section

dbForge Schema Compare for SQL Server Start Page
This topic describes the basic functionality provided by dbForge Schema Compare for SQL Server.

Installation Guide
This topic describes gives overview of the install/uninstall processes.

Activating dbForge Schema Compare for SQL Server
This topic describes how to activate the product.

How To: Connect to a Database
This topic explains how to create a new server connection.

How To: Manage Database Connections
This topic explains how to manage database connections through the Database Explorer window.

Comparing Database Schemas in MS SSMS
This topic describes how to start comparing database schemas in MS SSMS.

How To: Quickly Synchronize Two Schemas
This topic explains how to perform simple database schema comparison and synchronization.

How To: Save and Load Schema Comparison
This topic explains how to save and load schema comparison document.


dbForge Schema Compare for SQL Server Start Page

The goal of the start page is to provide a location, available when the product first started, for the user to find out about dbForge Schema Compare for SQL Server functionality. We also added some other features to this start page such as the ability to navigate to the product support page, blog, feedback page, etc. The Start page uses a multi-tab model that provides the relevant features and tools in a specific tab.

To access the Start page, in the View menu click Other Windows, and then click Start Page.

Section | Tool | Description
Quick Links | Help | Opens the built-in help file where you will find how to perform basic and advanced tasks in dbForge Schema Compare for SQL Server. It gives you necessary information to get started with the application and broaden your database administration skills when you are familiar with simple tasks.
 | Product Support Page | On the support page you can find answers to any questions you may have about using dbForge Schema Compare for SQL Server and provide comments and suggestions about the product.
 | Blog | Opens the Devart blog which contains a variety of technical articles on every product and theme.
 | Forum | Participate in the discussion forum of dbForge for SQL Server product line. Get answers to your technical questions and find more valuable information about dbForge Schema Compare for SQL Server and other products' advantages.
 | Devart website | Opens the Devart company website.
 | Product Feedback Page | We are striving to build a set of tools that simplify SQL interaction and enhance opportunities for developers, DBAs, and other people dealing with databases. We are interested in how well dbForge Schema Compare for SQL Server works for you and what features you want to see added.
 | Recent Projects | The section displays recently opened projects. Click a required project name link to open it.
new-schema-comparison | New Schema Comparison | Click the icon to open the Schema Comparison Wizard and start comparing the data immediately.
open-schema-comparison | Open Schema Comparison | Click the icon to choose a file path to an already existing comparison document and open it.
generate-scripts | Generate Scripts | Click the icon to open the Create Scripts wizard to to create scripts to transfer a database between instances of the SQL Server.
 | Create Schema Snapshot | Click the icon to open the Create Schema Snapshot dialog box to generate a snapshot file of your database structure.
 | Create Scripts Folder | Click to generate a folder that contains scripts of a database with help of the Create Scripts Folder or Snapshot dialog box.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Connect to a Database


Installation Guide

This section describes how to install and uninstall Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) In This Section

How To: Install dbForge Schema Compare for SQL Server
Describes how to install the application.

How To: Uninstall dbForge Schema Compare for SQL Server
Describes how to uninstall the application.


How To: Install dbForge Schema Compare for SQL Server

This topic describes how to install Schema Compare for SQL Server on Windows OS with the help of Devart dbForge Schema Compare for SQL Server Setup Wizard.

To Install Schema Compare for SQL Server

1. Run schemacomparesql.exe to begin installation.
2. On the Welcome to dbForge Schema Compare for SQL Server page, click Install.
3. On the Select Destination page, select the directory where dbForge Schema Compare for SQL Server will be installed. To change the default directory, click Browse. To restore the default directory, click Restore default location. Optionally, click the License Terms link to learn End-User Agreement for dbForge Schema Compare for SQL Server. If you agree to the Devart dbForge Schema Compare for SQL Server License Terms, click Next.
4. Optionally, on the Shortcuts page, select the additional shortcuts you would like the Setup Wizard to create while installing. There are two options available: Create a desktop icon and Add a shortcut to the start menu. Click Next.
5. On the Add-In page, select product or products which dbForge Schema Compare for SQL Server should be installed for as an add-in. Click Next.
6. On the File Associations page, select the document types and file extensions that will be associated with this application when it is installed on your computer. Click Next.
7. On the Startup Optimization page, select the option that fits your needs best. Click Next.
8. Optionally, on the Installing page, you can interrupt the installation by clicking the Cancel button.
9. On the final page, click Finish to exit Setup wizard. Optionally, you can select the Launch "dbForge Schema Compare for SQL Server" option to start the application immediately after installation.

ExpandedToggleIcon(9x12) See Also

Installation Guide

How To: Uninstall dbForge Schema Compare for SQL Server


How To: Uninstall dbForge Schema Compare for SQL Server

This topic describes how to uninstall dbForge Schema Compare for SQL Server from Windows OS.

To uninstall dbForge Schema Compare for SQL Server

1. To begin the uninstall, go to Control Panel and then Programs and Features.
2. Right click Devart dbForge Schema Compare for SQL Server and select Uninstall.
3. The Uninstall dialog box appears. Click Yes, if you are sure you want to uninstall the application. This starts the Devart dbForge Schema Compare for SQL Server Uninstaller.
4. Optionally, on the Uninstall options page, you can specify the following additional options and then click Uninstall.
· Registry options
· Connection list
· Configuration files
· Format profiles
· Scripts
5. Optionally, select the Go to the product feedback page after uninstall option to leave a feedback about the application.
6. Click Uninstall to proceed with the uninstall.
7. If the uninstall is successful, the dialog box confirming that the application was successfully removed appears. Click OK to exit the uninstaller.

ExpandedToggleIcon(9x12) See Also

Installation Guide

How To: Connect to a Database


Activating dbForge Schema Compare for SQL Server

Unless activated, dbForge Schema Compare for SQL Server works on the trial basis for 30 days. When this time period expires, dbForge Schema Compare for SQL Server must be activated with the purchased activation key.

dbForge Schema Compare for SQL Server can be activated either online, or offline.

Online activation

This activation method requires an active Internet connection.

To activate dbForge Schema Compare for SQL Server online:

1. If you have not purchased dbForge Schema Compare for SQL Server, click Buy Now... on the pop-up window that appears at the start of dbForge Schema Compare for SQL Server. If you already have your activation key, click Activate...
Alternatively, click Activate Product on the Help menu.

2. The Activation window opens. Copy your activation key from the e-mail that was sent to you after your purchase, and paste it into the edit box.
The activation key looks like a long sequence of letters and digits.

note Note

If you do not see the e-mail with the activation key, be advised to check your Junk/ Spam/Bulk folders.

You can always retrieve your activation key at your Customer Portal page.

3. Click Activate.

Offline activation

Offline activation allows activating dbForge Schema Compare for SQL Server right at the Devart web site. This activation method helps activating the product when the online activation fails.

To activate dbForge Schema Compare for SQL Server offline:

1. Click the Manual Activation button on the Activation window. It opens when online activation fails.

2. Copy the activation request text with the Copy to Clipboard button, or save it to a text file with the Save to File... button.

3. Open the Manual Product Activation page of the Devart web site, and paste the copied text in the text box. Click Download license. The license file with the .lic extension is downloaded to your computer.

4. Return back to the Activation window of dbForge Schema Compare for SQL Server and click the Load license... button. Specify the location of the downloaded .lic file and click Open.


How To: Connect to a Database

Before you can connect to a database, you must create a server connection.

To create a connection:

1. On the Database menu, click New Connection. The Database Connection Properties dialog box opens.
2. In the Server combo box, click <Browse...>. The Browse for Servers window opens.
3. On the Local Servers tab, select an SQL Server instance (if any). Otherwise, click the Network Servers tab to select an SQL Server instance in the network.
4. Select the Authentication type, either SQL Server authentication or Windows authentication.
5. Enter the login credentials in the User and Password fields.
6. In Database, type or click the name of the database which you want to connect to.
7. In the Connection Name text box, the connection name should be generated automatically from the host name. You can create a distinctive name for your new connection.
8. (optional) You can assign a document category to the new connection.
9. (optional) You can click Advanced to configure advanced connection properties.
10. (optional) Click the Test Connection button to verify the connection.
11. Click OK to create the connection.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Manage Database Connections


How To: Manage Database Connections

dbForge Schema Compare for SQL Server offers you visual, quick, and simple way to manage database connections through the Database Explorer window.

By default, the Database Explorer window opens when you start dbForge Schema Compare for SQL Server. To open the window manually, in the View menu, click Database Explorer. Alternatively, you can press: CTRL+W, L.

database-explorer-sqlserver

By default, Database Explorer displays recently used database connections. The list of available connections is empty, while opening the Database Explorer window for the first time.

note Note

The Database Explorer window and Properties window are not available in the dbForge Data Compare for SQL Server, dbForge Schema Compare for SQL Server products.

Use this window to open data connections and to log on to servers and explore their databases and system services.

Create a database connection

1. Open the Database Connection Properties dialog box:
· Click the [image] New Connection button on the Database Explorer toolbar.

or

· Right-click in the Database Explorer window and select New Connection from the shortcut menu.

2. Set up connection parameters.

Top-level node [image] that lists any data connections added by a user to the server. Beneath this node the diagrams, tables, views, stored procedures, and functions for each connection are listed.

Windows connection coloring

Window connection coloring allows you immediately know to which server you're connected to. You can add coloring for each server connection.

Open a database connection

Double-click a connection in the Database Explorer. The connection icon will be changed to [image] and the connection node will open to show database objects of the database assigned to the connection.

Close a database connection

Right-click a connection in the Database Explorer and select Close. The connection icon will be changed to CloseConnectionDatabaseExplorer to indicate the close.

Edit a database connection

Right-click a connection in the Database Explorer and select Modify Connection. The Database Connection Properties dialog box opens enabling you to edit the parameters.

Duplicate a database connection

Right-click a connection in Database Explorer and select Duplicate Connection. A copy of the connection will appear in the Database Explorer window.

Delete a database connection

Right-click a connection in the Database Explorer and select Delete. The message appears asking "Are you sure you want to remove database connection 'name'?". Click Yes to drop the connection. Click No to cancel dropping.

View a database connection information

Right-click a connection in the Database Explorer and select Properties. The Properties window opens displaying the connection properties info.

expandedtoggleicon(9x12) See Also

Getting Started

Comparing Database Schemas in MS SSMS


Comparing Database Schemas in MS SSMS

This topic explains how to start comparing database schemas in MS SSMS.

ExpandedToggleIcon(9x12) Comparing Schemas

1. In Object Explorer, right-click a database, point to Schema Compare, and then click Set as Source or Set as Target.
2. Depending on your choice in previous step, drag source or target database from Object Explorer to the dbForge Schema Compare for SQL Server window.
3. Click the green arrow button to open the dbForge Schema Compare for SQL Server desktop application to proceed with schema comparison and synchronization.

expandedtoggleicon(9x12) See Also

Getting Started

How To: Quickly Synchronize Two Schemas


How To: Quickly Synchronize Two Schemas

This topic explains how to perform simple database schema comparison and synchronization.

ExpandedToggleIcon(9x12) Comparing Schemas

1. On the Start page, click New Schema Comparison. The Schema Comparison wizard opens.
2. Select the Source and Target connections. (You can edit selected connections or create a new one by either clicking the Edit button or the New button.) To quickly compare schemas, you can click the Compare button immediately after setting databases and skip step 3.
3. To adjust comparison process, set the comparison options.

ExpandedToggleIcon(9x12) Synchronizing Schemas

1. Analyze comparison results, select the database objects you want to synchronize by checking the corresponding check boxes.
2. Select the data to synchronize in the grid with comparison results. (To do this, select check boxes next to tables (or views) in the top grid. You may also select check boxes next to individual records on the Only in Source, Only in Target, and Different Records tabs of the bottom grid).
3. Click the Synch-btn Synchronize button on the Comparison toolbar to open the Schema Synchronization wizard.
4. Select where to output the synchronization script in the wizard and then click the Synchronize button.

ExpandedToggleIcon(9x12) See Also

Getting Started

How To: Save and Load Schema Comparison


How To: Save and Load Schema Comparison

You can save the Schema Comparison document (the one that opens after comparison to show comparison results) for the future usage. The saved file has the '*.scomp' extension and stores schema comparison information, including:

· Source and target settings
· Selected values for comparison options
· Object filters
· Selected values for synchronization options
· Schema mapping settings

It does not contain schema comparison results or object DDL. When the file is opened, schemas are recompared. If target or source can not be found, the New Schema Comparison dialog appears, where you should set source or target options.

ExpandedToggleIcon(9x12) Saving Schema Comparison Document

To save:

· In the File menu, click Save (or Save As).
· Right-click the title of the document and select Save from the menu.
· Click the Save Save button on the toolbar.

ExpandedToggleIcon(9x12) Opening Schema Comparison Document

· Drag it to the dbForge Schema Compare for SQL Server UI.
· Use the Open File button on the Standard toolbar.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results


Database Tasks

This section provides information about the basic tasks related to working with databases.

ExpandedToggleIcon(9x12) In This Section:

Generate Scripts
The topic describes how you can use the Generate Scripts Wizard to create scripts for transferring a database between instances of the SQL Server.

Create Scripts Folder or Snapshot
This topic describes how to create scripts folder or schema snapshot file.


Generate Scripts

You can use the Generate Scripts Wizard to create scripts for transferring a database between instances of the SQL Server. You can generate scripts for a database on an instance of the Database Engine in your local network, or from SQL Database. The generated scripts can be run on another instance of the Database Engine or SQL Database. You can create scripts for an entire database, or limit it to specific objects.

ExpandedToggleIcon(9x12) Generating a Script

1. In the Database menu, point to Tasks, and then click Generate Scripts.
2. On the General page, in the Load a previously saved project section, click Open to select a previously saved *.backup file. If you do not have the project file, go to step 4.
3. In the Connection list box, select an instance of the SQL Server database engine.
4. In the Database list box, select a database.
5. Click "..." next to the Path text box, to select a folder to store schema export.
6. In the Output file name text box, specify a name of the file.
7. Optionally, you can select the Append timestamp to the file name option to add date-time parameters to the file name.
8. Optionally, you can select the Use compression (ZIP) option to compress the script file.
9. On the Script content page, select what do you want to generate. You can also include or exclude specific database objects.
10. On the Options page, specify how you want this wizard to generate scripts. Many different options are available.
11. On the Error handling page, specify errors processing behavior and logging options.
12. Click Generate.

ExpandedToggleIcon(9x12) Scheduling a Windows Task

1. Start Task Scheduler for Windows.
2. On the Action menu, select Create Basic Task.
3. Provide Name for the new task. Click Next.
4. Select one of the options when you want the task to be started. Click Next.
5. Select time and frequency for starting the task. Click Next.
6. Select Start a Program and click Next.
7. Enter the schemacompare.com file path in the Program/script field. (The default path is C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com)
8. Specify the arguments in the Add arguments field as follows:

/script /connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa" /projectfile:"D:\Scripts\AdventureWorks.backup"
9. Click Next.
10. Check all specified settings once again and, if no changes are required, click Finish. Otherwise, click Back and make the needed changes.

ExpandedToggleIcon(9x12) See Also

Database Tasks

Create Scripts Folder or Snapshot


Create Scripts Folder or Snapshot

This topic describes how to create a scripts folder or a snapshot.

ExpandedToggleIcon(9x12) Creating Scripts Folder

A scripts folder is a set of scripts that represent a database schema. The scripts folder can be used for:

· Version-controlling databases.
· Comparing database schemas.

To create a new scripts folder:

1. On the Database menu, point to Tasks, and then click Create Scripts Folder or Snapshot. The Create Scripts Folder or Snapshot dialog box opens.
2. Select Source for the scripts folder creation. Scripts folder can be created on the basis of a database or a snapshot.
3. Depending on the selected Source type, specify:
· For Database: Connection and Database. Optionally, you can select Decrypt Encrypted Objects to decrypt encrypted objects.
· For Snapshot: path to the required snapshot.
4. In Destination, select Scrips Folder in the Type field.
5. Specify Path to store the scripts folder.
6. Click Create.

To create a scrips folder with help of command line:

1. Click Start, type 'cmd' in the Search programs and files text box, and press ENTER. The Command Prompt opens.
2. Specify the operation you want to perform and the required parameters and arguments (actions you want to run) in the Command Prompt, for example as follows:

schemacompare.com /scriptsfolder [/switch1[:value | [parameter1:value parameter2:value ..]] /switch2 ..]

3. Press ENTER to run the process.
4. Select corresponding command line switches to perform the required operations:
Argument | Action and Usage
/connection | This switch is used to specify a connection string. The command line looks like: /connection:<connection_string>
/database | This switch is used to specify a database to create a script folder to. Command usage looks like: /database:<database_name>
/decrypt | This switch is used to define if source objects should be decrypted during describing. To enable the option, specify any of the following values: Yes, Y, On, True, T. To disable the option, specify any of the following values: No, N, Off, False, F. The command line looks like: /decrypt:<value>
/password | This switch is used to specify the server password. The switch overrides the password specified in the connection string. The command line looks like: /password:<pw>
/path | This switch is used to specify the script folder path. The command line looks like: /path:<folder_path>

ExpandedToggleIcon(9x12) Creating Snapshot

Snapshot is a file that contains information about a database structure in XML format.

To create a new snapshot:

1. On the Database menu, point to Tasks, and then click Create Scripts Folder or Snapshot. The Create Scripts Folder or Snapshot dialog box opens.
2. Select Source for the snapshot creation. Snapshot can be created on the basis of a database or a scripts folder.
3. Depending on the selected Source type, specify:
· For Database: Connection and required Database. Optionally, select Decrypt Encrypted Objects if you want encrypted objects be decrypted.
· For Scripts Folder: path to the required scripts folder.
4. In Destination, select Snapshot in the Type field.
5. Specify Path to store the snapshot file.
6. Optionally, you can select the Compress check box to archive the created file.
7. Click Create.

To create a new snapshot with help of command line:

You can automate creation of target database snapshots using the command line.

To create a snapshot of target database through the command line, do the following:

1. Open Command Prompt by pressing Win+R, and typing 'cmd' in the Open line.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
2. Type a path to the datacompare.com file, located in dbForge Schema Compare for SQL Server installation folder on your PC, and press the SPACE bar.

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com"

3. Specify the action you want to perform:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot

4. Specify the connection string and schemas:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /snapshot /connection:"User Id=hr;Server=SQL;Unicode=True" /s:"SH,SH"

5. Press ENTER to run the process.

Tip: To see a quick help on the switches available for the /snapshot operation, type the following:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /?

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select a corresponding command line switch to perform a required operation:

Argument | Action and Usage
/alias | Use the switch to define a version control alias. Command usage looks like: /alias:<value>
/comment | Use the switch to write a comment. Command usage looks like: /comment:<value>
/compress | Use the switch to apply compression to a snapshot file. Command usage looks like: /compression:<value> To turn this option on, type Yes, Y, On, True, T. To turn this option off, type No, N, Off, False, F.
/connection | Use the switch to specify a full connection string with additional parameters. This argument is required. Command usage looks like: /connection:<connection_string>
/database | Use the switch to specify a target database name. Define this argument to override the database specified in the connection string. Command usage looks like: /database:<database_name>
/file | Use the switch to specify a file name and its path to save a created snapshot file. Command usage looks like: /file:<file_path> If a path is not specified, a snapshot file will be saved to a current directory.
/password | Use the switch to specify a server password. Define this argument to override the password specified in the connection string. Command usage looks like: /password:<pw>

Command line used to make a snapshot of a schema may look like:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /connection:"User Id=hr;Server=SQL;Unicode=True;" /password:my_pass /schema:"HR" /file:"result.snap"

If you connect to the server in the Direct mode, the connection parameters will differ and the command line used to make a snapshot of a schema will look like:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /connection:"User Id=hr;Server=dbSQL;Connect Mode=SysDba;Unicode=True;Direct=True;Service Name=SQL" /password:my_pass /schema:"HR" /file:"result.snap"

ExpandedToggleIcon(9x12) See Also

Database Tasks


Managing Comparison Results

This section tells how to view and manage schema differences the best way.

ExpandedToggleIcon(9x12) In This Section

How To: Group and Filter Comparison Results
Describes how to group and filter comparison results by various criteria.

How To: Compare Objects' DDL
Tells how to compare DDL of two corresponding database objects.

How To: Preview Schema Synchronization Script
Teaches how to preview the synchronization script for any compared object.

How To: Generate Comparison Report
Tells how to generate a report after schema comparison is completed.


How To: Group and Filter Comparison Results

This topic explains how to group and filter comparison results in the result grid.

ExpandedToggleIcon(9x12) Grouping

Schema comparison results can be grouped either by schema object type or by operation (as shown in the screenshot). To change grouping, right-click in the document grid and select Object Type or Operation in the Group By submenu of the shortcut menu. By default, comparison results are always grouped by one of these items.

note Note

Appearance of this window may vary depending on the product.

ExpandedToggleIcon(9x12) Filtering

Database objects can be filtered by status. You can select what objects to show: Different, Equal, Only in Source, Only in Target, Inconsistent, or Unknown. You can also filter objects by action to view excluded or included objects.

To filter objects, on the Compare toolbar click the down arrow near the Filter button and select the corresponding option in the appeared menu. Any select filter criterion becomes framed in the menu to help you quickly identify what criterion is applied. You can select one and then another criterion to apply together, so several criteria can be applied at the same time.

To discard filtering, select All from the menu.

note Note

Appearance of this window may vary depending on the product.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results


How To: Compare Objects' DDL

dbForge Schema Compare for SQL Server allows you to compare DDL of the corresponding objects in the compared schemas.

1. In the Tools menu, click Options.
2. Click Schema Comparison and select General.

You can select one of the following text comparers:

· Internal - it is selected by default.
· Araxis Merge - before selecting this option, check that Araxis Merge 2001 or higher is installed on your PC.
· Custom - you can set and use any other text comparer, which can be used through the command line.

ExpandedToggleIcon(9x12) Using Internal Comparer

If this comparer is selected, under the grid, in the Schema Comparison window, two SQL editors show string and symbol differences of the selected Source and Target schema objects. It is a convenient option, as you can see the object and SQL differences at once without distraction and any inconvenience.

To see SQL differences of compared objects, select required objects in the grid and see the differences in two SQL editors under the grid. The corresponding blocks of text, but with any differences, are connected with lines. Differences in strings are marked with three colors:

· light green is for lines existing in the Source schema but missing in the Target one or for symbols that are different in the Source and Target schemas.
· light red - is for lines existing in the Target schema but missing in the Source one
· light blue - lines existing in the Source and Target schemas, but containing differences in some symbols. These symbols are displayed in the red font and highlighted with the light green color.

Corresponding blocks of text, but with any differences, are connected with lines. If required, you will copy text from the SQL editors and then edit or save it in a new SQL document.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Preview Schema Synchronization Script


How To: Preview Schema Synchronization Script

When analyzing the comparison results, you can select any object and preview the synchronization script for it, which will be generated by dbForge Schema Compare for SQL Server. This option is very convenient as you can check the script and be sure that you will get the correct synchronization and the desired result after it.

To preview the synchronization script:

Select the required object (or several ones) in the grid and do either of these actions:

1. Click the [image] View Schema Update Script button on the Comparison toolbar.
2. Right-click the grid and select the View Schema Update Script option.

By default, the window with the script snippet opens under the SchemaComparison window with the comparison results. You can move the opened window to any place in the dbForge Schema Compare for SQL Server UI.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Generate Comparison Report


How To: Generate Comparison Report

When schema comparison is completed, you can generate a comparison report to keep records of schema changes.

1. In the Comparison menu, click Generate Comparison Report. The Generate Comparison Report dialog will open.
2. Select a report format (HTML, Excel, XML, or XML for Excel), its location and objects you want to report.
3. Click Generate.

comparison-report

Tip: If you want to open the comparison report after generation, select View a report on completion.

ExpandedToggleIcon(9x12) See Also

Managing Comparison Results

How To: Synchronize Schemas


How To: Synchronize Schemas

This topic explains how to synchronize two database schemas.

note Note

Schema synchronization can not be rolled back! It may alter or drop schema objects in your Target schema. It is highly recommended to backup the Target database before synchronization.
1. Review the comparison results and select required objects for synchronization. Clear the check boxes next to the objects you do not want to be synchronized. You can also select an object and then click Exclude Selection in the shortcut menu to exclude one from the synchronization process.
2. Click the [image] View Schema Update Script button on the Comparison toolbar.
3. Click the Synch-btn Synchronize button to open the synchronization wizard. You can select what do you want to do with the synchronization script (either open or save).
4. Click the Synchronize button to close the wizard and complete the synchronization process.
5. Review the sync script, and then execute it by clicking the Execute button on the SQL toolbar.

ExpandedToggleIcon(9x12) See Also

How To: Compare and Synchronize Schemas through Command Line

Advanced Topics


Working with Command Line

This section describes how to automate data comparison and synchronization using the command line.

note Note

The command-line interface is available only in certain editions of Schema Compare for SQL Server. For detailed information on the features availability in the Schema Compare for SQL Server editions, please refer to the Editions topic.

ExpandedToggleIcon(9x12) In This Section

How To: Compare and Synchronize Schemas through Command Line
This chapter explains how to use the command line interface to run comparisons.

Additional /schemacompare Arguments
The topic contains information on command line switches and examples of their usage.

Command Line Options for /schemacompare Operation
Lists the comparison options to use in the command line.

Formatting Code through the Command Line
Learn how to automate code formatting using the command line.

Executing Scripts through the Command Line
Learn how to automate executing the scripts through the command line.

Arguments Used in Command Line
Describes command line switches to perform required operations.


How To: Compare and Synchronize Schemas through Command Line

You can automate schema comparison and synchronization using the command line.

1. Click Start, and type cmd in the Run line. Press ENTER. The Command Prompt opens.
2. Type a path to the schemacompare.com file, located in dbForge Schema Compare for SQL Server installation folder on your PC, and press the SPACE bar.
3. Type all the arguments (actions you want to run) in the Command Prompt. You can do this in three ways:
1) Type all the arguments directly in the Command Prompt, for example:

/schemacompare /source connection:"Data Source=source_name;Integrated Security=False;User ID=user_name;
Password=password;database=database_name" /target connection:"Data Source=tartget_name;
Integrated Security=False;User ID=user_name;Password=password;database=database_name"

2) Specify a path to a previously saved comparison document to use the connection settings along with the comparison settings specified in the document.

/schemacompare /compfile:"D:\file_name.scomp"

3) Type the path to a previously generated file with required command line arguments (see below how to prepare the file), for example:

/argfile:"D:\file_name.txt"

Type additional parameters that are not specified in the file into the Command Prompt, for example:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /argfile:file_name.txt /schemacompare /sync

Tip: To see a quick help on the arguments available in the command line, type the following:

schemacompare.com /?

4. Press ENTER to run the process.

Preparing a file with command line arguments

1. Define what action you want to run, for example:

/schemacompare

2. Define Source and Target connection strings:

/schemacompare /source connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa;
database=AdventureWorks" /target connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;
User ID=sa;database=AdventureWorks"

You can also use the schema comparison document that already contains Source and Target connection strings.

/schemacompare /compfile:"C:\MyComparison.scomp"

3. To generate and save a log file, specify the file name and location. For example:

/log:"C:\Log.log"

4. To generate and save a comparison report file, specify the file name and location. For example:

/report:"C:\Report.html"

5. To synchronize the schemas, i.e., update the Target schema, type the following:

/sync

6. To generate and save a synchronization script, specify the file location and name. For example:

/sync:"C:\sync_script_name.sql"

ExpandedToggleIcon(9x12) See Also

Working with Command Line

Command Line Options for /schemacompare Operation


Additional /schemacompare Arguments

This topic gives detailed description of command line switches and examples of their usage.

ExpandedToggleIcon(9x12) Arguments

To get more information on switches related to schema comparison in the command line interface, you can type:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /?

Below all switches of this option are described, together with usage examples.

Argument

Action and Usage

/backup

/backup[:dir]
If target is a live database: Makes a backup of a target database before the synchronization.
If the backup directory is not specified, the default server's backup directory is used.
If target is a scripts folder: Makes a copy of a target scripts folder before the synchronization. If the copy folder is not specified, the default user's backup directory is used.

/compfile

/compfile:<path>
This switch is used to load command line settings from the comparison project file, *.scomp.

Example of using a file with comparison settings, saved earlier:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /compfile:"D:\workDir\OSC1vsOSC2.scomp"

/groupby

/groupby:<none/status/objecttype>
This switch is used when generating comparison reports. Use it to group objects in such report.

The following example shows how to compare schemas using settings from the file, generate comparison report, and group objects in the report by type:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /report:"report.txt" /reportformat:HTML /groupby:objecttype

/log

/log:<filepath>
Use this switch if you want to generate comparison log file in a specified directory.

The following example shows how to compare schemas using settings from the file and write log to the specified file:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /log:"D:\sync.log

options

You can specify some comparison and synchronization options directly in the command line interface. See the list of available options and learn how to use them in the Command Line Options for /schemacompare Operation topic.

/report and /reportformat

/report:<filepath>

/reportformat:<HTML|XLS|XML|XMLFOREXCEL>
You can generate schema comparison report in .html, .xls, and .xml format. If you specify file format in the output file name in the /report switch, it is not necessary to use the /reportformat switch. Commands usage looks like:

The following example shows how to compare schemas using settings from a file, generate report to the specified file in the HTML format:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /report:"report.txt" /reportformat:HTML

/source

Specifies source with the following options:

server:<name> database:<db> [user:<name>] [password:<pw>]
Connects to a live database by specified parameters. If 'user' is not specified, the system's integrated security is used.

connection:<connection_string>
Allows specifying the full connection string with additional parameters.

snapshot:<filepath>
Loads a database from the specified snapshot file.

backup:<filepath> setid:<GUID>
Loads a database backup from one or several files. To specify multiple backup files, you should specify the "backup:<path>" parameter as many times as many files you have. The "setid" parameter specifies unique backup set.

scriptsfolder:<folderpath>
Loads database objects from the specified scripts folder.

/target

Specifies target with the following options:

server:<name> database:<db> [user:<name>] [password:<pw>]
Connects to a live database by specified parameters. If 'user' is not specified, the system's integrated security is used.

connection:<connection_string>
Allows specifying the full connection string with additional parameters.

snapshot:<filepath>
Loads a database from the specified snapshot file.

backup:<filepath> setid:<GUID>
Loads a database backup from one or several files. To specify multiple backup files, you should specify the "backup:<path>" parameter as many times as many files you have. The "setid" parameter specifies unique backup set.

scriptsfolder:<folderpath>
Loads database objects from the specified scripts folder.

/sync

/sync[:path]
You can perform schema synchronization from the command line interface. If you specify output file for synchronization, only synchronization script will be generated.

The following example shows how to compare schemas using settings from the file saved before, and save synchronization script:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /schemacompare /compfile:"OSC1vsOSC2.scomp" /sync:"D:\compare_result.sql"

ExpandedToggleIcon(9x12) Usage Examples

· Compare databases using settings from a file saved earlier:
/schemacompare /compfile:"D:\workDir\SC1vsSC2.scomp"
· Compare and synchronize schemas using connection through the client. Log will be written to the specified file:
/schemacompare /source server:SqlServer1 user:sa password:sa database:db1 /target server:SqlServer2 user:sa password:sa database:db2 /sync /log:"D:\sync.log"
· Compare specified databases and save the synchronization script to the D:\compare_result.sql file:
/schemacompare /source server:SqlServer1 user:sa password:sa database:db1 /target server:SqlServer2 user:sa password:sa database:db2 /sync:"D:\compare_result.sql"
· Compare and synchronize databases using settings from the file, ignore case and foreign keys during comparison; generate a report to the specified file in the html format:
/schemacompare /compfile:"SC1vsSC2.scomp" /icase:yes /IgnoreForeignKeys:yes /report:"report.txt" /reportformat:HTML /groupby:objecttype /incsettings:T /sync

ExpandedToggleIcon(9x12) See Also

Working with Command Line


Command Line Options for /schemacompare Operation

By default, dbForge Schema Compare for SQL Server generates a file with command line arguments and writes all the comparison and synchronization options into it. Each option is written like the following:

/option_name: [Y/N]

You can edit the file to turn on/off required options. To turn on comparison and synchronization options, edit their values to "Yes", "Y", "True", "T", or "On". To turn off the options, change their values to "No", "N", "False", "F", or "Off".

Each option has a full and short name. You can type either name of a required option into Command Prompt instead of editing the file.

See the list of the options with their full and short command line names below.

Command line option name | Short name | Option
CompareDatabaseProperties | cdbp | Compare database properties
DecryptEncryptedObjects | decrypt | Decrypt encrypted objects
ForceColumnOrder | force | Force column order
IgnoreAuthorization | iauth | Ignore authorization on schema objects
IgnoreBoundRulesDefaults | iboundruldef | Ignore bound rules and defaults
IgnoreCase | icase | Ignore case
IgnoreChangeTracking | itracking | Ignore CHANGE_TRACKING clauses and statements
IgnoreCheckConstraints | icheck | Ignore check constraints
IgnoreClrDataTypesInColumn | icdtc | Ignore CLR datatypes in columns
IgnoreCollations | icollate | Ignore collations
IgnoreComments | icomment | Ignore comments
IgnoreConstraintsNames | icnames | Ignore constraints' names
IgnoreConstraintSystemNames | icsn | Ignore constraints' system names
IgnoreDatabaseExtendedProperties | idbprop | Ignore database extended properties
IgnoreDatabaseInSynonyms | idbsyn | Ignore database and sever names in synonyms
IgnoreDatabaseObjectExtendedProperties | iobjprop | Ignore database object extended properties
IgnoreDataCompression | idatacompression | Ignore DATA COMPRESSION
IgnoreDataTypesInColumn | idtc | Ignore data types in column
IgnoreDDLTriggerState | iddltstate | Ignore state of DDL triggers
IgnoreDefaultCollations | idefcollate | Ignore default column collations
IgnoreDefaultConstraints | idefault | Ignore default constraints
IgnoreDMLTriggerState | idmltstate | Ignore state of DML triggers
IgnoreDropDMLTriggers | idropt | Ignore DML and INSTEAD OF triggers present only in Target
IgnoreDropIndexes | idropi | Ignore indexes present only in Target
IgnoreEventNotificationOnQueues | ievent | Ignore event notification on queues
IgnoreFilegroupsPartitionSchemes | istorage | Ignore filegroups and partitioned schemes/functions
IgnoreForeignKeyActions | ifkacts | Ignore foreign keys actions ON UPDATE and ON DELETE
IgnoreForeignKeys | ifk | Ignore foreign keys
IgnoreFullTextCatalogPath | iftpath | Ignore full-text catalog path
IgnoreFullTextSearch | isearch | Ignore full-text search
IgnoreIdentity | iidentity | Ignore identity on columns
IgnoreIdentitySeedIncrementValues | iseed | Ignore identity seed and increment values
IgnoreIndexColumnsSortOrder | iicso | Ignore sort direction (ASC/DESC) for index columns
IgnoreIndexes | iindex | Ignore indexes
IgnoreIndexesNames | iinames | Ignore indexes names
IgnoreIndexPageAndRowLock | iprlock | Ignore PAGE LOCKS and ROW LOCKS for indexes and constraints
IgnoreInsteadOfTriggers | iotrig | Ignore INSTEAD OF triggers
IgnoreKeywordReduction | ired | Ignore keyword reduction
IgnoreLockEscalation | ils | Ignore LOCK_ESCALATION
IgnoreLogins | ilogin | Ignore logins, certificates, asymmetric keys for users
IgnoreNextFilegroups | inextfg | Ignore next filegroups
IgnoreNocheck | inocheck | Ignore NOCHECK
IgnoreNotForReplication | ireplication | Ignore NOT FOR REPLICATION
IgnoreNotNullConstraints | inotnull | Ignore NOT NULL for a column
IgnoreObjectNamesInDefinitions | ion | Ignore object names in definintions
IgnorePadIndexAndFillfactor | ipiff | Ignore PAD INDEX and FILLFACTOR for indexes and constraints
IgnoreParserErrors | iparsererrors | Ignore parser errors
IgnorePermissions | iperm | Ignore permissions
IgnorePrimaryKeys | ipk | Ignore primary keys
IgnoreQuotedIdentifierAndANSINulls | iquotansi | Ignore QUOTED IDENTIFIERS and ANSI NULLS
IgnoreReplicatedProcedures | irproc | Ignore replication procedures
IgnoreReplicatedRoles | irrole | Ignore replication roles
IgnoreReplicatedSchemas | irschem | Ignore replication schemas
IgnoreReplicatedTables | irept | Ignore replicated tables
IgnoreReplicationTriggers | irtrig | Ignore replication triggers
IgnoreSemicolons | isc | Ignore semicolons
IgnoreSequenceMax | iseqmax | Ignore sequence max value
IgnoreSequenceMin | iseqmin | Ignore sequence min value
IgnoreSequenceStart | iseqstart | Ignore sequence start value
IgnoreSignatures | isign | Ignore signatures
IgnoreStatistics | istat | Ignore statistics
IgnoreStatisticsNorecompute | isnr | Ignore STATISTICS, NORECOMPUTE for indexes and constraints
IgnoreTableDMLTriggers | itdmltrig | Ignode table DML triggers
IgnoreTriggerFireOrder | ifire | Ignore firing order for DDL and DML triggers
IgnoreTSQLtFramework | itsqlt | Ignore tSQLt framework and unit tests
IgnoreUniqueKeys | iuk | Ignore unique keys
IgnoreUserDefaultLanguage | iudeflang | Ignore user DEFAULT_LANGUAGE
IgnoreUserDefaultSchema | iuds | Ignore user DEFAULT SCHEMA
IgnoreUserPermissions | iuperm | Ignore users' permissions
IgnoreWhiteSpace | ispace | Ignore white space
IgnoreWithEncryption | iwenc | Ignore WITH ENCRYPTION
IgnoreWithNocheck | iwnocheck | Ignore WITH NOCHECK state on constraints
IgnoreWithOptionOrder | iwith | Ignore WITH option order
MappingIgnoreSpaces | mispace | Ignore spaces in object names druing mapping and comparing
MappingSimilar | msim | Associate column names having similar name options
PopulateFullTextIndexes | populate | Populate full-text indexes
QuoteObjectNames | quote | Quote object names with square brackets
UserDataTypesToSystem | udttosys | Convert user data types into SQL Server system data types
AddBackupType | addbt | Add backup type
AddingErrorHandling | adderrorhandle | Add error handling statements
AddTransactionIsolationLevel | addtransiso | Set transaction isolation level
AddWithEncryption | addwithencr | Add WITH ENCRYPTION
AddWithNocheck | addnocheck | Add constraints and keys to tables using WITH NOCHECK
BackupExtension | extbackup | Extension for backup file
CheckObjectExistence | cexist | Check for object existence
CommentDdlForKeysCertificates | commentkeys | Comment DDL statements for signatures, certificates, asymmetric and symmetric keys
CreateBackupFolder | cbackupfolder |
BackupType | bt | Backup type
DeployDatabaseInSingleUserMode | depsingl | Synchronize database in the single user mode
DisableDdlTriggers | noddl | Disable DDL triggers during synchronization
DropCreateOnly | dropcreateonly | Use DROP and CREATE instead of ALTER
DropCreateOnlyAssemblies | dropcreateonlya | Use DROP and CREATE instead of ALTER for assemblies
DropCreateOnlyTables | dropcreateonlyt | Use DROP and CREATE instead of ALTER for tables
ExcludeComments | nocomments | Exclude comments
ExcludeDependencies | edep | Exclude dependencies
ExecuteAsSingleTransaction | tran | Execute a synchronization script as a single transaction
IncludePrintComments | iprint | Include print comments in the deployment script
IncludeUseDatabase | inud | Include USE <database_name> clause to the script
NeedCompressBackup | comprbackup | Use compression for backup
RefreshViews | rview | Exclude dependencies from a synchronization script
SynchronizeAsmViaFiles | asmviafiles | Synchronize assemblies via files
UseSchemaTransfer | ust | Use ALTER SCHEMA TRANSFER expression to transfer tables between schemas
VerifyTableData | verify | Verify table data using checksum
IncludeComparisonSettings | incsettings | Includes identical objects into your report
IncludeIdenticalObjects | incident | Includes comparison options into your report. This option is available only for HTML reports.
SelectedObjectsOnly | selobjonly | Includes objects selected for synchronization into your report

ExpandedToggleIcon(9x12) See Also

Working with Command Line


Formatting Code through the Command Line

You can automate code formatting using the command line.

Click Start.

1. Type 'cmd' in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
3. Type a path to the schemacompare.com file located in the dbForge Schema Compare for SQL Server installation folder on your PC, and press the SPACE key.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com

4. Specify the operation you want to perform (code formatting) and the required parameters and arguments:

schemacompare.com /formatsql [/switch1[:value | [parameter1:value parameter2:value ..]] /switch2 ..]

Tip: To see a quick help on the arguments available in the command line, type the following:

/formatsql /?

5. Press ENTER to run the process.

note Note

You can set the unlimited quantity of the required extensions:
schemacompare.com /formatsql /sourcefolder:"c:\" /filextention:*.sql /filextention:*.prg /filextention:*.db1

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select corresponding command line switches to perform the required operations:

Argument | Action and Usage
/connection | This switch is used to specify a connection string. Command usage looks like: /connection:<connection_string>
/filextention | This switch is used to specify the extension of the source folder files that will be formatted. The .sql extension is selected by default. Command usage looks like: /filextention:*.<sql|prc|txt|...>
/log | This switch is used to generate a formatting log file in the specified directory. Command usage looks like: /log:<filepath>
/outputfile | This switch is used to specify the path to an output file where formatting results of the source file will be saved (in this case, the source file is saved without changing). If the parameter is not specified, the formatting results will be saved in the source file. Command usage looks like: /outputfile:<path>
/outputfolder | This switch is used to specify the patch to an output folder where the source folder files with formatting results will be saved (files form the source folder will no be changed). If the parameter is not specified, the formatting results will be saved in the source folder. Command usage looks like: /outputfolder:<path>
/password | This switch is used to specify a server password. It overrides the password specified in the connection string. Command usage looks like: /password:<pw>
/profile | This switch is used to specify the path to a file that contains settings for formatting options. If the parameter is not specified, the default settings will be applied to the formatting options. Command usage looks like: /profile:<path>
/sourcefile | This switch is used to specify the source SQL file to be formatted. Command usage looks like: /sourcefile:<path>
/soucefolder | This switch is used to specify the path to a folder where the files for formatting are located. Command usage looks like: /sourcefolder:<path>
/includesubfolders | This switch is used to include the current directory and all subdirectories in search operation. Command usage looks like: /includesubfolders

ExpandedToggleIcon(9x12) See Also

Executing Scripts through the Command Line


Executing Scripts through the Command Line

You can automate executing the scripts using the command line.

Click Start.

1. Type 'cmd' in the Search programs and files text box and press the ENTER button.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
3. Type a path to the schemacompare.com file located in the dbForge Schema Compare for SQL Server installation folder on your PC, and then press the SPACE key.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com

4. To execute the corresponding script, use the /execute command, and press the SPACE key.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /execute /?

5. Specify connection details of the server where to execute the script.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /execute
/connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa"

6. Specify the script file.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /execute
/connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa" /inputfile:"script.sql"

7. Specify the password.

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /execute
/connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa" /inputfile:"script.sql"
/Password:mypsw

8. To hide the command line window, use the /quiet command. (Useful for batch files).

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /execute
/connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa" /inputfile:"script.sql"
/Password:mypsw /quiet

9. Press ENTER to run the process.

If you use the /argfile argument, all the following commands are specified inside an argfile:

/execute

/connection:"Data Source=DBMSSQL\MSSQL2012;Integrated Security=False;User ID=sa"

/inputfile:"script.sql"

In this case, the command line string will be written as follows:

C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /argfile:myarg.txt

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select corresponding command line switches to perform the required operations:

Argument | Action and Usage
/connection | This switch is used to specify a connection string. Command usage looks like: /connection:<connection_string>
/database | This switch is used to specify a database to execute the script to. Databases specified in the script before will be ignored. It does not affect the objects specified with fully qualified names.
/inputfile | This switch is used to specify an SQL or ZIP file with the script to execute.
/password | This switch is used to specify a server password. It overrides the password specified in the connection string. Command line usage looks like: /password:<pw>
/encoding | This switch is used to specify the encoding which should be applied to open and execute the script. Command line usage looks like: /encoding:<encoding>

ExpandedToggleIcon(9x12) See Also


Arguments Used in Command Line

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select corresponding command line switches to perform the required operations:

Argument | Action and Usage
/connection | This switch is used to specify a connection string. Command usage looks like: /connection:<connection_string>
/database | This switch is used to specify a database to script. It overrides the database specified in the template or in the connection string.
/outputfile | This switch is used to specify a file name for storing the database script. It overrides the file name specified in the template.
/password | This switch is used to specify a server password. It overrides the password specified in the connection string. Command line usage looks like: /password:<pw>
/projectfile | This switch is used to specify a script template to use. Some template options can be overridden by switches.
/execute | This switch is used to execute a script.
/schemacompare | This switch is used to launch schema comparison.
/script | This switch is used to script a database.
/snapshot | This switch is used to make a snapshot of a target schema.
/quiet | This switch is used to hide a console window in the console mode. It should be used after main operation switch.


Advanced Schema Comparison Topics

This section gives advanced information on the schema comparison process and issues that you may encounter.

ExpandedToggleIcon(9x12) In This Section

Schema Comparison and Synchronization Overview
Provides general information on schema comparison and synchronization.

Viewing Schema Differences Overview
Explains how comparison results are presented and how to organize them for better understanding.

Comparing Schemas on Different SQL Server Server Versions
Describes peculiarities of schema comparison on servers with different versions.

Known Schema Comparison Problems
Lists known schema comparison problems.


Schema Comparison and Synchronization Overview

Schema Compare for SQL Server gives you a perfect opportunity to compare and synchronize schemas with many useful features. They include the following:

· Comparing and synchronizing of two schemas.
· Schema comparison separates objects existing only in the Target or Source database, identical objects, and ones having the same name, but with different structure.
· Schema comparison results are displayed in a convenient document, easy for analysis and synchronization.
· Schema comparison is asynchronous. Based on your needs, you can stop the process at any moment.
· Schema comparison includes object description. When any errors occur during description, error notifications are shown. You can either stop or retry comparison, or ignore the errors. In case of fatal errors, schema comparison is automatically stopped.
· You can quickly synchronize the Target schema with the Source one or export a schema synchronization script.

ExpandedToggleIcon(9x12) See Also

Advanced Schemas Comparison Topics

Viewing Schema Differences Overview


Viewing Schema Differences Overview

After comparing schemas, the differences are shown in the Schema Comparison document. In the upper part you will see the names of compared databases and their connections. Source schema objects are displayed in the left part and Target schema objects are in the right one.

ExpandedToggleIcon(9x12) Object status

dbForge Schema Compare for SQL Server automatically sets different statuses for compared objects to help you quickly analyze the differences. Compared objects can have the following statuses:

· Only in Source - schema object exists in source schema and does not exist in target schema.
· Only in Target - schema object exists in target schema and does not exist in source schema.
· Different - schema objects with the same names exist in both schemas, but they have different DDL.
· Equal - identical objects exist in both schemas.
· Inconsistent - objects are different, but target object can not be created or updated due to incompatibility between the source and target SQL Server servers. For example, if source table contains a BIT column and target SQL Server server does not support BIT columns. Table status will be inconsistent.
· Unknown - object metadata cannot be retrieved, so its status is unknown.

note Note

If a Source table has partitioning and a Target SQL Server server does not support partitioning, table comparison status depends on the table structure differences. If the table exists only in Source or has other differences than partitioning, it has Only in Source or Different status and it can be synchronized with Source except for partitioning. If the tables in Source and Target have the same structure except for partitioning, the partitioning is ignored and the table comparison status is Equal.

ExpandedToggleIcon(9x12) Update operation

For each compared object Schema Compare for SQL Server automatically sets the operation in the Operation field to apply after synchronization. Based on your needs, you can change it and select the required one from the drop-down list in the field. The following operations are available:

· None - by default, it is set for identical objects, you can change it to Drop.
· Update - by default, it is set for objects with Different status and means the object will be moved to the Target schema. You can change it to Drop or None.
· Drop - by default, it is set for objects with Only in Target status and means the object will be dropped in the Target schema. You can change it to None.
· Create - by default, it is set for objects with Only in Source status and means the object will be created in the Target schema. You can change it to None.

ExpandedToggleIcon(9x12) Excluding objects from synchronization

If you don't want to synchronize some objects, unselect check boxes for them in the grid.

To exclude several objects from synchronization or include them, highlight these objects in the grid and select the Exclude Selection or Include Selection options from the right-click the menu or press the SPACE key to include/exclude selected objects.

By default all compared objects are included into synchronization.

ExpandedToggleIcon(9x12) Managing comparison results

To refresh schema comparison results, click the Refresh button on the Comparison toolbar.

To better understand comparison results, you can do the following:

· Filter them by comparison status
· Group by comparison status and object type

ExpandedToggleIcon(9x12) See Also

Advanced Schemas Comparison Topics

Comparing and Synchronizing Schemas on Different Server Versions


Comparing and Synchronizing Schemas on Different Server Versions

Comparing and Synchronizing Schemas on Different SQL Server Server Versions

When comparing schemas on different SQL Server servers, some incompatibilities can occur in schema objects. For example, when comparing schemas on SQL Server 3.23 and 5.x. Schema on SQL Server 5.x can have such objects as views, triggers, stored routines that are not supported on 3.23 server. This topic describes how dbForge Schema Compare for SQL Server treats such incompatibilities.

ExpandedToggleIcon(9x12) Not Supported Objects

If source schema contains objects that are not supported on the target SQL Server server, they are not displayed in the Schema Comparison document and are not affected by synchronization.

If target schema contains objects that are not supported on the source SQL Server server, they are displayed in the document. Their default operation is None and they will not be affected by synchronization. You may change their operation to Drop, so the object will be dropped from the target schema.

ExpandedToggleIcon(9x12) Partially Supported Objects

Sometimes there are some incompatibilities even if the type of the database object is supported on both source and target database. For example, tables are supported by both SQL Server 3.23 and SQL Server 5.x, but a table on one server may have a column of a type that is not supported on the other one.

When an object is supported on the source server but is not supported on the target server, it will have Inconsistent status and cannot participate in synchronization. When there is an object in the target that is not supported in the source, but source objects are supported on the target server, target schema can be synchronized and incompatible database objects have Different status.

Here are some examples of such incompatibilities:

· Unsupported column type (for example, SQL Server 3.23 does not support BIT column type).
· Unsupported table engine.
· Unsupported ROW_FORMAT
· Usage of unsupported built-in functions in the DDL.

ExpandedToggleIcon(9x12) Partitioning

Partitioning is treated in another way than other incompatibilities. Let us examine several situations:

· The source and target tables have the same structure except for partitioning. In that case, the target table can be updated. If the target schema supports partitioning, the status is Different, otherwise it is Equal.
· Source partitioned table has another structure than corresponding target table or there are no corresponding target table (having the same name). In that case the table has Different status.

If target schema supports partitioning, partitioned tables are included into schema comparison results, otherwise they are ignored.

ExpandedToggleIcon(9x12) Syntax Incompatibility

In cases when equal schema objects have syntax differences, because they are placed on different server versions, the object DDL is generated according to target object DDL.

ExpandedToggleIcon(9x12) See Also

Advanced Topics

Known Schema Comparison Problems


Known Schema Comparison Problems

When comparing SQL Server schemas you may face some problems caused by SQL Server limitations. Here is the list of widely-known problems:

· If you compare schema on SQL Server 6.0 with another schema on SQL Server 4 or 5.0, and there are tables with TIMESTAMP column, status of such tables will always be different even if they have the same structure or they were synchronized.
· SQL Server does not allow editing tables with EXAMPLE table engine, so synchronization of such tables will fail.
· On the SQL Server 6.0 table, containing VARCHAR column can have ROW_FORMAT = FIXED. On the earlier SQL Server version you may execute ALTER TABLE ... ROW_FORMAT = FIXED but it does not do anything. So, such tables will have Different comparison status even if after their synchronization.

ExpandedToggleIcon(9x12) See Also

Advanced Topics


Working with Data in Data Editor

ExpandedToggleIcon(9x12) In This Section

Viewing Data in Grid
Describes how to use multiple grid editor's features to customize the data display and get more insight.

Editing Data in Grid
Describes how to quickly edit data using various grid editor's features.

Data Shortcut Keys
Lists useful shortcut keys for working with data.


Viewing Data in Grid

This section describes features for viewing data in dbForge Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) In This Section

Viewing Data in Grid Overview
Tells how to efficiently view data in Schema Compare for SQL Server.

Sorting Data in Grid
Tells how to sort data in the grid.

Grouping Data in Grid
Tells how to use data grouping.

Filtering Data in Grid
Tells how to apply various filter conditions to filter data in the grid.

Server-side and Client-side Sorting and Filtering Data in Grid
Explains how sorting and filtering are processed on the client side and on the server side. Gives a list of problems that may be encountered.

Paginal Mode
Teaches how to use paginal mode to limit row count in the grid.

Auto-search Mode
Teaches how to use auto-search mode to quickly locate data.

Card View
Describes how to use card mode for graphical data representation.

ExpandedToggleIcon(9x12) See Also

Working with Data in Data Editor

Editing Data in Grid


Viewing Data in Grid Overview

The Data Editor allows you to view and quickly edit data right in the grid. For more information on editing data refer to topic Editing Data in Grid.

ExpandedToggleIcon(9x12) To Access Data

· Execute a query that returns data.
· Open the table or view editor and switch to the data view.

Use the rich set of data management options in the context menu.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

note Note

If you want to retrieve all data from a table with a large number of records, a message warning you about the possibility of the "Out of memory" exception is shown, and you can choose either of the following actions - continue retrieving data, cancel retrieving data, or turn on Paginal Mode.

To simplify data analysis, you can use the following features:

· Grouping Data in Grid
· Sorting Data in Grid
· Filtering Data in Grid
· Paginal Mode
· Card View
· Auto-search Mode
· Data Viewer

note Note

By default, Paginal Mode is enabled in data view with 1000 records per page, so only 1000 records are displayed at once. For more information, see Paginal Mode.

You can change columns order and width, group by order via dragging column headers into required place. You can fit the column's width to the column content by right-clicking on an appropriate header and choosing Best Fit from context menu. To adjust widths of all columns at once, choose Best Fit (all columns) instead. Note that this operation can take some time when there are many records in the grid.

To refresh data, click the Refresh command in the Data menu (for Data view), the context menu, or on the toolbar. To abort too long refresh operation, click the Stop Refresh command in the Data menu (for Data view) or on the toolbar.

Grid rows' background and foreground colors can be set. You can set them separately for odd and even rows, focused row, selected rows, focused cell, group rows.

Data row can be viewed, edited and printed as cards. To learn more about it, visit the Card View topic.

Schema Compare for SQL Server allows you to view data as text. To retrieve data as text click Redirect Data to Output Window on the SQL toolbar, switch to the Data tab in the Output window and execute the query to get data. You cannot edit data in the Output window.

Tip: you can use down arrow to add an empty row to the table displayed in the grid. If you've added an empty row accidentally, you can easily delete it using the up arrow.

note Note

Null values 0000-00-00 in fields of DATE data type are displayed as 01.01.0001. Null values of TIMESTAMP fields are displayed as 01.01.0001 0:00:00.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Sorting Data in Grid


Sorting Data in Grid

By default, Schema Compare for SQL Server retrieves unsorted data from tables if the Retrieve Data option was used. If data was retrieved after executing an SQL statement, it will be sorted according to the operators used in this statement (in case operators are sorting-related, e. g. ORDER BY).

To sort data

To sort data in grid or to change the sort order, click the header of a column. Alternatively, right-click a column header, and then click Sort Ascending or Sort Descending on the shortcut menu.

To assign a secondary sorting, click another column header, while holding down the SHIFT key. You can set as many sorting columns as you need. To stop sorting on a certain column, click it while holding the CTRL key.

To clear column sorting, click the Clear Sorting option on the table shortcut menu.

The current sort order of a column is indicated by the sort glyph (a small arrow displayed at the column header's right edge). If data is sorted in ascending order, the sort glyph represents an up-arrow. When sorting in descending order, the sort glyph is displayed as a down-arrow. If the column isn't sorted, the sort glyph is hidden.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Grouping Data in Grid


Grouping Data in Grid

To group data by column, click ShowGroupByBox Show Group by Box on the document toolbar. The Group by Box pane will appear above the grid. Drag a column header you want the data to be grouped by to the pane.

Alternatively, right-click the required column header and click Group By This Column on the shortcut menu. The data is automatically displayed in groups marked with collapsed nodes. The column header is moved to the Group By Box pane.

note Note

Actual document look may slightly vary from the above image, depending on the product you use.

Group By Box is the area above the data grid where you can see the grouping order and perform further grouping-related operations. Drag a column header to Group By Box to group the data by that column. You can group the data by multiple columns. In this case the grid will display a tree of nested groups that you can expand by clicking '+' buttons. To collapse the groups, click '-' buttons.

To expand or collapse all groups at once, right-click the Group By Box pane, and then click Full Expand or Full Collapse on the shortcut menu.

To cancel grouping by column, drag-and-drop the column header from the Group By Box pane to the grid or right-click the column header, and then click Ungroup from the shortcut menu.

To remove all groupings, right-click Group By Box, and then click Clear Grouping on the shortcut menu.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Filtering Data in Grid


Filtering Data in Grid

ExpandedToggleIcon(9x12) Hiding Data of a Column

1. Right-click the required column, and then click Visible Columns on the shortcut menu. The Visible Columns dialog box opens.
2. Clear the check box next to the column you want to hide in the grid.
3. Click OK to close the dialog box and apply the filter condition.

ExpandedToggleIcon(9x12) Filtering Data by Column

· On a column header, click the filer-button Filter button. Select the filter value from the drop-down list box. The box includes a set of values encountered in the column and the universal items such as All, Custom, Blanks, and Non Blanks.
· Right-click a column, and point to Quick Filter on the shortcut menu, and then click the required filtering condition.

quickfilter

When the data is filtered, the column Filter button will be changed to active-filter to indicate the applied filter. The filter condition appears at the bottom of the grid providing you a one-click quick access to the filter condition parameters. You can manage them in the following ways:

· To remove all filter conditions, click cancel-filter at the bottom of the grid. To remove the filter condition of a column, right-click this column and click Clear Filter on the shortcut menu.
· To switch from the filtered data to the full data display, clear the [image] check box at the bottom of the grid.
· To edit the filter condition, click edit-filter . The Filter Editor dialog box opens.

ExpandedToggleIcon(9x12) Applying a Custom Filter Condition to Column

1. Right-click the required column, point to Quick Filter on the shortcut menu, and then click [image]. The Filter Editor dialog box opens.
2. Choose a relation type and type values to build a filter.

filtereditor-oracle

Filter conditions in the Filter Editor dialog box are displayed as a tree with condition and group nodes. A group consists of several conditions or subgroups, united with a logical operator. To change a group logical operator, click it and select another one from the menu. To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. To navigate between a condition column, a criteria operator and an operand value, use the LEFT ARROW and RIGHT ARROW keys.

To remove a condition, click FilterGreyDel or navigate to the condition and press the DELETE or MINUS SIGN key. To remove a group, click its logical operator and select the Remove Group from the appeared menu. You can copy, cut, and paste conditions and groups with CTRL+C, CTRL+X, and CTRL+V keys.

3. Click OK to apply the filter condition to the data in the grid.

ExpandedToggleIcon(9x12) Creating a New Filter Condition

1. Create a new group:
· Click the upper-level group operator and select Add Group from the menu.
· Press CTRL+PLUS SIGN.
2. Create a new filter condition by doing one of the following:
· Click the upper-level group operator and select Add Condition from the menu.
· Navigate to a group you want to enhance, and press INSERT or PLUS SIGN key.
· Click FilterGreyAdd of the group you want to enhance.
3. Click the condition column, and then and select the column you need from the menu.
4. Click the condition criteria operator and select the criteria operator you want to apply.
5. If the condition operator requires operand values, specify them.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Server-Side and Client-Side Sorting and Filtering


Server-Side and Client-Side Sorting and Filtering

In Schema Compare for SQL Server, sorting and filtering of data can be performed on the client or on the server side.

If there are not many records in a table, they are all shown in the result grid after retrieving data from a table or after executing a SELECT statement. If you want to sort these records or use a filter, the filtering and sorting procedures are performed on the client side and all available records are processed.

But if there are many records in a table, they are not displayed after executing a SELECT statement or retrieving data at once, because such action can cause hanging of the client machine or some other problems associated with too much data to operate.

The other case when not all records are displayed in the grid, is when Paginal Mode is on and there are more records then the number of records displayed on one page. In these cases, if you perform client-side sorting or filtering, only records available on the client machine are processed. That means you will not get a complete result of filtering or sorting. That's why Schema Compare for SQL Server performs server-side filtering or sorting when not all records can be displayed in the grid.

When server-side filtering or sorting is performed, the application sends a query that is a modification of the starting query to the server. The shortcoming of this way is that server resources are taken, but the benefit is that a user will get a complete result of sorting or filtering.

But once all records are received, for example, after pressing CTRL+END or scrolling to the end, server-side filtering and sorting is turned off and client-side filtering and sorting is used.

Problems that may occur during server-side sorting and filtering:

In some cases the application can not modify the starting query to send it to the server and perform server-side sorting or filtering. These cases are the following:

· There is an expression without alias in a SELECT clause. Actually this is a restriction of MS SQL Server - one cannot modify a query that contains a statement without an alias in a SELECT clause. And if there is no alias for a column, one cannot sort or filter data in other columns as well, until all data is fetched or an alias is given.
· There is a query with an ORDER BY clause. In this case no server-side filtering can be performed, and it is a SQL Server restriction.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Paginal Mode


Paginal Mode

Paginal Mode splits data into pages and is used for displaying data with large number of records.

To enable Paginal Mode, click Paginal Mode.

To configure the number of record per a page, type or select the value from the Page Row Count drop-down list box.

To navigate through pages, use the corresponding buttons on the document toolbar.

Paginal mode toolbar buttons

By default, Paginal Mode is enabled for data views with 1000 records on a page, so only 1000 records are displayed at once. You may change default settings on the Data Editor, General tab of the Options window.

note Note

Paginal Mode can also be enabled by clicking the corresponding button on a message received when retrieving data from a table that has large number of records.

note Note

If not all records are displayed on one page when Paginal mode is on, the warning icon Caution is shown on the status bar. If you move the mouse pointer onto the icon, a notification informing that the data is split into pages will be shown.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Auto-search Mode


Auto-Search Mode

Auto-search mode allows you to search column data.

To enable or disable the Auto-Search mode, do any of the following:

· Press CTRL+I keys.
· On the Data menu, click Auto-search mode.
· Click Auto-search mode on the Data Editor toolbar.

To search for the data, select a cell in a column, and type first letters of the required data. If you made a mistake when typing, press BACKSPACE and type the string again.

To navigate to the next entry, press CTRL+DOWN keys. To return to the previous entry, press CTRL+UP. The entries will be highlighted.

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Card View


Card View

Data Editor allows you to view, edit, and print data in the Card View mode. In the Card View mode, each data row is represented as a card with caption 'Record N' and number.

To enable the Card View mode, click the Switch to Card View button on the Data Editor toolbar. To return the grid view mode, click the Switch to the Grid View button on the Data Editor toolbar.

You can view or edit data in the same way as in the grid mode. Data cards can be expanded and collapsed with help of corresponding button on a caption.

To sort or filter data in the card mode, click the Customize button, and then click either Sort, or Filter next to a column.

To customize the column display in cards, click the Customize button and select or clear check boxes next to the required columns.

Card View

ExpandedToggleIcon(9x12) See Also

Viewing Data in Grid

Editing Data in Grid


Editing Data in Grid

This section describes how to effortlessly edit data in dbForge Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) In This Section

Editing Data in Grid Overview
The topic describes how to quickly edit data using various grid editor's features.

Using Transactions
This topic explains how to use transactions in Schema Compare for SQL Server for data editing. This functionality is not available in Devart Schema and Data Compare tools.

Cached Updates
This topic explains how to use cached updates mode.

ExpandedToggleIcon(9x12) See Also

Working with Data in Data Editor

Data Shortcut Keys


Editing Data in Grid Overview

When dbForge Schema Compare for SQL Server executes any statement returning a result set, the retrieved data is displayed in the Data Editor of the data view of the same SQL document. This topic shows how to edit the data in grid; for information about customizing data grid, as well as sorting, grouping and filtering, visit Viewing Data in Grid topic.

ExpandedToggleIcon(9x12) To insert, delete, copy and paste data:

Use the popup menu or the corresponding buttons under the grid. For example, you can do the following:

· To insert NULL (instead of empty string), select Set Value To ->Null from the popup menu. You can also use the CTRL+0 key combination.
Tip: Use Set Value To menu to quickly set an empty string, zero, or a current date.

· To add a new record, select the Append option from the popup menu or click the Append Append button under the grid. To delete a record from the grid, select the Delete option from the popup menu or click the '-' button under the grid or press CTRL+DEL keys.
· To copy and paste cell values, use the corresponding options from the popup menu.

ExpandedToggleIcon(9x12) To select data:

You can easily select and copy the data just like cells in a spreadsheet. Do either of these actions:

· Move the mouse pointer across the grid holding the left mouse button
· Click the first cell of the data range, press SHIFT, and, holding the SHIFT key, click the last cell. A rectangular range of cells will be selected.

Tip: Using the CTRL key, you may include and exclude cells to selection. Any number of rows may be copied and pasted to some other application, for example, a spreadsheet, but when you paste data in data grid, only the first row will be pasted.

note Note

Actual document look may slightly vary from the above image depending on the product you use.

note Note

Some queries return read only data, for example, queries with aggregate functions (count, avg etc.), or data, retrieved from non-updatable views. Such data can't be edited. It is also impossible to edit the result of executing of the script with several select statements.

ExpandedToggleIcon(9x12) Row and cell indicators

When working with grid, you can see special indicators near to the focused cell. These indicators reflect current editing state.

The row is focused.

The row has been edited.

Incorrect value was entered into a cell. You must either fix the value or press the ESCAPE key to cancel changes made to the cell.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Cached Updates


Using Transactions

Schema Compare for SQL Server allows to control data editing with transactions. You can access the following buttons on the Connection toolbar: Begin Transaction, Commit, and Rollback.

Click on Begin Transaction button on the Connection toolbar or select Begin Transaction from the popup menu of the connection to start a new transaction. Since now all changes you make to a database object are not applied until you click Commit button on the Connection toolbar or select Commit from the popup menu of the connection. To revert all changes and return to the point where you have been at the moment of clicking Begin Transaction button, click on the Rollback button on the Connection toolbar or select Rollback from the the popup menu of the connection.

Commit is automatically issued when you save documents that represent database objects.

The transaction applies to the whole connection. Notice that the Output window reports all transaction events.

note Note

If you are using Devart Schema Compare or Data Compare tools, this functionality is not available.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Cached Updates


Cached Updates

Cached updates mode allows you to control data editing within single database object. For the object you have turned this mode on, updates are stored locally on the client side until you click the Apply Changes button. If you do not need the changes to be applied, click the Cancel Changes button. When you close the document in the cached updates mode, you cancel all changes made since the last Apply command.

ExpandedToggleIcon(9x12) See Also

Editing Data in Grid

Working with Data in Data Editor


Data Shortcut Keys

Use following shortcut key combinations when working with data in the Data Editor or data view of an SQL document.

Icon | Command Name | Shortcut Keys | Action | Where is used
AutoSearch | Auto-search mode | CTRL+I | Data auto-search mode | Data Editor
RefreshButton | Refresh | F5 | Refresh Data view | Data Editor
RefreshButton | Refresh | CTRL+R | Refresh Data view | Data Editor
 |  | CTRL+HOME | Focus on first record in data grid | Data Editor
 |  | CTRL+END | Focus on last record in data grid | Data Editor
 |  | CTRL+DELETE | Delete currently selected row in data grid | Data Editor
 |  | INSERT | Insert new record in data grid | Data Editor
 |  | CTRL+0 | Insert NULL value in current cell | Data Editor

These shortcuts are default shortcuts. All shortcuts can be customized.

ExpandedToggleIcon(9x12) See Also

Working with Data in Data Editor


Writing and Executing SQL Statements

ExpandedToggleIcon(9x12) In This Section

Writing SQL Statements
Basic tips on writing SQL statements ans working with SQL scripts.

Executing SQL Statements
Explains some special features for executing SQL statements.

Viewing Server Messages and Errors
Describes windows designed to display server messages and errors.

Using Parameters
Information on how to use parameters to simplify process of editing the query.

Executing Large Scripts
Tells how to execute a large script without opening it in the editor.

Opening Large Scripts in SQL Editor
Contains information about opening large scripts in the editor.

Associating Windows with Connection
Information on how documents and tool windows use connections.

SQL Document Shortcut Keys
Lists shortcut keys designed to facilitate your work with SQL documents and stored procedures.


Writing SQL Statements

Every SQL document contains the Text view with SQL editor in it. You switch to this view to edit your SQL queries.

When you type text in SQL editor, it automatically recognizes and highlights SQL syntax.

For ease of SQL writing and reviewing, you can also use such supported shortcut keys as: CTRL+PLUS (+) KEY (to zoom the query in), CTRL+MINUS (-) KEY (to zoom the query out), CTRL+0 (to return an SQL document to the one-to-one scale).

You write and execute SQL queries not only one at a time but you may as well compose SQL scripts. SQL scripts consist of multiple SQL statements separated by the appropriate statement delimiter.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Executing SQL Statements


Executing SQL Statements

ExpandedToggleIcon(9x12) How to Run Execution

Entire Script

To execute the entire script, click the Execute button on the SQL toolbar.

Alternatively, on the SQL menu, select the Execute command.

Selected Block of Text

To execute an arbitrary text block:

1. Select the text block using the mouse or keyboard.
2. Run the Execute command as when executing the entire script. Alternatively, select Execute Selection from the shortcut menu of SQL Editor

Current Statement

To execute current statement, click the Execute Current Statement button on the SQL toolbar.

Alternatively, right-click a required statement, and select Execute Current Statement command on the shortcut menu.

Execute to Cursor

To execute script to the current position of the cursor:

1. Move cursor to the required position.
2. Click Execute to Cursor on the shortcut menu or press Ctrl+Shift+F10.

ExpandedToggleIcon(9x12) How to Stop Execution

To stop SQL execution, click Stop Execution the SQL toolbar.

ExpandedToggleIcon(9x12) Representing Query Execution Results

The query execution results can be represented in two ways - in text and in grid formats.

To represent results as text, click Results as Text on the SQL toolbar before query execution.

To represent results as grid, click Results as Grid on the SQL toolbar before query execution.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Viewing Server Messages and Errors

When you run a query against a database server, it returns a response to the client. There are three types of server response to an SQL query:

· Tabular data
· Status (info) message
· Error

Tabular data is displayed in the data editor. Status messages and errors are logged to Output window. Errors are not only logged to Output window they are also shown in Error List window.

ExpandedToggleIcon(9x12) Using Output Window

Following image represents general view of Output window.

note Note

Depending on the product the Output window appearance may vary.

Output Panes

The window can contain up to four output panes (depending on the specific product):

· General pane contains most output messages, not only from a database server but from the application itself.
· Data pane displays query results that are represented as a formatted text. This pane remains empty unless Redirect Data to Output Window option is set in any SQL document.
· SQL Log pane displays all SQL queries executed by an application during the current session. But you need to turn on Write queries sent by the program to SQL Log option to see those queries. This option is located in the following path: Tools -> Options -> Environment -> Output.

As you can see from the above screen-shot, server errors are also logged to Output window. And you can navigate to the place of an error by double-click of from the pop-up menu.

Searching Output Messages

You can search text in Output window. To find specific text:

1. Focus Output window.
2. Open Find and Replace window by pressing CTRL+F.
3. Enter search text and press ENTER or click Search button.

ExpandedToggleIcon(9x12) Using Error List Window

When something goes wrong, typically you see an error. If this is a user or database server error, such as mistyped query, in most cases you will see it in Error List window.

Here is an example of an error displayed in Error List.

Error List shows not only errors, but also warnings and informational messages which require user attention. Warning is in essence a non-blocking error. And informational message is just a user notification.

You can filter messages by type using appropriate buttons on the toolbar of Error List window.

You can navigate to the error position, double-clicking it in the list or select Go to Error from the pop-up menu.

How to View Errors from Current Document Only

Error List aggregates all error messages in the application. And if you have multiple open documents with errors, the error processing can quickly become awkward.

But the window has one more filter button - In Active Document. This button allows to view only those errors that are located in current document window.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Using Parameters


Using Parameters

ExpandedToggleIcon(9x12) What is a Parameter?

Parameter is a placeholder for a variable that contains a value of some type that is passed to a database server along with the SQL text at the query execution time. Also, parameter can hold values returned by a server after query or stored procedure execution.

You can benefit from using of parameters in the following situations:

· When you execute a query multiple times with different input values
· When you debug a query from your application code

ExpandedToggleIcon(9x12) Adding Parameters to a Query Text

Parameters are declared using '@' prefix followed by name of the parameter. Prefix is included to the name of the parameter.

For example:

SELECT
Employee.*
FROM
HumanResources.Employee
WHERE
Employee.Title = @Job AND
Employee.VacationHours <= @Level

@Job and @Level are parameters in this query.

ExpandedToggleIcon(9x12) Modifying Parameter Values and Types

When you run a query that contains parameters with empty values, you will automatically be prompted to initialize them.

To set parameter values and types, select Edit Parameters on the SQL toolbar, or press F8. In the opened Edit Parameters dialog box, set parameters' type, value, and other properties.

note Note

When you execute a query with preset parameter values, you will not be automatically prompted to edit them. To edit parameters, press F8 or select Edit Parameters on the SQL toolbar.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Executing Large Scripts

Schema Compare for SQL Server allows you to execute large scripts without opening SQL Editor and loading the whole script in memory. When you try to open a large script, you will be prompted to execute it with the help of the Execute Script Wizard.

To execute a large script:

1. On the Database menu, click ExecuteLargeScript Execute Large Script.
2. In Connection, select a connection to a required database server against which you want to execute your script.
3. In Database, select a required database from the drop-down list/
4. In File name, specify the path to the script you want to execute.
5. In SQL file encoding, ensure that the file encoding is selected correctly. The program automatically selects it basing on the script. If it fails, the default encoding (the current Windows encoding on the machine where the program is running) is selected. You can always select a required encoding from the drop-down list box.
6. Click Execute to execute the script.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Opening Large Scripts in SQL Editor


Opening Large Scripts in SQL Editor

To avoid performance slowdown, some features are disabled when working with large SQL scripts.

If script size exceeds 10 Mb, the SQL syntax highlight is disabled. It is not enabled when you reduce the script in the editor. You should reopen script to re-enable the feature.

note Note

Maximum file size the application can open depends on available memory on your computer.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


Associating Windows with Connection

When several connection are established, you can execute queries or perform another actions with either of them. SQL documents are associated with a connection which you can see or set on the Connection toolbar. The drop-down list in the toolbar shows what connection is associated with the active document or tool window. If a tool window, that does not require a connection, is active, connection of the active document (or tool window in the document area) is displayed.

When creating or opening a SQL document, it is assigned a default connection. If you create SQL document with no connection, the document will have no connection and you can not execute SQL or retrieve data. You can change connection for SQL document by selecting required connection in the Document Connection box on the Connection toolbar.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

SQL Document Shortcut Keys


SQL Document Shortcut Keys

Use following shortcut keys when working with an SQL document or stored procedure.

Icon | Command Name | Shortcut Keys | Action | Where is used
Execute | Execute | F5 | Execute query associated with current document | SQL editor
PreviousSQL | Previous SQL | Ctrl+Shift+ Up Arrow | Previous SQL statement from history | SQL editor
NextSQL | Next SQL | Ctrl+Shift+ Down Arrow | Next SQL statement from history | SQL editor
History | SQL History | Ctrl+Alt+H | Open SQL History dialog | SQL editor
Parameters | Edit Parameters | Ctrl+Shift+P | Edit parameters | SQL editor
DataAsText | Redirect Data To Output Window | Ctrl+Shift+T | Show data as text in the Output window | SQL editor
Comment | Comment Selection | Ctrl+E, C | Comment selection | SQL Editor
Uncomment | Uncomment Selection | Ctrl+E, U | Uncomment selection | SQL Editor
 | Toggle Outlining Expansion | Ctrl+M, M | Toggle outlining expansion | SQL Editor
 | Toggle All Outlining | Ctrl+M, L | Toggle all outlining | SQL Editor
 | Stop Outlining | Ctrl+M, P | Stop outlining | SQL Editor
 |  | Ctrl+F2 | Switch to Navigation Bar | SQL Editor
 |  | Ctrl+Alt+PgUp | Switch from the current document tab to the previous tab. | SQL Editor
 |  | Ctrl+Alt+PgDown | Switch from the current document tab to the next tab. | SQL Editor

These shortcuts are default shortcuts. All shortcuts can be customized.

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements


User Interface Concepts

expandedtoggleicon(9x12) In This Section

Using Documentation
The topic explains how to use the current manual.

User Interface Elements
This topic provides you with basic information about managing your environment workspace.

Working with Text Editor
This topic explains how to work with the Text Editor.

Customizing Window Layout
This section provides information about window layouts and their customization.

Manipulating Documents
The topic describes how to manipulate documents in Schema Compare for SQL Server.

Customizing Environment
This topic contains information on customizing environment to simplify your work and save time.

Find and Replace Text and Code
This section describes how to use Find and Replace utility.


Using Documentation

The application documentation is available from the official Devart website in the following formats:

· Online
· Offline CHM file (you can download it on the Download section of the product)

There are several ways to navigate through documentation:

· F1 Search
· Search
· Contents

expandedtoggleicon(9x12) F1 Search

F1 provides context help for the active window, dialog box. It always returns no more than one page.

expandedtoggleicon(9x12) Search

Use Search to return all documents that match any specified term or a set of terms.

expandedtoggleicon(9x12) Contents

The table of contents shows all documentation topics in a hierarchical tree view structure and provides a convenient way to browse help. If you opened topic from index or search or from the link and you want to know where this topic is located, use the Locate button or switch to the Contents tab.

expandedtoggleicon(9x12) See Also

Customizing Environments

User Interface Elements


User Interface Elements

This topic provides you basic information about managing your environment workspace. Environment workspace consists of toolbars, tool windows, menus and document area. To personalize menus and toolbars and to adjust their behavior to your needs, point to Toolbars in the View menu, and click Customize.

expandedtoggleicon(9x12) Toolbars

A toolbar is a container for a group of commands or controls that are typically related in their function.

Schema Compare for SQL Server supports dockable toolbars. A dockable toolbar can be attached, or docked, to any side of its parent window, or it can be detached, or floated, in its own mini-frame window. This article explains how to use dockable toolbars in your applications.

Note Note

If you drag a toolbar to the right or left side of the window, toolbar drop-down lists or combo boxes will not be available. For example, if you drag the Connection toolbar to the right or left side of the window, the Connection box will not be available.

expandedtoggleicon(9x12) Menus

The environment has a set of toolbars where reside buttons, using which you can accomplish most frequent tasks. The toolbar you can access depends on kind of document currently active. If it is not visible, right-click on toolbars area and choose one from the shortcut menu.

You can control which toolbars are allowed to appear, and which must be always visible. By default, when you switch between views or documents, corresponding toolbars appear and disappear. When a toolbar is visible, right-click on toolbar area and deselect its item in the shortcut menu to prevent it from showing even if corresponding view is active. If you want to make a toolbar always visible, select it in the shortcut menu, when corresponding document or view is not active. To return a toolbar to its default state select it in the shortcut menu when corresponding document or view is active. You can edit any toolbar, delete, or add your own in Customization dialog box. To open it choose Customize from a toolbar shortcut menu.

expandedtoggleicon(9x12) Document Area

Document area typically displays SQL code or diagrams. Document area size can be manipulated by resizing docked tool windows. To free more space for documents, you can put docked tool windows to auto-hide mode by clicking the pushpin icon on the title bar of the window.

You can arrange documents in tab groups in document area. To create a tab group or move document to another tab group just drag a document to a drop point. Dragging a document to an arrow drop point will create new tab group; dragging it to the tab group central drop point will move the document to this tab group.

Multiple documents can be organized into horizontal or vertical tab groups for organizing a workspace for working with several documents at the same time. New document tab group can be created either by dragging document to the required place or by selecting New Horizontal Tab Group or New Vertical Tab Group from the document header shortcut menu.

Documents can be moved between tab groups by dragging-n-dropping or by selecting required command from the shortcut menu. You can expand a tab group to the whole document area and restore document tab groups' sizes by selecting Prominent from the document header shortcut menu.

expandedtoggleicon(9x12) Switching Between Windows

This section contains information about how to switch between documents and tool windows.

To cycle through open documents, use CTRL+TAB or CTRL+SHIFT+TAB key combinations. Press CTRL+TAB to switch to previously used document. Pressing CTRL+TAB again will return you to current document. Hit TAB key while holding CTRL key to cycle through recent documents stack. You can also use CTRL+SHIFT+TAB combination to browse documents in another direction.

To navigate from the current document tab to the next tab, use CTRL+ALT+PGDOWN key combination. To navigate from the current document tab to the previous tab, use CTRL+ALT+PGUP key combination.

You can also switch between documents in the following ways.

· By clicking document titles.
· By clicking the down arrow near the right upper corner of the document area and selecting document name from the appeared menu.
· By selecting document from the Window menu.
· By selecting document in the Windows dialog and clicking the Activate button.

To activate a tool window, use its shortcut key.

expandedtoggleicon(9x12) Switching to another skin

dbForge Schema Compare for SQL Server provides you several types of a skin. To switch to another skin, on the Tools menu, choose Skin, and then click the skin name you like.

The following skins are available in dbForge Schema Compare for SQL Server:

· Visual Studio 2013 Blue
· Visual Studio 2013 Light
· Visual Studio 2013 Dark
· Visual Studio 2010
· Metropolis
· Metropolis Dark
· Office 2010 Silver
· Office 2010 Blue
· Office 2010 Black
· Office 2013
· Office 2013 Dark Gray
· Office 2013 Light Gray
· Windows 7

expandedtoggleicon(9x12) See Also

Using Documentation

Working with Text Editor


Working with Text Editor

The text editor is the word processor of the Schema Compare for SQL Server. When the text editor is used to edit text, it is referred to as the text editor. When it is used to edit SQL source code, which is its more common use, it is referred to as the code editor. You can open multiple code editors to view or/and edit code. A list of all documents open for editing in instances of the code editor is available on the Windows menu.

To open the Text editor:

1. On the File menu, click New, and then click File. (Alternatively, on the Standard toolbar, click the New File button.)

2. The New File dialog box opens.

3. Select either the Text file or the XML file form the General Files section.

The only difference between XML and text editors is that XML editor provides syntax highlighting for XML code. You can customize XML highlighting and coloring in Fonts and Colors, Text Editor, Options Dialog Box.

expandedtoggleicon(9x12) User Interface

Code pane
The area where code or text is displayed for editing. It provides SQL statement completion.

Indicator margin
A gray column on the left side of the code editor where indicators for breakpoints and bookmarks are displayed. Clicking this area sets a breakpoint on the adjacent line of code.

Selection margin
A column between the indicator margin and the editing window where you can click to select lines of code.

Horizontal and vertical scroll bars
Lets you scroll the code pane horizontally and vertically so that you can view the code that extends beyond the viewable edges of the pane.
expandedtoggleicon(9x12) Text Editor Toolbar

The Text Editor toolbar contains tools related to the code completion features, commenting and uncommenting of code, bookmarks, etc.

Display an Object Member List
Displays a list of valid databases, tables, columns, and other database objects. When a member from the list is selected, you can insert that member into your code by pressing TAB, or by typing a space or period.

Display Parameter Info
This feature opens the Parameters list to give you information about the number, names, and types of parameters required by a function or attribute. The Parameters list also displays parameter information for nested functions. If you type a function as a parameter to another function, the Parameters list displays the parameters for the inner function. Then, when the inner function Parameters list is complete, the Parameters list reverts to displaying the outer function parameters.

To view Parameter Info for functions:

1. After the name of a function, type an open parenthesis as you normally would to open the Parameters list.
2. Schema Compare for SQL Server displays the complete declaration for the function in a pop-up window just under the insertion point. The first parameter in the list appears in bold.
3. As you type the function parameters, the bold changes to reflect the next parameter that you need to enter.
4. Press ESC at any time to close the list, or continue typing until you have completed the function.
5. Typing the closing parenthesis also closes the Parameters list.

Display Quick Info
This option displays the complete declaration for any identifier in your code.

You can manually invoke Quick Info feature as follows:

1. On the Edit menu, click Code Completion, and then click Quick Info.
2. Use the keyboard shortcut CTRL+K, CTRL+I.
3. Select the Quick Info toolbar button from the Text Editor toolbar.

Display Word Completion
Complete word types the rest of a variable, command, or function name once you have entered enough characters to disambiguate the term. Type the first few letters of the name, and then press ALT+RIGHT ARROW or CTRL+SPACEBAR.

Refresh Local Cache
If you are writing a query on a database while someone else is making changes to the structure of that database, the suggestions offered by Schema Compare for SQL Server may become out of date. For instance, if someone has added several tables to a database while you have been connected to that database, these tables will not appear in the suggestions box. To reload the database objects, click Refresh Suggestions. Refreshing suggestions applies only to the database to which you are currently connected.

Reset Suggestions Cache
If you connect to a number of different databases during the same session, Schema Compare for SQL Server will load all the objects for each database as required, without unloading any of the previously stored objects. This means that you can go back to previous queries and continue to see suggestions for any database to which you have previously connected.
Schema Compare for SQL Server loads database objects into its memory whenever you connect to a database, in order to display suggestions from that database. If you connect to several databases with a large number of objects, this may eventually result in running out of memory. To reset the memory at any time, click Reset Suggestion Cache.

Decrease Line Indent
Removes a tab (or the equivalent spaces) from the selected lines or the current line.

Increase Line Indent
Adds a tab (or the equivalent spaces) to the selected lines or the current line.

Comment out the selected lines
Adds comment characters to the selection or the current line.

Uncomment the selected lines
Removes comment characters from the selection or the current line.

Toggle a bookmark on the current line
Adds or removes a bookmark on the selected line of the document in the active Editor. Does not alter the line of code bookmarked.

Move the caret to the previous bookmark
Selects the previous bookmark. When the first bookmark is reached, jumps ahead to the last one.

Move the caret to the next bookmark
Selects the next bookmark. When the last bookmark is reached, jumps back to the first one.

Clear all bookmarks in current document
Removes all the bookmarks in the current document.

Format Document
Automatically formats SQL code in the currently opened document.

expandedtoggleicon(9x12) Selecting text and code

You can quickly select a single word, line of text, or multiple paragraphs while you work with code in the editor. Keyboard shortcuts also let you select text starting from the cursor to any other point in your document.

To select text:

· To select any amount of text, just drag the mouse over the text.
· To select a word, either double-click a word or put your cursor next to word and press CTRL+SHIFT+ either RIGHT ARROW or LEFT ARROW.
· To select a line of text, drag the mouse over a line.
· To select text from the cursor to the start or end of the line, press SHIFT+ either HOME or END.

expandedtoggleicon(9x12) Editing text and code

The Editor allows you to manipulate text in the same ways as most word processing applications or text editors. For example, you can:

· Copy and Paste text or code inside the editor and between several Editors or between the Editor and other text editing applications.
· Put the Code Editor into the overstrike mode using the INSERT key
· Use the DELETE and BACKSPACE keys to remove text or code

expandedtoggleicon(9x12) Navigating text and code

There are various ways to move through text or code in the Code Editor using the mouse and navigation keys:

· Use the arrow keys to move one character at a time, or the arrow keys in combination with the CTRL key to move one word at a time. Arrow keys move one line at a time also.
· Click a location with the mouse.
· Use the scroll bars or scroll wheel on the mouse to move through the code.
· Use the HOME, END, PAGEUP, and PAGEDOWN keys.
· Use CTRL+PAGE UP and CTRL+PAGE DOWN to move the insertion point to the top or bottom of the window, respectively.
· Use CTRL+UP ARROW and CTRL+DOWN ARROW to scroll the view without moving the insertion point.

Go to Line command

Use the Go to Line command to a specific line number:

1. In the General, Text Editor, Options Dialog Box, select the Line Numbers option.
2. With a document open in the Editor, select Go to Line from the Edit menu.
3. Enter the line number you want to move to.

expandedtoggleicon(9x12) Change Text Case in the Editor

You can use menu commands or keyboard shortcuts to convert the case of selected text to all upper case or to all lower case.

To switch text to upper case:

1. Select the text you want to convert.
2. On the Edit menu, select Advanced.
3. To convert text to all upper case, choose Make Uppercase, or press CTRL+SHIFT+U.

To convert text to all lower case, choose Make Lowercase, or press CTRL+U.

expandedtoggleicon(9x12) Setting Bookmarks

As the name suggests, bookmarking accelerate your code navigation in the text editor.

There may be some piece of code where you need to move to very frequently. Generally, you scroll the page and move to that section, but Schema Compare for SQL Server provides great features by which you can move to a particular section very quickly using some shortcut keys. This is called Bookmarking of Code.

You can place a bookmark by clicking on the bookmark icon or use CTRL + B, CTRL + T.

To create or remove a bookmark using the Text Editor toolbar:

1. Open a file in the Editor.
2. Place the insertion point on the line you want to bookmark.
3. Click the Toggle a bookmark on the current line button on the Text toolbar.

To move to a bookmarked line:

1. Scroll to the bookmarked line.
2. On the Text toolbar, the Move the caret to the previous bookmark and Move the caret to the next bookmark buttons are enabled.
3. Click these buttons to navigate to bookmarks in files within the current solution or project.

expandedtoggleicon(9x12) View White Space and Word Wrap

You can turn View White Space and Word Wrap modes on or off by selecting corresponding commands from the Advanced submenu of the Edit menu.

View White Space mode displays spaces and tab characters.

Word Wrap automatically displays any portion of a line that extends horizontally beyond the viewable editor area on the next line.

expandedtoggleicon(9x12) Text Indenting

The Editor provides text indenting functionality. You can set the indent at some line, thus when you press ENTER, this indent is set at the next line. To change line indenting use Increase Line Indent and Decrease Line Indent options.

To increase or decrease indenting perform the following actions:

1. Select the text you want to indent.
2. On the Edit menu, select Advanced.
3. Select Increase Line Indent or Decrease Line Indent to manage the indentation.

collapsedtoggleicon(9x12) Code Outlining

SQL Editor allows you to hide parts of code. Outlining marks are shown left of the code editor window. Code blocks which belong to the same structural item can be collapsed by using the minus (-) symbol. Outlined code is not deleted, it is merely hidden from view.

You can then expand the outlined statement or user-defined region by clicking the plus sign (+) next to the symbol.

Outlining SQL Statements

The statement is outlined in the following cases:

· it spans over two or more lines
· it is a create statement

Nested SQL statement (for example, SELECT in CREATE VIEW) is outlined only if it starts from the new line.

Statement is not outlined if it is very short and takes only one line of code. Stored code condition and cycle operators are not outlined; the same is about nested BEGIN ... END blocks.

User-defined Outlining Regions

You can outline code block using Regions.

To create the region, type #region command at the start line of the region. No symbols except spaces are allowed at the same line before #region command. Region may have the name, so simply specify it after space at the same line. Each region statement has to be closed by the #endregion command. Type #endregion at the beginning of the line determining the region end.

You can create named regions using the #region <region name> and #endregion <region name> commands.

SQL code block, grouped by the specified region can be collapsed/expanded by user. You can create nested regions to operate several SQL code blocks.

expandedtoggleicon(9x12) See Also

User Interface Elements

Find and Replace Text and Code


Manipulating Documents

The topic describes how to manipulate documents in Schema Compare for SQL Server.

expandedtoggleicon(9x12) Managing Documents

The Windows Dialog Box allows you to switch between documents and manage them. To open it, select Windows from the Window menu. This dialog allows you to save and close multiple documents at once, and activate required document.

To save document(s) select required document(s) and click the Save button.

To close document(s) select required document(s) and click the Close Window(s) button.

note Note

To close an opened document, click the document title with middle mouse button (mouse wheel).

To activate required document, select the document and click the Activate button.

expandedtoggleicon(9x12) Navigating through the Document Views

Each SQL document includes different representations of the content - document views.

To switch to a specific view, click a button with the view name on the bottom pane of the document. Alternatively, select the required view from the shortcut menu of the document bottom pane.

You can also cycle through available views with the F7 key.

expandedtoggleicon(9x12) Working with Document Tab Groups

Multiple documents can be organized into horizontal or vertical tab groups for organizing a workspace for working with several documents at the same time. New document tab group can be created either by dragging document to the required place or by selecting New Horizontal Tab Group or New Vertical Tab Group from the document header shortcut menu.

Documents can be moved between tab groups by dragging-n-dropping or by selecting required command from the shortcut menu.

expandedtoggleicon(9x12) Restoring Tabs

Document tabs can be saved to cash and eventually be restored after the application crush or accidental closing. To customize the tab restore options, on the Tools menu, select Options. In the Options dialog box, expand Environment, then expand Documents and select Restore. Set the time after which the data will be saved automatically and select restartable file types.

Document tabs will be restored automatically at the run of the application.

expandedtoggleicon(9x12) Document Header Shortcut Menu

The document header shortcut menu includes the following options:

Save <Name>.sql
Saves a current SQL document.

Close
Closes a current document.

Close All But This
Closes all documents excepting the selected one.

Copy Full Path
Copies the full path for the document.

Open Containing Folder
Opens the folder containing the document.

Float
Detaches the window.

New Horizontal Tab Group
Creates new horizontal tab group.

New Vertical Tab Group
Creates new vertical tab group.

expandedtoggleicon(9x12) See Also

Customizing Window Layout

Customizing Environment


Customizing Window Layout

This section provides information about window layouts and their customization.

expandedtoggleicon(9x12) Closing and Displaying Tool Windows

When a tool window is closed, it becomes invisible but preserves its content, that will be available when the window is opened again. Most tool windows are listed in the View menu and can be opened by selecting corresponding View menu command. Other tool windows are listed in Database menu. You can also use shortcut keys to display certain tool windows.

All layout changes are saved when you close the application and restored when you open it again.

expandedtoggleicon(9x12) Auto-hide Mode

Tool window auto-hide mode allows you to minimize tool windows along the edges of the application window, freeing more space for the document area.

To turn on auto-hide mode, perform one of the following.

· Activate the window and select Auto Hide from the Window menu
· Right-click the window title and select Auto Hide from the shortcut menu
· Click on the pushpin icon on the title bar of the window

When tool window is in auto-hide mode, it shows when you point on it and hides when you click somewhere out of the window. You can turn auto-hide mode on for all docked tool windows to free all the workspace for document area. To do it, select AutoHide All from the Window menu.

expandedtoggleicon(9x12) Layout Saving and Restoring

All layout changes are saved when you close the application and restored when you open it again. To restore layout to its default state select Reset Window Layout from the Windows menu.

expandedtoggleicon(9x12) See Also

User Interface Concepts

Manipulating Documents


Customizing Environment

The environment provides many useful shortcut key combinations to speed up your work. Default shortcut settings are similar to shortcuts in Visual Studio. Default keyboard mapping schema can be changed to the one similar to Visual C++ 6.0 or to Delphi. There are some more keyboard mapping schemas. Moreover, you can assign your own shortcut keys to every action.

Shortcuts can be changed on the Keyboard, Environment, Options dialog box.

To access this dialog box:

1. In the Tools menu, click Options. The dialog box appears.
2. Expand the Environment section, and click Keyboard.

expandedtoggleicon(9x12) Choosing a keyboard mapping schema

You can select a keyboard mapping schema from the Apply the following additional keyboard mapping scheme drop-down list on the Keyboard page of the Environment section in the Options dialog box.

expandedtoggleicon(9x12) Determining and removing the shortcut key combination for a command

To determine or remove the shortcut key combination for a command perform the following actions.

1. On the Keyboard, Environment, Options dialog box, enter the command name without spaces or a part of it in the Show commands containing box.
2. In the list, select the correct command.
3. Shortcuts for selected command drop-down list now contains the assigned key combination for the command if any combinations exist. You can view them in the list.
4. If you want to remove the combination, select a command in the list, and click the Remove button.

expandedtoggleicon(9x12) Assigning custom shortcut key combination for a command

To assign a shortcut key combination for a command:

1. On the Keyboard, Environment, Options dialog box, enter the command name without spaces or a part of it, in the Show commands containing text box.
2. In the list, select the correct command.
3. On the Use new shortcut in drop-down list, select the feature area where you want to use the shortcut.
4. Place the cursor in the Press shortcut keys box, and press the key combination to set for the selected command. The combination will be displayed in the box.
5. Click Assign.

expandedtoggleicon(9x12) See Also

Customizing Environment

© 2009-2017 Devart


Find and Replace Text and Code

This section describes how to use Find and Replace utility.

expandedtoggleicon(9x12) In This Section

Finding and Replacing Text
The topic explains how to finding and replacing text in a file.

Searching and Replacing Text in Files
The topic describes searching and replacing text in files techniques.

Using Incremental Search
The topic explains how to use incremental search to find required text in a file.

Regular Expressions for Find and Replace
The topic explains how to use regular expressions while searching.

Wildcards for Find and Replace
The topic explains how to use wildcards while searching.


Finding and Replacing Text

You can find and replace text using Find and Replace window. To open this window press CTRL+F or CTRL+H. These techniques allow you to control the scope of find and replace and choose the method of reviewing search matches and replacements.

You should consider the following information when you search and replace text:

· Options set in the Find and Replace window are global; certain options selected in one dialog box are selected for all the dialogs. These options are Match case, Match whole word, Search all open documents, Search hidden text, Search up, Wildcards, and Regular Expressions.
· Undo is available only for documents left open after a replace operation.
· Undo for a Replace All operation rolls back all replacement changes in the current document.

You can search one or more open files or windows and move through the search matches one by one using the Find and Replace window. This technique allows you to review each individual search match in the context of the text around the match.

To search current document, current project, or all open documents:

1. Open the items you wish to search.
2. Press CTRL+F and switch to Find mode if necessary.
3. In the Look in box, select 'Current Document', 'Current Project' or 'All Open Documents'.
4. In the Find what text box, enter the text you intend to search for.
5. Select additional search options to increase the accuracy of the search.
6. Click Find Next to start the search and continue choosing Find Next until the last file has been searched.

note Note

You may search in the Output or Data Viewer and Editor windows in the same way. Just select Current Window on the step 3. In the Data Viewer and Editor window you may search both hex code and text. Hex code can be searched only when no wildcards or regular expressions are used.

When the search passes the beginning or end of the document, a message is displayed in the status bar. A message box appears when the search reaches the starting point of the search.

To replace in the current document or in all open documents:

1. Open the items you wish to search.
2. Press CTRL+H and switch to Replace mode if necessary.
3. In the Look in box, select 'Current Document', 'Current Project' or 'All Open Documents'.
4. In the Find what text box, enter the text you intend to search for.
5. In the Replace with text box, enter the text with which you intend to replace the search text.
6. Click Replace and continue clicking Replace until the last match in the last file has been replaced. Use Find Next to skip a match you do not want to replace.

You may click Replace All to replace all matches. A message box appears, listing the total number of replacements. The Replace All command replaces all search matches, including those you have skipped with the Find Next button. To reverse Replace All, choose Undo from the Edit menu in each changed file before closing any of the files.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Searching and Replacing Text in Files


Searching and Replacing Text in Files

You can use the Find and Replace in Files window to perform search and replace operations. To open this window press CTRL+F or CTRL+H, then switch to Find in Files or Replace in Files mode.

Searching and replacing text in files has following peculiarities:

· You can enter disc folder as search location or even create and use named folder sets.
· You can only find all occurrences, you cannot use Find Next.

To create a named folder set:

1. In the Find and Replace in Files window, click the button button next to the Look In box.
2. Enter the folder set name.
3. Edit the folder list with LeftArrow and RightArrow buttons. To browse folders
4. Click the Apply button. Now you may use this folder set in the Look In box.

To delete named folder set, click the button button next to the Look In box, enter the folder set name, and click Delete button.

To search in files:

1. Press CTRL+F and switch to Find in Files mode if necessary.
2. In the Look in box, select needed location or enter folder path or name of the named folder set.
3. In the Find what text box, enter the text you intend to search for.
4. Select additional search options to increase the accuracy of the search.
5. You may specify the file mask for searching in the Look at these file types box.
6. If needed, customize the Result options.
7. Click the Find All button.

After search is finished, all results are displayed in the Find Results window. You may double-click on matches to navigate to them.

To replace in files

1. Press CTRL+H and switch to Replace in Files mode if necessary.
2. In the Look in box, select needed location or enter folder path or name of the named folder set.
3. In the Find what text box, enter the text you intend to search for.
4. Select additional search options to increase the accuracy of the search.
5. If needed, customize the Result options. Select the Keep modified files open after Replace All check box if you want to be able to undo changes.
6. You may specify the file mask for replacing in the Look at these file types box.
7. In the Replace with text box, enter the text with which you intend to replace the search text.
8. Click Replace and continue clicking Replace until the last match in the last file has been replaced. Use Find Next to skip a match you do not want to replace.

You may click Replace All to replace all matches. A message box appears, listing the total number of replacements. The Replace All command replaces all search matches, including those you have skipped with the Find Next button. To reverse Replace All, choose Undo from the Edit menu in each changed file before closing any of the files.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Using Incremental Search


Using Incremental Search

You can search an individual document or window incrementally by entering a search string character by character, then observing the matches found as the search string lengthens. To activate an incremental search, choose Advanced from the Edit menu and choose Incremental Search.

An incremental search automatically searches the entire document or all text within a window, with the exception of text that has been collapsed or concealed. The editor highlights the first set of characters found in the document or window that match the search string entered.

Incremental searches are performed by default from the current location in the document downward, and from left to right. To move to the next match, press CTRL+I. To reverse the direction of the search, press CTRL+SHIFT+I.

To search incrementally:

1. Place the cursor in a blank section of the file or window you want to search.
2. From the Edit menu, choose Advanced, and then select Incremental Search.
3. The cursor icon changes to binoculars with an arrow indicating the search direction, and the status bar displays the text Incremental Search.
4. Begin typing the search string.
5. The status bar displays the search string you are entering, and the editor highlights the first match found for what you have typed so far.
6. Continue to add characters to the search string.

The editor searches again for a match of the augmented search string, and again highlights the first match found.

If no match is found, the status bar displays the following message: Incremental Search: <text> not found.

expandedtoggleicon(9x12) See Also

Find and replace text and code

Regular Expressions for Find and Replace


Regular Expressions for Find and Replace

The Find and Replace window contains a list of symbols and signs which you can use to quickly find and replace required patterns of text. They are called regular expressions.

To select a regular expression, do the following:

1. In the Find and Replace window, select the Use check box and choose Regular Expressions from the drop-down list. The [image] arrow button next to the Find what field becomes active.
2. Click the [image] arrow button and select a regular expression from the drop-down list. It is inserted into the Find what field.

The drop-down list contains the following regular expressions:

Syntax | Expression | Description
. | Any single character | Matches any single character except a line break.
* | Zero or more | Matches zero or more occurrences of the preceding expression, finding all possible matches.
+ | One or more | Matches at least one occurrence of the preceding expression.
^ | Beginning of line | Anchors the match string to the beginning of a line.
$ | End of line | Anchors the match string to the end of a line.
< | Beginning of word | Matches only when a word begins at this point in the text.
> | End of word | Matches only when a word ends at this point in the text.
\n | Line break | Matches a platform-independent line break. In a Replace expression, inserts a line break.
[] | Any one character in the set | Matches any one of the characters within the []. To specify a range of characters, list the starting and ending character separated by a dash (-), as in [a-z].
[^] | Any one character not in the set | Matches any character not in the set of characters following the ^.
| | Or | Matches either the expression before or the one after the OR symbol (|). Mostly used within a group. For example, (database|management)system matches "database system" and "management system".
\ | Escape Special Character | Matches the character that follows the backslash (\) as a literal. This allows you to find the characters used in regular expression notation, such as { and ^. For example, \^ Searches for the ^ character.
{} | Tagged Expression | Matches text tagged with the enclosed expression.
:i | SQL identifier | Matches the expression ([a-zA-Z_$][a-zA-Z0-9_$]*).
:q | Quoted string | Matches the expression (("[^"]*")|('[^']*')).
:b | Space or Tab | Matches either space or tab characters.
:z | Integer | Matches the expression ([0-9]+).

expandedtoggleicon(9x12) See Also

Find and replace text and code

Wildcards for Find and Replace


Wildcards for Find and Replace

The Find and Replace window contains a list of expressions to replace characters or digits in the Find what field. They are called Wildcards.

To select a required wildcard, do the following:

1. In the Find and Replace window, select the Use check box and choose Wildcards from the drop-down list. The [image] arrow button next to the Find what field becomes active.
2. Click the [image] arrow button and select a wildcard from the drop-down list. It is inserted into the Find what field.

The drop-down list contains the following wildcards:

Syntax | Expression | Description
? | Any single character | Matches any single character.
# | Any single digit | Matches any single digit. For example, 5# matches numbers that include 5 followed by another number, such as 51, but not 15.
[!] | Characters not in set | Matches any one character that is not specified in the set.
\ | Escape | Matches the character that follows the backslash (\) as a literal. This allows you to find the characters used in wildcard notation, such as * and #.
* | One or more characters | Matches any one or more characters. For example, test* matches any text that includes "test", such as testfile.txt.
[] | Set of characters | Matches any one of the characters specified in the set.

expandedtoggleicon(9x12) See Also

Find and Replace Text and Code

User Interface Concepts


Reference

ExpandedToggleIcon(9x12) In This Section

Data Editor
This section provides information on data managing windows and dialogs.

Database Connection
This section describes Data Connection user interface elements.

Database Tasks
Describes wizards and dialog boxes, related to the database tasks tools.

Execute Script Wizard
Use this wizard for executing large scripts without opening them in editor.

Find and Replace Window
This section describes how to use the Find and Replace window to search for text, expressions, or entity names within the code of your documents.

Options
This section describes different options that are available in Schema Compare for SQL Server.

Service Windows
This section describes user interface elements of service windows and dialogs.

Schema Compare
This section describes all the wizards, documents, windows and other UI elements related to schema comparison and synchronization processes.

Shortcut Keys
Use the topic to customize shortcut keys in dbForge Schema Compare for SQL Server.

SQL Document
This section describes SQL Document user interface elements.


Data Editor

This section provides information on data managing windows and dialogs.

ExpandedToggleIcon(9x12) In This Section

Data Viewer and Editor
Describes how to view and edit fields of large data types.

Custom AutoFilter Dialog Box
Tells how to build a custom filter for a data column.

Filter Editor Dialog Box
Describes how to build complex filter conditions for table data.

Visible Columns Dialog Box
Tells how to filter data by hiding some columns.

Data Editor Window
Describes user interface elements of the Data Editor window.


Data Viewer and Editor Window

Data Viewer and Editor is a tool which allows simple viewing and editing fields.

The control automatically detects type of the content of the BLOB field and represents it as an image, text, rich text or hex dump. To access Data Viewer and Editor, on the View menu, click Data Viewer and Editor. Then just select the text or BLOB field, and its content appears in the Data Viewer and Editor window.

load-data Load Data
Replaces the cell content with the data from the file. It opens the Open File dialog where you can select a required file and specify the encoding which should be applied to open and save the file content.

Save Save Data
Opens the Save File As dialog to save data to a file.

note Note

If you try to save to database more data than can be stored in the selected column type, the data will be truncated.

Save Data at the Left
Saves data displayed in the left part of the window to a file.

Save Data at the Right
Saves data displayed in the right part of the window to a file.

note Note

The Save Data at the Left and Save Data at the Right options are available for comparison results.

null-data Null Data
Sets the cell value to NULL.

Apply Changes
Click to apply changes.

cancel-changes Cancel Changes
Click to cancel changes.

copy-cell Copy Entire Cell Value
Copies the cell data into the clipboard.

Paste Entire Cell Value
Replaces the cell data with the data from the clipboard. The format of the pasted data is automatically detected and the required view is set.

cut-cell Cut Entire Cell Value
Cut the cell data placing it to the clipboard.

Hexadecimal View
Shows cell data as hex dump.

Text View
Shows cell data as a text.

xml-view XML View
Shows the cell data as structured XML.

json-icon JSON View
Shows cell data as a JSON string.

Rich Text View
Shows cell data as a rich text.

Image View
Shows cell data as an image.

geometry-viewer Spatial View - Geometry
Shows geometry data as an image. The image in the view can be moved with the mouse pointer. The image can be also zoomed in and out. To zoom the image in, hold down the Ctrl key and roll the mouse wheel forward. To zoom the image out, hold down the Ctrl key and roll the mouse wheel backward.

FitScale Fit Image
Fits an image to the size of the window.

View White Space
Shows each white space with a green character.

Type | Size
Shows the type and size of the displayed data. If data cannot be displayed in the selected view, the Type will be set to Unknown.

note Note

You can copy all data in the cell by using the CTRL+SHIFT+C shortcut. Format of the copied data will depend on the selected view. For example, if the Hexadecimal view is selected, the data will be copied in hex order; data in the Text view, will be copied in text format, etc.

ExpandedToggleIcon(9x12) See Also

Data Editor

Custom AutoFilter Dialog Box


Custom AutoFilter Dialog Box

Custom AutoFilter dialog is used to create a custom filter for a data grid column. It is displayed when choosing Custom in the grid drop-down filter list.

Using this dialog, you can build a custom data filter with two conditions for a column. Condition relation can be selected from the drop-down list in the left box and value for relation can be entered in the right box. Select And or Or option, and click OK to apply the filter.

ExpandedToggleIcon(9x12) See Also

Data Editor

Filter Editor Dialog Box


Filter Editor Dialog Box

Use the Filter Editor dialog to create complex filter conditions to filter data in the data grid. To open this dialog, right-click a required column and select the [image] Condition item from the Quick Filter sub-menu.

Filter conditions in the Filter Editor dialog box are displayed as a tree with condition and group nodes. A group consists of several conditions or subgroups, united with a logical operator.

Condition Tree

The upper part of the Filter Editor dialog is a condition tree. Its nodes are red-colored condition groups and conditions, started with blue-colored column name.

Condition Group

It is displayed as a red-colored logical operator and a FilterGreyAdd button. Clicking the FilterGreyAdd button adds a new condition to group. Clicking the logical operator displays the following menu:

And
Sets And logical operator for the group. All group conditions must be true.

Or
Sets And logical operator for the group. At least one condition from the group must be true.

Not And
Sets Not And logical operator for the group. At least one condition from the group must be false.

Not Or
Sets Not Or logical operator for the group. All group conditions must be false.

Add Condition
Adds a new condition to the group.

Add Group
Adds a new condition group to the current group.

Clear All
This command is available for the top-level condition group only. Removes all conditions and subgroups, leaving only the top-level group node.

Remove Group
This command is available for the non-top-level condition group only. Removes the condition group.

Condition

It consists of the following parts:

Condition column
Blue-colored name of the grid column, to which condition will be applied. You can set another column for the condition by clicking the column name and choosing the column from the appeared menu.

Criteria operator
Green-colored criteria operator. You can set another operator for the condition by clicking the operator name and choosing the operator from the appeared menu.

Operand value
Click and enter the operand value here. Some operators have no operand values (for example Is blank operator), some may have several values.

FilterGreyAdd
This button appears for operators that can have one or more operand values. Click it to add one more operand value.

FilterGreyDel
Click this button to delete the condition. You can also navigate to the condition and press the DELETE or MINUS SIGN key

To navigate between conditions and groups, use the UP ARROW and DOWN ARROW keys. To navigate between a condition column, a criteria operator and a operand value, use the LEFT ARROW and RIGHT ARROW keys.

Buttons

OK
Apply the filter and close Filter Builder dialog.

Cancel
Close Filter Builder dialog and cancel all filter changes.

Apply
Apply the filter and without closing Filter Builder dialog.

ExpandedToggleIcon(9x12) See Also

Data Editor

Visible Columns Dialog Box


Visible Columns Dialog Box

Use the Visible Columns dialog to simplify data analysis and filter data by hiding some columns in the grid. To open this dialog, select Visible Columns from the column shortcut menu. The Visible Columns dialog contains the following:

List of columns
Clear a check box next to a column to hide the column data in the grid. Select a check box to show the column data again.

Select / Deselect All
Select this check box to show all the columns at once. Clear the check box to manually select required columns.

Sort alphabetically
Select it to show the columns in alphabetical order.

ExpandedToggleIcon(9x12) See Also

Data Editor

Data Editor Window


Data Editor Window

This topic describes the Data Editor window user interface elements.

RefreshButton Refresh Data
Use this option to refresh data.

Stop Refresh Data
Use this option to stop refresh operation.

Cached Updates Mode
Allows you to control data editing within single database object.

Apply Changes
Click to store your changes to the server.

Cancel Changes
Click in case you do not want the changes to be applied.

Paginal Mode
Use the Paginal Mode to simplify data view by dividing it into parts.

Go To First Page
Click the Go To First Page button to open the first part page of data.

Go To Previous Page
Click the Go To Previous Page button to open the previous part page of data.

Go to Next Page
Click the Go to Next Page button to open the next part page of data.

Go To Last Page
Click the Go To Last Page button to open the last part page of data.

Switch To Grid View
Click the Switch To Grid View button on the data view toolbar to switch to the Grid View mode.

Switch To Card View
Click the Switch To Card View button to switch to the Card View mode.

Show Group By Box
Click the Show Group By Box button to group data by column.

Auto-search mode
Click the Auto-search mode button to switch to the Auto-search mode. You can also switch to the Auto-search mode by pressing CTRL+I keys.

Data Editor Grid
Contains editable data. It could be represented as a table in the Grid View mode as well as cards in the Card View mode.

First First
Click the First button to switch to the first record field.

Previous Previous
Click the Previous button to switch to the previous record field.

Next Next
Click the Next button to switch to the next record field.

Last Last
Click the Last button to switch to the last record field.

Append Append
Click the Append button to insert more records.

Delete Delete
Click this button to delete the records.

End Edit
Click this button to confirm the changes.

Cancel Edit
Click the Cancel Edit button to discard the changes.

ExpandedToggleIcon(9x12) See Also

Data Editor


Database Connection

This section describes Data Connection user interface elements.

note Note

Database Explorer is not available in the following products:

· dbForge Data Compare for SQL Server
· dbForge Schema Compare for SQL Server
· dbForge Data Generator for SQL Server
· dbForge Event Profiler for SQL Server

ExpandedToggleIcon(9x12) In This Section

Database Connection Properties Dialog Box
Information about connection parameters.

Connect to SQL Database Dialog Box
The topic helps you to connect to the server without having specified a password.

Browse for Servers Dialog Box
The topic helps you to select local and network servers.

Connection Manager Dialog Box
The topic helps you to create, edit, and delete database connections.

Connect to Server Dialog Box
The topic helps you to connect to the server when the Database Explorer window is not activated.


Database Connection Properties Dialog Box

Use the Database Connection Properties dialog box to setup or change the database connection parameters. There are several ways to access the Database Connection Properties dialog box:

· Click New Connection on the Database Explorer window toolbar.
· In Database Explorer, open the shortcut menu for the data connection you want to modify and choose Modify Connection.
· In the Database menu, click New Connection.
· Right-click in the Database Explorer, and then select New Connection on the shortcut menu.

note Note

Database Explorer is not available in the following products:

· dbForge Data Compare for SQL Server
· dbForge Schema Compare for SQL Server
· dbForge Data Generator for SQL Server
· dbForge Event Profiler for SQL Server

The Database Connection Properties dialog box includes the following tabs:

General, Database Connection Properties Dialog Box
Allows you to set the login information required to connect to the SQL Server.

Advanced, Database Connection Properties Dialog Box
Allows you to set additional options to tune database connections.

ExpandedToggleIcon(9x12) See Also

Database Connection

Browse for Servers Dialog Box


General, Database Connection Properties Dialog Box

Use the General tab of the Database Connection Properties dialog box to view and manage the following parameters of an SQL Server database connection:

Server
Select the server instance to connect to. The server instance last connected to is displayed by default.

Authentication
Two authentication modes are available when connecting to an instance of the Database Engine.

Windows Authentication
Microsoft Windows Authentication mode allows a user to connect through a Windows user account.

SQL Server Authentication
When a user connects with a specified login name and password from a non-trusted connection, SQL Server performs the authentication itself by checking to see if a SQL Server login account has been set up and if the specified password matches the one previously recorded. If SQL Server does not have a login account set, authentication fails, and the user receives an error message.

Active Directory Password Authentication
Allows connecting to MicrosoftAzure SQL Database with help of identities in Azure Active Directory. Use this method for connecting to SQL Database if you are logged into Windows using credentials from a domain that is not federated with Azure, or when using Azure AD authentication using Azure AD based on the initial or the client domain.

Active Directory Integrated Authentication
Allows connecting to MicrosoftAzure SQL Database by using identities in Azure Active Directory. Use this method for connecting to SQL Database if you are logged into Windows using your Azure Active Directory credentials from a federated domain.

Login
Enter the login to connect with. This option is not available if you have selected to connect using Windows Authentication.

Password
Enter the password for the login. This option is not available if you have selected to connect using Windows Authentication.

Allow saving password
If selected, the password is stored among the other connection parameters.

Database
Select a name of an SQL Server database you want to connect to.

Show all databases
Select the check box to show all databases.

Connection Name
Use this text box, to specify the connection name.

Document Category
You can assign a category for a document to associate it with a specific connection.

Test Connection
Click this button to make the test connection to a database.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Advanced, Database Connection Properties Dialog Box


Advanced, Database Connection Properties Dialog Box

The Advanced properties tab provides the following options:

Connection timeout
Sets the length of time (in seconds) to wait for a connection to the server before terminating the attempt and generating an error. The default value is 15 seconds.

Execute timeout
Sets the length of time (in seconds) to wait for a query execution before terminating the attempt and generating an error.

Encrypt connection
Forces encryption of the connection.

To add more connection parameters to the connection string, use the additional connection parameters.

Keyword

Default

Description

Asynchronous Processing

When true, enables asynchronous operation support. Recognized values are true, false, yes, and no.

AttachDBFilename

"false"

The name of the primary database file, including the full path name of an attachable database. AttachDBFilename is only supported for primary data files with an .mdf extension. The attachment will fail if the primary data file is read-only. The path may be absolute or relative.

Connection Timeout

15

The length of time (in seconds) to wait for a connection to the server before terminating the attempt and generating an error.

Context Connection

"false"

true if an in-process connection to SQL Server should be made.

Current Language

The SQL Server Language record name.

Data Source

The name or network address of the instance of SQL Server to which to connect. The port number can be specified after the server name: server=tcp:servername, portnumber. When specifying a local instance, always use (local). To force a protocol, add one of the following prefixes: np:(local), tcp:(local), lpc:(local)

Encrypt

"false"

When true, SQL Server uses SSL encryption for all data sent between the client and server if the server has a certificate installed. Recognized values are true, false, yes, and no.

Failover Partner

The name of the failover partner server where database mirroring is configured.

Initial Catalog

The name of the database.

Integrated Security

"false"

Whether the connection is to be a secure connection or not. Recognized values are 'true', 'false', and 'sspi', which is equivalent to 'true'.

MultipleActiveResultSets

"false"

When true, an application can maintain multiple active result sets (MARS). When false, an application must process or cancel all result sets from one batch before it can execute any other batch on that connection. Recognized values are true and false.

MultiSubnetFailover

Always specify multiSubnetFailover=Yes when connecting to the availability group listener of a SQL Server 2012 availability group or a SQL Server 2012 Failover Cluster Instance. multiSubnetFailover=Yes configures SQL Server Native Client to provide faster detection of and connection to the (currently) active server. Possible values are Yes and No.

Network Library

The network library used to establish a connection to an instance of SQL Server. Supported values include dbnmpntw (Named Pipes), dbmsrpcn (Multiprotocol, Windows RPC), dbmsadsn (Apple Talk), dbmsgnet (VIA), dbmslpcn (Shared Memory, local machine only) and dbmsspxn (IPX/SPX), dbmssocn (TCP/IP) and Dbmsvinn (Banyan Vines).

The corresponding network DLL must be installed on the system to which you connect. If you do not specify a network and you use a local server (for example, "." or "(local)"), shared memory is used.

Packet Size

Size in bytes of the network packets used to communicate with an instance of SQL Server.

Password

The SQL Server password.

Persist Security Info

"false"

When set to 'false' (strongly recommended), security-sensitive information, such as the password, is not returned as part of the connection if the connection is open or has ever been in an open state. Resetting the connection string resets all connection string values including the password.

Replication

"false"

true if replication is supported using the connection.

TrustServerCertificate

"false"

When set to true, SSL is used to encrypt the channel when bypassing walking the certificate chain to validate trust. If TrustServerCertificate is set to true and Encrypt is set to false, the channel is not encrypted. Recognized values are true, false, yes, and no.

Type System Version

A string value that indicates the type system the application expects. Possible values are:

· Type System Version=SQL Server 2000;
· Type System Version=SQL Server 2005;
· Type System Version=SQL Server 2008;
· Type System Version=Latest;

When set to SQL Server 2000, the SQL Server 2000 type system is used. The following conversions are performed when connecting to a SQL Server 2005 instance:

· XML to NTEXT
· UDT to VARBINARY
· VARCHAR(MAX), NVARCHAR(MAX) and VARBINARY(MAX) to TEXT, NEXT and IMAGE respectively.

When set to SQL Server 2005, the SQL Server 2005 type system is used. No conversions are made for the current version of ADO.NET.

When set to Latest, the latest version than this client-server pair can handle is used. This will automatically move forward as the client and server components are upgraded.

User ID

The SQL Server login account.

User Instance

"false"

A value that indicates whether to redirect the connection from the default SQL Server Express instance to a runtime-initiated instance running under the account of the caller.

Workstation ID

The local computer name

The name of the workstation connecting to SQL Server.

ExpandedToggleIcon(9x12) See Also

Database Connection Properties Dialog Box

Browse for Servers Dialog Box


Connect to SQL Database Dialog Box

The dialog box appears when you connect to the server without having specified a password.

Authentication
Specify the required authentication mode here.

User
Enter the name for the SQL login account.

Password
Enter the password for the SQL login account.

Server
Specify the server you want to connect to.

Database
Specify the database you want to work with.

ExpandedToggleIcon(9x12) See Also

Database Connection

Browse for Servers Dialog Box


Browse for Servers Dialog Box

Use the Browse for Servers dialog box to select the local and network servers.

This dialog box appears when you click <Browse...> in the Server combo-box (which is located on the General tab of the Database Connection Properties dialog box)

The Database Connection Properties dialog box provides the next members:

Local Servers
Displays the list of local servers.

Network Servers
Allows you to select an SQL Server instance in the network.

Refresh
Refreshes the list of network servers.

ExpandedToggleIcon(9x12) See Also

Database Connection

Connect to Server Dialog Box


Connection Manager Dialog Box

Connection Manager dialog box allows you to create, edit, and delete database connections.

ExpandedToggleIcon(9x12) Dialog Box Controls

Dialog box contains the following controls:

Connections
The list of the existing database server connections.

New
Click to open Database Connection Properties dialog box for creating a new connection.

Edit
Click to open Database Connection Properties dialog box for editing a connection.

Delete
Click to delete the connection.

Connection String
Displays a connection string, containing the connection parameters, for the selected connection.

ExpandedToggleIcon(9x12) See Also

Database Connection

Connect to Server Dialog Box


Connect to Server Dialog Box

Use the dialog box to connect to the server when the Database Explorer window is not activated.

note Note

Database Explorer is not available in the following products:

· dbForge Data Compare for SQL Server
· dbForge Schema Compare for SQL Server
· dbForge Data Generator for SQL Server
· dbForge Event Profiler for SQL Server
· dbForge Documenter for SQL Server

Connections
Displays information on available server connections.

Server
Specify the server connection you want to create a new SQL document in.
Database
Specifies a database you want ot connect to.
User
Specifies a connection user login.
Name
Specifies a selected server database name.

ExpandedToggleIcon(9x12) See Also

Database Connection


Database Tasks

This section describes wizards and dialog boxes, related to the database tasks tools.

ExpandedToggleIcon(9x12) In This Section:

Generate Script Wizard
Describes Generate Script wizard's fields and options.

Create Scripts Folder or Snapshort Dialog Box
Describes fields and options of the Create Scripts Folder or Snapshot dialog box.


Generate Script Wizard

ExpandedToggleIcon(9x12) In This Section

General, Generate Script Wizard
Choose general backup options on this page.

Script Content, Generate Script Wizard
Choose database objects to backup on this page.

Options, Generate Script Wizard
Set database backup options on this page.

Errors Handling, Generate Script Wizard
Specify errors processing behavior and logging options on this page.

Progress, Generate Script Wizard
See the progress of database backup process on this page.

Finish, Generate Script Wizard
See the results of database backup operation on this page.

ExpandedToggleIcon(9x12) See Also

Execute Script Wizard


General, Generate Script Wizard

Choose general backup options on this page.

Load a previously saved backup project
Use these options to load an existing backup.

Open
Calls the Open dialog. Use this button to open an existing backup project. Click this button to choose one of the previously opened backup projects. If you load an existing project its name is displayed in a field near these buttons.

Connection
Choose a connection from the drop-down list.

Database
Choose a database from the drop-down list.

Path
Defines the path where output file will be saved.

Output file name
Enter output file name here. The default name is the name of the database.

Append timestamp to the file name
Select it to include a timestamp to the name of the generated file. For example, if the file with the structure of sakila database is ready for generation on the 1st of November, 2009 at 12:30 a.m, the file name with the timestamp will be the following - "database name" 20091101 1230.sql.

Auto delete old files
If the Append timestamp to the file name option is checked, you can choose to delete old output files automatically when generating new files.

Files older than
Set the number of days the files should be older to be deleted.

Quantity more than
Backups are auto deleted if their quantity is more than the number specified.

Use compression (ZIP)
Check this option to compress a database script to a ZIP file.

note Note

If the size of the SQL file you want to compress is more than 4GB, the ZIP64 format will be used for compression. Otherwise the old format will be used.

Level
Select the level of compression here. You can select one of the following levels of compression: No Compression, Best Speed, Fast, Default, Good, Maximum.

Comment
Add a comment to the created archive.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Script Content, Generate Script Wizard


Script Content, Generate Script Wizard

Choose database objects to backup on this page.

Structure
Backup only objects' structure into DDL statements.

Data
Backup only tables' data into INSERT statements.

Include all objects
Check this to backup all database objects. If this option is not checked, select the objects you want to backup in the tree below.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Options, Generate Script Wizard


Options, Generate Script Wizard

Set database backup options on this page.

The Options wizard page contains the following details:

Find
Enter the first character of the option's name to show only the options that contain this part in their names.

Common

Check for object existence
Check whether the object already exists on the server.

Generate comments in the script
Select to insert comments in the script.

Scripts collation
Includes collation information in the script.

Scripts default constraints
Scripts default constraints and schema defaults.

Scripts extended properties
Adds extended properties in the script.

Script logins
Includes all logins available on the server. Passwords will not be included.

Scripts security permissions
Scripts security permissions.

Scripts statistics
Scripts statistics.

Tables/Views

Scripts change tracking
Scripts CHANGE_TRACKING clauses and statements when comparing and synchronizing databases.

Scripts check constraints
Adds CHECK constraints to the script.

Scripts DATA_COMPRESSION for indexes, primary and unique constraints
When selected, DATA_COMPRESSION clause is scripted for indexes, primary and unique constraints.

Scripts DML triggers
Scripts the creation of triggers on the table.

Scripts foreign keys
Scripts the creation of foreign keys on the table.

Scripts full-text search
Scripts full-text stoplists, full-text catalogues, and full-text indexes.

Scripts indexes
Scripts indexes.

Scripts primary keys
Scripts the creation of primary keys on the table.

Script unique keys
Includes the CREATE statement for unique keys in the tables.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default settings.

My Defaults
Click this button to restore your default settings, previously saved with the Save As My Defaults button.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Errors Handling, Generate Script Wizard


Errors Handling, Generate Script Wizard

On this page, you can specify errors processing behavior and logging options.

Errors Handling

Prompt a user for an action
If an error occurred, the application will show a message with the description of an error, its possible reason and possible actions to take.

Ignore all errors
All errors that may occur during the process are written to the error list, and the process will be finished.

Abort at the first error
If an error occurs, the backup process is aborted.

Log Settings

Write an import report to a log file
Check this option to write an backup report to a log file.

Log file
Choose the destination folder where the log file will be located.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Progress, Generate Script Wizard


Progress, Generate Script Wizard

You can see the progress of database backup process on this page. To minimize the application windows, click the Minimize Application button. To cancel the backup process press the Cancel button.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Finish, Generate Script Wizard


Finish, Generate Script Wizard

You can see the results of database backup operation on this page.

If the process was completed successfully, the complete icon indicates this status.

If the process failed, this status is indicated by the failed icon.

In the results of backup process the number of errors, warnings and objects is stated.

Show log file...
This button is active if you chose to create a log file on the Errors handling page.

Open script
Check this option to open the result file when the wizard is closed.

Save a backup project
Check this option to save a backup project for future use. After the wizard is closed the Save As dialog window is opened.

ExpandedToggleIcon(9x12) See Also

Generate Script Wizard

Execute Script Wizard


Create Scripts Folder or Snapshot Dialog Box

Use this dialog box to:

· create a folder to store database scripts.
· generate a snapshot file for your database structure.

Source: Database

Connection
Select an SQL Server connection from the drop-down list. Click <Manage...> to open the Connection Manager dialog box. It will help you create, edit, and delete database connections.

Edit
Click to edit the selected connection. The Database Connection Properties dialog box opens. This option is available only when Database is selected as a Source Type.

New
Click to create a new SQL Server connection. The Database Connection Properties dialog box opens.

Server Version
Displays the server version.

Database
Specify the required database. Click <Refresh...> to refresh the list of available databases, if any changes were made.

Decrypt encrypted objects
Select the option to let encrypted objects be decrypted automatically.

Source: Scripts Folder

Database scripts folder
Specify the path to the scripts folder.

SQL Server Version
Displays the server version that is associated with the scripts folder.

Default Collation
Displays default collation that is associated with the scripts folder.

Source: Snapshot

Snapshot can be a source for the Scripts Folder only.

Snapshot
Specify the path to a snapshot you want to use.

Server
Displays the server connection name that is associated with the selected snapshot file.

Server Version
Displays the server version that is associated with the selected snapshot file.

Database
Displays the name of the database for the selected snapshot.

Created
Displays date and time when the selected snapshot was created.

Category
Displays the connection category that is associated with the selected snapshot file.

Destination Type: Scripts Folder

Path
Specify a path to store the scripts folder.

Scripts Folder Structure
Click to setup scrips folder structure.

Destination Type: Snapshot

Path
Specify a path to store the snapshot.

Compress
Select this check box if you want Schema Compare for SQL Server to archive the snapshot file. This option is useful when you save large snapshots.

ExpandedToggleIcon(9x12) See Also

Database Tasks


Execute Script Wizard

Use this wizard for executing large scripts without opening them in the editor. To access the Execute Script Wizard, on the Database menu, click ExecuteLargeScript Execute Large Script. The wizard pages are listed below.

ExpandedToggleIcon(9x12) Script Location, Execute Script Wizard

Use this page to choose a location and connection parameters of a large script to execute it without opening in the text editor. This will significantly save your time while working with large scripts.

Options

Connection
Click the field to select a connection to a required server where you want to execute your script. In the drop-down list of the field you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete existing connections.

Database
Click the field to select a required database from the list of all databases available on the selected SQL Server.

File Name
Enter the path to a script you want to execute or click the Browse button to select the path in the Open dialog.

SQL file encoding
Select the encoding which should be applied to open and execute the script. The program automatically selects it based on the script, if it fails, the default encoding (the current Windows encoding on the machine where dbForge Schema Compare for SQL Server is running) is selected.

Execute
Click it to execute the selected script.

Cancel
Click it to close the wizard and discard the script execution.

ExpandedToggleIcon(9x12) Execution Progress, Execute Script Wizard

See script execution progress on this page. To stop the script execution, click the Cancel button.

ExpandedToggleIcon(9x12) Operation Complete, Execute Script Wizard

See the results of script execution on this page.

ExpandedToggleIcon(9x12) See Also

Reference


Find and Replace Window

You can use the Find and Replace window to search for text, expressions, or entity names within the code of your documents. To access this window, from the Edit menu, click Find and Replace, and then select one of the options listed.

The Find and Replace window contains a toolbar with two drop-downs, one for find operations and one for replace operations. When you select an operation, the corresponding options for the operation are displayed. You can search and replace in one or more files or an entire project for text, SQL code, or symbols.

ExpandedToggleIcon(9x12) In This Section

Find, Find and Replace Window
Used to search the active file for a string or expression. Jumps from match to match within each document.

Find in Files, Find and Replace Window
Used to search for a string or expression in files stored within a set of search folders, or across the active solution. Displays matches in the Find Results windows.

Choose Search Folders Dialog Box
The topic describes Choose Search Folders dialog box that allows you to create your own set of search folders, and to specify the order in which they are searched.

Find Results Window
The topic describes the Find Results window that allows you to navigate text search results


Find, Find and Replace Window

Use Find and Replace dialog box for searching and replacing text in the code editor.

note Note

The dialog boxes and menu commands you see might differ from those described in Help depending on your active settings or edition.

To access the Find and Replace dialog box:

1. In the Edit menu, click Find and Replace.
2. Select required option from the list.

An alternative way to access the Find and Replace window is by pressing CTRL+F shortcut key.

ExpandedToggleIcon(9x12) Menus

Find
Allows to select Find or Find in Files dialog.

Find
The search will be executed in an open document.

Find in Files
The search will be executed in the selected files or a project. If this option is selected, the Find and Replace window provides additional options. You can create a set of selected folders, specify search file types, and set result options.

Replace
Allows to select Replace or Replace in Files dialog.

Replace
The search will be executed in the document. The occurrences will be replaced with the replacement string.

Replace in Files
The search will be executed in the files or a project. The occurrences will be replaced with the replacement string.

ExpandedToggleIcon(9x12) General Options

Find what
To search for a new text string or expression, specify it in the box. To search for any of the strings that you searched for most recently, open the list, and select the string for which you want to search. You can also:

· Reuse the search strings by selecting any from the drop-down list in the field
· Enter a new search string into the field
· Use regular expressions as search strings
· Use wildcards in your search strings

Replace with
Replacement string.

Look in
Select search location here.

Current Document
Search will be executed in current document only.

Current Window
Search will be executed in current tool window. It can be either the Output window or the Data Viewer and Editor window.

All Open Documents
Search will be executed in all open documents.

Selection
Search will be executed in the selected text.

Current Project
Search will be executed in the opened project.

ExpandedToggleIcon(9x12) Find Options

Match case
Case sensitive search.

Match whole word
The string will not be found/replaced if it is not a whole word.

Search up
Search will be performed in reverse direction.

Search hidden text
Search in collapsed text areas (such as regions, definitions and others) will be also performed.

Use
Use regular expressions or wildcards in search.

Regular expressions
A regular expression is a pattern of text that consists of ordinary characters (for example, letters a through z) and special characters, known as metacharacters. The pattern describes one or more strings to match when searching text. If this option is selected, the arrow button next to the Find what field becomes active. You can click the button and select a required regular expression to add to the Find what field.

Wildcards
This is a list of expressions to replace characters or digits in the Find what field.

ExpandedToggleIcon(9x12) Buttons

Find Next
Searches the next occurrence in document.

Bookmark All
Sets bookmarks for the lines, that contain occurrences in the scope. Available for the Find mode.

Replace
Searches the next occurrence in document or replaces the selected one if on replace dialog, shows replace dialog if on search dialog. Available for the Replace mode.

Replace All
Replaces all occurrences in search location. Available for the Replace mode.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Find in Files, Find and Replace Window


Find in Files, Find and Replace Window

Use the Find and Replace window to find and replace text in the selected files.

note Note

The dialog boxes and menu commands you see might differ from those described in Help depending on your active settings or edition.

To access the Find in Files, Find and Replace dialog box:

1. In the Edit menu, click Find and Replace.
2. Select required option from the list.

An alternative way to access the Find in Files, Find and Replace window is by pressing CTRL+F shortcut key, and then select Find in Files from the Find menu.

ExpandedToggleIcon(9x12) Menus

Find
Allows to select Find or Find in Files dialog.

Find
The search will be executed in the opened document.

Find in Files
The search will be executed in the selected files or a project. If this option is selected, the Find and Replace window provides additional options. You can create a set of selected folders, specify search file types, and set result options.

Replace
Allows to select Replace or Replace in Files dialog.

Replace
The search will be executed in the document. The occurrences will be replaced with the replacement string.

Replace in Files
The search will be executed in the files or a project. The occurrences will be replaced with the replacement string.

ExpandedToggleIcon(9x12) General Options

Find what
String that will be searched. This field allows you to use a string or a regular expression that will be matched. You can do the following:

· Reuse the search strings by selecting any from the drop-down list in the field
· Enter a new search string into the field
· Use regular expressions as search strings
· Use wildcards in your search strings

Replace with
Replacement string.

Look in
Select a search location here, either selecting options from the drop-down list or creating a new set of folders in the Choose Search Folders window. The drop-down list contains the following options:

Current document
Search will be executed in the current document only.

All open documents
Search will be executed in all open documents.

Current Project
Search will be executed in the opened project.

Button
Click to open the Choose Search Folders dialog box for creating custom named folder list.

Include sub-folders
Select this check-box to include the sub-folders within the selected folder set in the Look in field.

ExpandedToggleIcon(9x12) Find Options

Match case
Case sensitive search.

Match whole word
The string will not be found/replaced if it is not a whole word.

Use
Select this check-box to activate the use of regular expressions or wildcards in search strings.

Regular expressions
A regular expression is a pattern of text that consists of ordinary characters (for example, letters a through z) and special characters, known as metacharacters. The pattern describes one or more strings to match when searching text. If this option is selected, the arrow button next to the Find what field becomes active. You can click the button and select a required regular expression to add to the Find what field.

Wildcards
This is a list of expressions to replace characters or digits in the Find what field.

Look at these file types
Select the required file types from the drop-down list. The search will be executed only in files of the selected type.

ExpandedToggleIcon(9x12) Result Options

Display file names only
Select this check-box to show one entry per a file containing a search match.

Keep modified files open after Replace All
Select this check-box to leave all modified files open after Replace All is performed. It will allow you to undo or save the changes in the files.

ExpandedToggleIcon(9x12) Buttons

Find Next
Searches the next occurrence in document.

Find All
Searches for all occurrences in the scope. Available for the Find in Files mode.

Replace
Searches the next occurrence in document or replaces the selected one if on replace dialog, shows replace dialog if on search dialog. Available for the Replace in Files mode.

Replace All
Replaces all occurrences in search location. Available for the Replace in Files mode.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Choose Search Folders Dialog Box


Choose Search Folders Dialog Box

This dialog allows you to create, save, and revise your own set of search folders, and to specify the order in which they are searched. To open this dialog, click the Button button, next to the Look in field.

Folder set
Shows the folders available for search. To create a new folder set, enter a name, add a set of search folders to the Selected folders list, and then click the Apply button.

Apply
Saves the set of search folders in the Selected folders list as a named folder set. This folder set then can be chosen in the Look in field on all tabs of the Find and Replace window. Leaves the Choose Search Folders dialog box open.

Delete
Removes the selected folder set from the Folder set field, and from the Look in field on all tabs of the Find and Replace window.

Available folders
Select a previously selected folder from the drop-down list to populate the Selected folders list.

List of Folders
Shows the drives and folders available within the folder selected in the Available folders drop-down list. Double-click to expand any drive or folder listed. Select a folder, or hold down the SHIFT or CTRL key to select multiple folders. To add a selected folder to the Selected folders list, click the arrowright right-arrow button. To remove a selected folder, click the arrowleft the left-arrow button.

Up
Moves the selection in the Available folders list one level higher in the folder hierarchy.

Selected folders
Lists folders added from the Available folders list. These folders will be included in the named folder set.

Arrow buttons
arrowright - Moves folders to the Selected folders list.

arrowleft - Selects folders from the Selected folders list.

arrowup - Moves the selected folder to one position higher in the Selected folders list so that the folder will be searched earlier.

arrowdown - Shifts the selected folder to one position down in the Selected folders list so that the folder will be searched later.

OK
Saves the set of search folders listed in Selected folders list as a named folder set. This folder set then can be chosen in the Look in field on all tabs of the Find and Replace window. Closes the Choose Search Folders window.

Cancel
Discards all changes and closes the Choose Search Folders window.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window

Find Results Window


Find Results Window

Find Results window allows you to navigate text search results. It provides you following search results: file name, line number and part of the text, containing the match. You may double-click on matches to navigate to them. Find Results window has following toolbar buttons.

Go to the location on the current line
Moves caret to the selected line location of the match found.

Go to the previous location in the list
Moves caret to the selected line location of the previous match found.

Go to the next location In the list
Moves caret to the selected line location of the next match found.

Clear All
Clears Find Results window.

ExpandedToggleIcon(9x12) See Also

Find and Replace Window


Options

This section describes different options that are available in dbForge Studio.

ExpandedToggleIcon(9x12) In This Section

Environment Options
This section describes Environment options which determine how certain elements of the dbForge Studio display and behave.

Text Editor Options
This section describes Text Editor options that provide a variety of ways to customize the performance and appearance of the editor.

Data Editor Options
This section describes the Data Editor options.

Schema Comparison Options
This section describes schema comparison options.

Generate Scripts Options
This section describes DDL generation options.

Query Execution Options
This section provides a variety of ways to customize the performance of query execution.


Environment Options

You can use the pages in the Environment folder in the Options dialog box to set how certain elements of the Schema Compare for SQL Server display and behave. You can access the Environment pages by clicking Options on the Tools menu, and then clicking Environment.

ExpandedToggleIcon(9x12) In This Section

General, Environment, Options Dialog Box
Lists general environment preferences and explains them.

Keyboard, Environment, Options Dialog Box
Describes the tab where you can customize shortcut keys.

Output, Environment Options Dialog Box
Describes the tab where you can customize application output.

Documents, Environment, Options Dialog Box
Describes the tab where you can customize the document view layout.

Web Browser, Environment, Options Dialog Box
Describes the tab where you can set Schema Compare for SQL Server web browser options.

ExpandedToggleIcon(9x12) See Also

Options

Text Editor Options


General, Environment, Options Dialog Box

Use this page of the Options dialog box to change settings for the Schema Compare for SQL Server. You can access the Options dialog box by clicking Options on the Tools menu and then selecting the General page in the Environment folder.

Settings

At startup
Select what to do when Schema Compare for SQL Server starts up.

Show Startup page
A Start Up page will be opened at startup.
Load Last Opened Project
Last opened project will be loaded at startup.
Create New SQL Document
A new empty SQL document will be created at startup.

Show Empty Environment
No documents or projects will be opened or created at startup.

Check updates on startup once a week
Select this option so that dbForge Schema Compare for SQL Server will check if any updates are available for the product every week

Show splash screen on startup
Clear to turn off splash screen displaying.

Stop script execution on the first error
If selected, script execution will be stopped when execution encounters the first error.

Show status bar
Determines whether status bar should be visible.

Open object editors in the same window
If selected, all new object editors will be opened "unpinned". That means, when opening a database object with already opened database object of the same type, object editor of already opened object will be replaced with object editor of the opening object. This option doesn't work with stored procedures and functions.

Open source objects in the same window
If selected, all new source object editors will be opened "unpinned". This option works with stored procedures and functions.

Display X items shown in Window menu
Customizes the number of windows that appear in the Windows list of the Window menu. Type a number between 1 and 24. By default, the number is 10.

Display X items shown in recently used lists
Customizes the number of most recently used projects and files that appear on the File menu. Type a number between 1 and 24. By default, the number is 10. This is an easy way to retrieve recently used projects and files.

ExpandedToggleIcon(9x12) See Also

Environment Options

Keyboard, Environment, Options Dialog Box


Keyboard, Environment, Options Dialog Box

The Keyboard page of the Options dialog box allows you to customize the keyboard scheme for the Schema Compare for SQL Server. Use this option to set shortcut keys for frequently used commands or to establish your favorite binding for a particular command. To access this dialog box, select Options from the Tools menu and choosing the Keyboard page from the Environment folder.

ExpandedToggleIcon(9x12) Options

Keyboard mapping scheme
Lists the set of all available collections of shortcut keys:

· Embarcadero RAD Studio
· Microsoft Visual Studio
· Eclipse
· Quest Software SQL Navigator
· Quest Software Toad
· Oracle SQL Developer
· Microsoft SQL Server Management Studio

To load a specific scheme, select it from the list. When you are ready to leave the options dialog box, click OK.

Reset
Resets all shortcuts to the defaults of the selected keyboard mapping scheme.

Show commands containing
Specifies which command is selected and shows a list of all commands available in the Schema Compare for SQL Server that contain the specified characters, or all commands if this edit box is empty. As you type a complete word, the result list displays all entries containing the typed word. For example, you can enter save, locate the command, File.Save, and see that the associated shortcut is CTRL+S.

Shortcut(s) for selected command
Lists mapped shortcuts for the command selected in the Show commands containing list. Some commands have more than one mapped shortcut.

Remove
Removes the selected shortcut key combination.

Use new shortcut in
Specifies the scope of the shortcut key. For example, you can use the shortcut key globally in the Schema Compare for SQL Server or only within a specific context (or window); Global is the default setting. If you choose a specific context, the shortcut key remains in effect only while the context is active. If you choose Global, the shortcut key works in any active window in the Schema Compare for SQL Server, unless the same shortcut is mapped in another editor, in which case the editor overrides the shortcut.

Press shortcut key(s)
Allows you to press a key combination to be used for the currently selected command. You must use one or more modifier keys such as CTRL, ALT, or SHIFT. The modifier keys appear in the order in which you press them. For example, pressing CRTL, then SHIFT, and then F2 creates the shortcut key, CTRL+SHIFT+F2. You can enter one or two key combinations that include a modifier key. For example, you can enter CTRL+Y, or enter CTRL+Y, CTRL+W. Use BACKSPACE to delete the whole shortcut key combination at one time.

note Note

The following keys cannot be assigned: ALT, SHIFT, or CTRL without another key; ESC, PRINT SCRN/SYS RQ, SCROLL LOCK, PAUSE/BREAK, TAB, CAPS LOCK, INSERT, HOME, END, PAGE UP, PAGE DOWN, Windows logo keys, Application key, any of the ARROW keys, or ENTER; NUM LOCK, DEL, or CLEAR on the numeric keypad; or CTRL+ALT+DELETE.

Assign
Binds the new key combination to the selected command in the Keyboard mapping scheme displayed. The new assignment is added to the Shortcut(s) for selected command list and you can specify multiple key combinations for one command. This button is active after you type a key combination in the Press shortcut key(s) box. If you attempt to bind a key in the [Default Settings] scheme, you are prompted to make a copy of the scheme and give it a name.

note Note

Changes made using the Assign button are not canceled if you click the Cancel button.

Shortcut currently used by
Displays the command to which the key combination is currently assigned. Appears only when you assign a key or key combination that is already assigned. To replace the shortcut with a custom shortcut key combination you must define a new Keyboard mapping scheme.

ExpandedToggleIcon(9x12) See Also

Environment Options

Output, Environment, Options Dialog Box


Output, Environment, Options Dialog Box

Use Options window to adjust Schema Compare for SQL Server behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the Output page from the Environment folder.

ExpandedToggleIcon(9x12) Settings

Turn on 'Redirect Data to Output Window' by default
Enables displaying of selected data as text in the Output window instead of the Data view for every SQL document by default.

Show time for output events
If selected, the time stamp is added at the beginning of every line in the Output window.

ExpandedToggleIcon(9x12) SQL Log

Write queries sent by program to the SQL Log
Allows to log all the queries sent by program to a database.

ExpandedToggleIcon(9x12) Event Tracing

Log application errors
Check this option to write all errors and processes that took place during the application work to a file. This file is placed in the directory with the application executable file.

It can help a user to provide more detailed information on the encountered problem to the developers so that they are able to reproduce and fix the problem faster. If you have encountered an error and are going to send us an error report, this file will be attached to the letter with the error report.

Delete application log after closing
Clear this checkbox if you want the application log be available after application closing.

ExpandedToggleIcon(9x12) See Also

Environment Options

Documents, Environment, Options Dialog Box


Documents, Environment, Options Dialog Box

Use the Options window to adjust the Schema Compare for SQL Server behavior to your needs.

ExpandedToggleIcon(9x12) In This Section

SQL Documents Dialog Box
Describes options available for SQL document view.

Categories
Displays the list of available document categories.

Restore
Use the topic to customize the automatic files saving.

ExpandedToggleIcon(9x12) See Also

Environment Options

Web Browser, Environment, Options Dialog Box


SQL Documents Dialog Box

The SQL Documents subsection of Environment Documents of the Options window contains the following options:

ExpandedToggleIcon(9x12) Default SQL Document View Layout

One main document view
All views corresponding to the opened SQL document are visible. You can activate the needed view by clicking the corresponding tabs.

All views tabbed
Only one view corresponding to the document is visible, all others are tabbed. Click the needed tab for the corresponding view to be shown on the screen.

note Note

You can also change the document view layout from the popup menu that can be called from the lower part of the document view.

Show Data view for every SQL document
Check this option for the Data view tab to be displayed for every opened or newly created SQL document.

Activate Data editor after query execution
Check this option to focus on the Data editor after a query is executed. If this option is unchecked, focus stays in the Text view.

Redirect data to Data window if Data view is closed
If this option is checked, data returned after query execution is displayed into the Data window if the Data view is closed.

ExpandedToggleIcon(9x12) See Also

Documents, Environment, Options Dialog Box

Categories


Categories

Document categories
Displays the list of available document categories.

Name
Category name.

Shape
Category shape.

Color
Category color.

New Category
Adds a new category to the list.

Delete Category
Deletes a selected category.

Reset to Default
Resets all changes to defaults.

ExpandedToggleIcon(9x12) See Also

Environment Options

Restore


Restore

Use the topic to customize the automatic files saving. It will allow you to return to the documents which you forgot to save during the last session.

Settings

Save restore information every ... min
Set the time after which the data will be saved automatically.

Restorable file types

SQL files (*.sql)
If checked, the *.sql files will be saved automatically.

Text files (*.txt)
If checked, the text files will be saved automatically.

XML files (*.xml)
If checked, the XML files will be saved automatically.

Schema comparison files (*.scomp)
If checked, the data comparison files will be saved automatically.

ExpandedToggleIcon(9x12) See Also

Documents, Environment, Options Dialog Box

Web Browser, Environment, Options Dialog Box


Web Browser, Environment, Options Dialog Box

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the Web Browser page from the Environment folder.

ExpandedToggleIcon(9x12) Settings

Home page
Set here a home page for Schema Compare for SQL Server web browser. It opens when you call Schema Compare for SQL Server web browser window or click Home button on Web toolbar.

Use default
Use the product home page.

Search page
Set here a search page for Schema Compare for SQL Server web browser. It opens when you click Online Search button on Web toolbar.

Use default
Use Google as a search page.

ExpandedToggleIcon(9x12) See Also

Environment Options

Options


Text Editor Options

The Text Editor options in the Options dialog box provide a variety of ways to customize the performance and appearance of the editor.

ExpandedToggleIcon(9x12) In This Section

General, Text Editor, Options Dialog Box
This dialog box lets you change global settings for the Schema Compare for SQL Server.

Tabs, Text Editor, Options Dialog Box
This dialog box allows you to change the default behavior of the Code Editor.

Font & Colors, Text Editor, Options Dialog Box
This dialog box allows you to change the default setting for a custom font and color scheme for various user interface elements.

Printing, Text Editor, Options Dialog Box
This dialog box allows you to change default printing options.

Advanced, Text Editor, Options Dialog Box
This dialog box describes how to set up tabulation and indenting editor preferences.

Code Completion
This section describes statement completion options available in Schema Compare for SQL Server.

Formatting
This section describes code formatting options available in Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) See Also

Options

Data Editor Options


General, Text Editor, Options Dialog Box

This dialog box lets you change global settings for the Code and Text. To display this dialog box, click Options on the Tools menu, expand the Text Editor node, and then click General.

Settings

Virtual whitespace
When selected, it allows you to move the cursor beyond the physical end of a line of text into character spaces that do not exist. If you move your cursor out into this area and begin typing, the void between your current position and the end of the last word is automatically filled with space characters. When this setting is not selected, you cannot move the cursor beyond the last character in a line.

Bracket matching
If selected, dbForge Schema Compare for SQL Server finds a corresponding bracket for the one that is currently near the cursor.

Display

Line numbers
Displays line numbers in the left of Text view of a document.

Indicator margin
Reveals the indicator margin on the left of Text view of a document.

Vertical scroll bar
Shows or hides a vertical scrollbar in Text view of a document.

Horizontal scrollbar
Shows or hides horizontal scrollbar in Text view of a document.
Navigation bar
Check this option to enable a navigation bar. It can be useful if you have a large amount of CREATE TABLE instances in your script and you need to navigate between columns and tables in it.
Hide if empty
Check this option to show navigation bar only when two or more objects are created. If only one object is created in a SQL statement the bar remains hidden as it is not needed.

ExpandedToggleIcon(9x12) See Also

Tabs, Text Editor, Options Dialog Box


Tabs, Text Editor, Options Dialog Box

This dialog box allows you to change the default behavior of the Code Editor. To display this dialog box, click Options on the Tools menu, expand the Text Editor node, and then click Tabs.

ExpandedToggleIcon(9x12) Indenting

None
When selected, no automatic indenting occurs when you press ENTER to move to a new line of text, and the cursor is placed at the first column of the next line.

Block
When selected and you press ENTER, the new line of text is automatically indented to the same tab stop as the line preceding it.

Smart
When selected, new lines of text are automatically indented taking into account selecting formatting options.

ExpandedToggleIcon(9x12) Tabs

Tab size
Sets the distance in spaces between tab stops. The default is 2 spaces.

Indent size
Sets the size in spaces of an automatic indentation. The default is 2 spaces. Tab characters, space characters, or both will be inserted to fill the specified size.

Insert spaces
When selected, indent operations insert only space characters, not TAB characters. If the Indent size is set to 5, for example, then five space characters are inserted whenever you press the TAB key or the Increase Indent button on the Formatting toolbar.

Keep tabs
When selected, indent operations insert as many TAB characters as possible. Each TAB character fills the number of spaces specified in Tab size. If the Indent size is not an even multiple of the Tab size, space characters are added to fill in the difference.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Font & Colors, Text Editor, Options Dialog Box


Font & Colors, Text Editor, Options Dialog Box

The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for various user interface elements in the Schema Compare for SQL Server. To access this dialog box, click Options on the Tools menu, and then select the Font &Colors page in the Text Editor folder.

Options

Font (bold type indicates fixed-width fonts)
Lists all the fonts installed on your system. Fixed fonts appear in bold.

Size
Specify the size of the font for the selected display item here.

Use Defaults
Resets text editor font and color settings to the default values.

Display items
Select a display item here to change its font and color settings.

Brace Matching
Matching braces, for example ().
Built-in Data Type
Built-in data type, for example, INT or VARCHAR.
Built-in Function
Built-in function, for example, COUNT.
Call Return
Source statement that indicates call return points when context is switched to a non-top stack frame when debugging.
Comment
Code comment.
Current Statement
Current code line when debugging.
Identifier
Identifier, such as database object name, stored procedure parameter, etc.
Keyword
SQL keyword.
Number
Number.
Operator
Operators and separators (, ;: * + = / - . (<>!~&^%\|{})).
Plain Text
Text, when editing a file as text.
Program Block Label
Labels.
Region
Region or endregion command.
Select Marker
Frame around the select statements.
Selected Line
Line, selected in the Find Results window.
String
SQL string constant.
Visible Whitespace
White space characters when View White Space is turned on.
XML Attribute Name
Tag attribute in XML editor.
XML Comment
Comment in XML editor.
XML Indent
Indent in XML editor.
XML Number
Number in XML editor.
XML Special Tag
Special XML tag.
XML String
String constant in XML editor.
XML Tag Name
XML attribute name.

Bold
Select it to display the text of selected display items in bold.

Italic
Select it to display the text of selected display items in italic.

Item foreground
Font color of a selected display item.

Item background
Background color of a selected display item.

Sample
Sample of a display item appearance.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Printing, Text Editor, Options Dialog Box


Printing, Text Editor, Options Dialog Box

This dialog box allows you to change default printing options. To access this dialog box, click Options on the Tools menu, and then select the Printing page in the Text Editor folder.

ExpandedToggleIcon(9x12) Settings

Print header
Check it to print the document name.

Print line numbers
Check it to print line numbers in the document.

Print white space
Check it to print white space symbols, tabulation symbols, and symbols of line breaks.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Advanced, Text Editor Options Dialog Box


Advanced, Text Editor, Options Dialog Box

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu.

The Advanced section of the Text Editor options allows you to setup outlining and SELECT statement highlighting. You can use the following options:

ExpandedToggleIcon(9x12) Outlining

Enter outlining mode when files open
If selected, outlining is enabled when you open a file.

Collapse --region blocks when files open
If selected, --region blocks in an opened file will be collapsed.

ExpandedToggleIcon(9x12) Syntax highlighting

Highlight SELECT statements
If selected, a frame will be drawn around SELECT statements.

Underline errors in the editor
If selected, syntax errors will be underlined with a red curved line.

ExpandedToggleIcon(9x12) Editor performance

Enable syntax highlight
Clear a check box to disable syntax highlight.

Max script size
Specify max script size for syntax highlight support.

Max script size
Specify max script size for code completion, navigation and refactoring support.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Code Completion Options


Code Completion Options

Code Completion

This section explains statement completion options provided in the Options window.

The Code Completion section of the Text Editor options contains the following subsections:

ExpandedToggleIcon(9x12) In This Section

General, Code Completion Text Editor Options Dialog Box
Lists general code completion preferences and explains them.

Advanced, Code Completion Text Editor Options Dialog Box
Describes advanced code completion options.

List Members, Code Completion Text Editor Options Dialog Box
Describes options for list members.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Formatting


General, Code Completion Text Editor Options Dialog Box

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu.

The General subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code formatting when typing code. Use the following options:

Enable Code Completion
Select to toggle automatic code completion. Selected by default.

Auto-list members
Toggles the display of valid databases, tables, columns, and other database objects in the suggestion box when you are typing. Selected by default.

Auto Parameter Info
Toggles the display of the Parameter Info hint when the left bracket is typed after the procedure or object method name. Selected by default.

Automatically trigger after ... millisec
Defines a delay used by dbForge SQL Complete to show the suggestion box after you stop typing. To change the default value, use the arrow buttons in the field or enter the value.

Highlight Occurrences
Toggles identifier occurrence highlighting.

ExpandedToggleIcon(9x12) See Also

Code Completion Options

Advanced, Code Completion Text Editor Options


Advanced, Code Completion Text Editor Options

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu.

The Advanced subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code completion when typing code. The following options are available:

Qualify column name with table alias
Defines that column names should be committed with table alias.

Qualify column name (no table alias)
Defines how column names should be committed.

With table name
The name of the table the column belongs to is specified before the column name: TableName.ColumnName.
With schema name and table name
The name of the table the column belongs to and the schema name are specified before the column name: SchemaName.TableName.ColumnName.

Reverse order in 'JOIN'-condition
Applies reverse order in JOIN conditions.

Add parentheses when inserting a function
If the option is checked, parentheses are added when you insert functions.

Quote identifiers
Choose the way of identifying a quote here.

Always
If the option is enabled, all the identifiers, aliases, and database objects will be enclosed in parentheses.
If an identifier concurs with a keyword
If the option is enabled, all the identifiers, aliases, and database objects will be enclosed in parentheses, in case their names concur with reserved keywords or system objects.
If quotes are required
If the option is enabled, all the identifiers, aliases, and database objects will be enclosed in parentheses, if required. For instance, if a column name is declared with white spaces.

ExpandedToggleIcon(9x12) See Also

Code Completion Options

List Members, Code Completion Text Editor Options


List Members, Code Completion Text Editor Options

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu.

The List Members subsection of the Code Completion section of the Text Editor options allows you to setup options for automatic code completion when typing code. The following options are available:

ExpandedToggleIcon(9x12) Settings

Sort keywords by relevance
When selected, keywords in the suggestion box will be sorted to display the most relevant at the top of the list. It is selected by default.

ExpandedToggleIcon(9x12) Filtering Rule

These options define how to filter the list of suggestions in the suggestion box. If neither of them is selected, Schema Compare for SQL Server will display only suggestions that start with the typed character(s).

By Matching
When selected, Schema Compare for SQL Server filters the list of suggestions to display those that start with the typed character(s) or contain it in the top of the list.

Camel Case
When selected, Schema Compare for SQL Server filters the list of suggestions to display those that are compound word which elements are joined without spaces and start with the typed characters.

ExpandedToggleIcon(9x12) Commit selection in completion list by typing

When you type any of the symbols specified below, Schema Compare for SQL Server will insert a highlighted suggestion from the suggestion box into code.

Tab
The highlighted suggestion will be inserted when you press the TAB key.

Whitespace
The highlighted suggestion will be inserted when you press the SPACE key.

Following characters:
Enter characters here, and the highlighted suggestion will be inserted when you type any of the specified characters.

Add new line on enter at end of fully typed word
Cursor will be moved to the new line if you type a word completely and press ENTER.

ExpandedToggleIcon(9x12) See Also

Code Completion Options


Formatting

This section explains code formatting options provided in the Options window. The Formatting section of the Text Editor options contains the following subsections:

ExpandedToggleIcon(9x12) In This Section

General, Formatting, Text Editor Options Dialog Box
Lists general code formatting preferences and explains them.

Profiles, Formatting, Text Editor Options Dialog Box
Describes options to customize case formatting profiles.

ExpandedToggleIcon(9x12) See Also

Text Editor Options

Data Editor Options


General, Formatting, Text Editor Options Dialog Box

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu, expand the Text Editor node, and in the Formatting node click General.

ExpandedToggleIcon(9x12) Settings

The General subsection of the Text Editor Formatting section allows you to setup options for automatic code formatting when typing code. You can use the following options:

Automatically format on paste
If checked, pasted code will be automatically formatted. Selected by default.

Automatically format completed statement on delimiter
If checked, code will be automatically formatted when the delimiter is entered (semicolon or backslash). Selected by default.

Automatically format while typing
If the option is checked, code formatting while typing statement elements in SQL editor is supported. Start typing first letters for the required statement, and press TAB or a space to see the result. All objects and keywords are formatted in correspondence with formatting active profile settings. By default, the option is selected.

Right Margin
Line breaks will be inserted automatically after the Right Margin number of characters on a line. 80 is by default.

Put syntax errors to Output window
Select it if you want syntax errors to be redirected to the Output window.

Show syntax error notification window
Select it if you want the syntax error notification window to appear upon formatting a document.

Dictionary file
Specify file with dictionary to adjust formatting to your needs. You can use default dictionary or create a new one. Also you can modify the existing dictionary. This dictionary is used to format identifiers when the Text Case -> Identifier Case option is set to Initial Caps each word.

Available prefixes
Specify prefixes here. If one of the prefixes is used in a word, the application looks in the dictionary for the word that is used after the prefix. If the word is found, its first letter is written in uppercase. These prefixes can be used to format identifiers when the Text Case -> Identifier Case option is set to Initial Caps each word.

Reset Page Defaults
Resets all options on this page to their default values.

ExpandedToggleIcon(9x12) See Also

Formatting

Text Editor Options


Profiles, Formatting, Text Editor Options Dialog Box

Use the Profiles option to customize code formatting provided by Schema Compare for SQL Server. To access it, go to Tools menu, select Options, and then click Text Editor. Navigating to Formatting, click Profiles.

ExpandedToggleIcon(9x12) Formatting Profiles

Select a profile from the table.

Name
Profile name.

File
Profile file name.

Edit Profile...
Opens the Edit Profile Options window that allows editing options available in the profile.

New Profile...
Opens the New Profile window to create a new formatting profile.

Activate
Click to activate the selected profile.

Show in Folder
Opens folder containing the selected profile.

ExpandedToggleIcon(9x12) Context Menu

Edit Profile
Click to open the Edit Profile window.

Reset To Defaults
Click to reset settings to the default values.

Activate
Activates the selected profile.

Rename
Click to change the profile name.

Show In Folder
Opens folder containing the file in Windows Explorer.

Copy File Path
Copies file path to the clipboard.

Delete
Click to delete selected formatting profile.

ExpandedToggleIcon(9x12) See Also

Formatting

Text Editor Options


Edit Profile, Formatting Options

Use this window to edit formatting options in the selected formatting profile.

ExpandedToggleIcon(9x12) Edit Profile Window

Filter
Allows to quick search the needed options/option groups.

collapse-all Collapse/Expand all option groups
Click to expand/collapse the option groups tree.

Show white spaces button
Click to toggle white spaces in the formatting profile editor.

Show Original Sample
Click to restore the code sample to its original state.

Format Text
Formats code according to the selected options.

Options tree
Includes various code formatting options. Allows customizing default text formatting options the way user likes.

Code field
Shows how the code looks like after choosing the corresponding text formatting options.

ExpandedToggleIcon(9x12) Edit Profile Context Menu

Format Selection
Formats selected code according to the chosen options.

Cut
Cuts selected text and places it to the clipboard.

Copy
Copies selected text to the clipboard.

Paste
Pastes the clipboard content into the cursor position.

ExpandedToggleIcon(9x12) See Also

Profiles, Formatting, Text Editor Options Dialog Box

New Profile, Formatting Options


New Profile, Formatting Options

Use this window to create and add new formatting profile to the list of profiles.

ExpandedToggleIcon(9x12) New Profile Window

Name
Specify the new profile name here.

Copy settings from
Select an existing profile to copy settings from.

File Path
Set the path to save your new formatting profile.

Set Active
Activate this profile in the Profiles, Options Dialog Box.

ExpandedToggleIcon(9x12) See Also

Profiles, Formatting, Text Editor Options Dialog Box

Data Editor Options


Data Editor Options

The Data Editor options in the Options dialog box provide a variety of ways to customize the performance and appearance of the editor.

ExpandedToggleIcon(9x12) In This Section

General, Data Editor, Options Dialog Box
Use the Options window to adjust the products behavior to your needs.

Font & Colors, Data Editor, Options Dialog Box
The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for Data Editor.

Printing, Data Editor, Options Dialog Box
This dialog box allows you to change default printing options.

Formatting, Data Editor, Options Dialog Box
Use the Options window to adjust the products behavior to your needs.

ExpandedToggleIcon(9x12) See Also

Options

Schema Comparison Options


General, Data Editor, Options Dialog Box

Use the Options window to adjust the products behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the General page from the Data Editor folder.

The Data Editor General section of the Options window contains the following options:

ExpandedToggleIcon(9x12) Settings

Automatically adjust column width
Automatically adjusts column width for every data grid.

Use cached updates mode by default
If selected, cached updates mode will be enabled by default in data view of every SQL document created.

Use paginal mode by default
If selected, paginal mode will be enabled by default in data view of every SQL document created.

Initial page size
Default page record count for paginal mode for data view.

Use auto-search mode by default
Activates auto-search in Data view by default.

Show row numbers
Adds a column with row numbers (#) to the data editor grid.

ExpandedToggleIcon(9x12) Data Editing

Open Data Editor in the editing mode
Select to open the Data Editor is opened in the editing mode by default.

Open Data Editor in the read-only mode
Select to open the Data Editor is opened in the read-only mode by default.

Show a dialog window to choose a mode
Select to invoke a dialog window asking to choose the mode in which Data Editor should be opened (editing or read-only).

ExpandedToggleIcon(9x12) See Also

Data Editor

Font & Colors, Data Editor, Options Dialog Box


Font & Colors, Data Editor, Options Dialog Box

The Fonts and Colors page of the Options dialog box lets you establish a custom font and color scheme for Data Editor. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Font &Colors page in the Data Editor folder.

ExpandedToggleIcon(9x12) Options

Data Editor Font & Colors section of the Options window contains the following options:

Font

Select a font for the selected display item here.

Size

Specify a font size for the selected display item here.

Use Defaults

Click this button to reset specified font and color settings to the default values.

Display item

Select a display item here to change its background and foreground color settings.

Item foreground

Select a font color for the selected display item.

Item background

Select a background color for the selected display item.

Sample

Preview the display item appearance here.

ExpandedToggleIcon(9x12) See Also

Data Editor

Printing, Data Editor, Options Dialog Box


Printing, Data Editor, Options Dialog Box

This dialog box allows you to change default printing options. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Printing page in the Data Editor folder.

ExpandedToggleIcon(9x12) General

Auto width

Select to fit the printed data to the page width.

ExpandedToggleIcon(9x12) Grid

Print horizontal lines

Select to print grid horizontal lines.

Print vertical lines

Select to print grid vertical lines.

ExpandedToggleIcon(9x12) Card

Print card captions

Select to prints card captions.

Print empty fields

Select to prints card empty fields.

ExpandedToggleIcon(9x12) See Also

Data Editor

Formatting, Data Editor, Options Dialog Box


Formatting, Data Editor, Options Dialog Box

Use the Options window to adjust the products behavior to your needs. You can access this dialog box by clicking Options on the Tools menu, and then selecting the Formatting page in the Data Editor folder.

ExpandedToggleIcon(9x12) DateTime Format

Data type

Select either Date or DateTime format here.

Edit format

Set the datetime format here. It can be one of the predefined formats or custom format. Predefined formats are described below. The following table contains all available format specifiers and their description.

Format Specifier

Description

d

A placeholder for the day of the month. If the day is a single digit only (1-9), then it's displayed as a single digit.

Note that if the 'd' specifier is used alone, without other custom specifiers, it's interpreted as the standard mask (short date pattern). If the 'd' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

dd

A placeholder for the day of the month. If the day is a single digit only (1-9), it is formatted with a preceding 0 (01-09).

ddd

Displays the abbreviated name of the current day.

The value represented by this specifier cannot be edited.

dddd (plus any number of additional "d" characters)

Displays the full name of the current day.

The value represented by this specifier cannot be edited.

f

A placeholder for seconds fractions represented in one digit.

Note that if the 'f' specifier is used alone without other custom specifiers, it's interpreted as the standard mask (full date/time pattern ). If the 'f' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

ff

A placeholder for seconds fractions represented in two digits.

fff

A placeholder for seconds fractions represented in three digits.

ffff

Displays seconds fractions represented in four digits.

The value represented by this specifier cannot be edited.

fffff

Displays seconds fractions represented in five digits.

The value represented by this specifier cannot be edited.

ffffff

Displays seconds fractions represented in six digits.

The value represented by this specifier cannot be edited.

fffffff

Displays seconds fractions represented in seven digits.

The value represented by this specifier cannot be edited.

g

Displays the era (A.D. for example) for the current date/time value.

The value represented by this specifier cannot be edited.

h

A placeholder for the hour part of the date/time value in the range 1-12.

hh

A placeholder for the hour part of the date/time value in the range 1-12. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

H

A placeholder for the hour part of the date/time value in the range 0-23.

HH

A placeholder for the hour part of the date/time value in the range 0-23. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

m

A placeholder for the minutes of the date/time value in the range 0-59.

mm

A placeholder for the minutes of the date/time value in the range 0-59. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

M

A placeholder for the month in this position, measured as a number in the range 1-12.

MM

A placeholder for the month in this position, measured as a number in the range 1-12. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

MMM

A placeholder for the abbreviated name of the month.

MMMM

A placeholder for the full name of the month.

s

A placeholder for the seconds part of the date/time value in the range 0-59.

Note that if the 's' specifier is used alone without other custom specifiers it's interpreted as the standard mask (sortable date/time pattern). If the 's' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

ss

A placeholder for the seconds part of the date/time value in the range 0-59. This pattern inserts two placeholders to enter a value. If a single digit is entered it's preceded with a '0'.

t

A placeholder for the first character of the A.M./P.M. designator of the date/time value.

Note that if the 't' specifier is used alone without other custom specifiers it's interpreted as the standard mask (short time pattern). If the 't' specifier is passed with other custom specifiers or the '%' character, it's interpreted as a custom mask specifier.

tt

A placeholder for the A.M./P.M. designator of the date/time value.

y

A placeholder for entering the last two digits of the year of the date/time value.

Note that if the 'y' specifier is used alone without other custom specifiers, it's interpreted as the standard mask (year month pattern). If the 'y' specifier is passed with other custom specifiers or the '%' character it's interpreted as a custom mask specifier.

yy

A placeholder for entering the last two digits of the year of the date/time value. This pattern inserts two placeholders to enter a value. If a single digit is entered it is preceded with a '0'.

yyyy

A placeholder for entering the year part of the date/time value including the century.

z

Displays the time zone offset for the system's current time zone in whole hours only. The offset is always displayed with a leading sign (zero is displayed as "+0"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12 to +13. If the offset is a single digit (0-9), it's displayed as a single digit with an appropriate leading sign.

The value represented by this specifier cannot be edited.

zz

Displays the time zone offset for the system's current time zone in whole hours only. The offset is always displayed with a leading or trailing sign (zero is displayed as "+00"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12 to +13. If the offset is a single digit (0-9), it's formatted with a preceding 0 (01-09) with an appropriate leading sign.

The value represented by this specifier cannot be edited.

zzz

Displays the time zone offset for the system's current time zone in hours and minutes. The offset is always displayed with a leading or trailing sign (zero is displayed as "+00:00"), indicating how many hours ahead of Greenwich mean time (+) or hours behind Greenwich mean time (-) the current time zone is. The range of values is -12:00 to +13:00. If the offset is a single digit (0-9), it's formatted with a preceding 0 (01-09) with an appropriate leading sign.

The value represented by this specifier cannot be edited.

:

Time separator.

/

Date separator. The actual date separator is determined by the DateTimeFormatInfo.DateSeparator property of the current culture.

"abc" or 'abc'

Quoted string. Inserts the string enclosed with single or double quotes literally to the edit box. The string cannot be edited.

%c

Where c is one of the standard mask specifiers, makes the specifier be interpreted as a custom mask specifier.

Note that if a mask specifier is used alone as a single character, it's interpreted as a standard mask specifier. Only mask specifiers consisting of two or more characters are interpreted as custom specifiers. In order to use a custom specifier on its own which matches one of the standard specifiers it should be preceded with the % character.

\c

The backslash is used as the escape character. It inserts the following character literally to the edit box.

Any other characters.

The other characters are inserted to the edit box literally.

ExpandedToggleIcon(9x12) Predefined Formats

You can choose one of the predefined datetime formats here. The following table contains their descriptions and samples.

Standard Mask | Name | Sample. Culture: English (USA)
d | Short date | 8/20/2007
D | Long date | Monday, August 20, 2007
t | Short time | 10:23 AM
T | Long time | 10:23:35 AM
f | Full date/time (short time) | Monday, August 20, 2007 10:23 AM
F | Full date/time (long time) | Monday, August 20, 2007 10:23:35 AM
g | General date/time (short time) | 8/20/2007 10:23 AM
G | General date/time (long time) | 8/20/2007 10:23:35 AM
M or m | Month day | August 20
R or r | RFC1123 | Mon, 20 Aug 2007 10:23:35 GMT
s | Sortable date/time | 2007-08-20T10:23:35
u | Universal sortable date/time | 2007-08-20 10:23:35Z
Y or y | Year month | August, 2007

ExpandedToggleIcon(9x12) See Also

Data Editor

Options


Schema Comparison Options

This section describes schema comparison options.

ExpandedToggleIcon(9x12) In This Section

General, Schema Comparison Options Dialog Box
Describes the tab where you can customize text comparer settings for schema comparison.

Synchronization, Schema Comparison, Options Dialog Box
Choose the editor where to open the synchronization script in.

ExpandedToggleIcon(9x12) See Also

Options

Reference


General, Schema Comparison Options Dialog Box

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, go to the Tools menu, and then select Options... Then go to the Schema Comparison node.

The General section of the Schema Comparison node contains the following options:

Text Comparer

Internal
Use internal Schema Compare for SQL Server comparer. Text comparer will be displayed at the bottom of the Schema Comparison Document.
Araxis Merge
Use Araxis Merge. This option is available only if Araxis Merge 2001 or higher is installed.
Custom
Use a custom comparer. You should set Comparer Location and Command Line Arguments to use this option.
Comparer Location
Specify the comparer executable file here.
Command Line Arguments
Specify command line arguments for the comparer call. You may use the following predefined arguments:
· %file1% - full name with a path of the first file to compare.
· %file2% - full name with a path of the second file to compare.
· %title1% - title for the first comparison pane.
· %title2% - title for the second comparison pane.

Enable 'Sort columns and constraints alphabetically'
Click the option to sort columns and constraints in alphabetical order.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Options

Options


Synchronization, Schema Comparison, Options Dialog Box

Choose the editor where to open the synchronization script in.

SQL Editor

Internal
Synchronization script will be opened in the internal dbForge Schema Compare for SQL Server editor.

Microsoft SQL Server Management Studio 2005
Synchronization script will be opened in the Microsoft SQL Server Management Studio 2005 editor.

Microsoft SQL Server Management Studio 2008
Synchronization script will be opened in the Microsoft SQL Server Management Studio 2008 editor.

Microsoft SQL Server Management Studio 2012
Synchronization script will be opened in the Microsoft SQL Server Management Studio 2012 editor.

Microsoft SQL Server Management Studio 2014
Synchronization script will be opened in the Microsoft SQL Server Management Studio 2014 editor.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Options

General, Schema Comparison Options Dialog Box


Generate Scripts Options

This section describes DDL generation options.

ExpandedToggleIcon(9x12) In This Section

General, Generate Scripts Options
Describes general options for DDL generating.

ExpandedToggleIcon(9x12) See Also

Options

Query Execution Options


General, Generate Scripts Options

Use the Options window to adjust Schema Compare for SQL Server behavior to your needs. To open it, select Options from the Tools menu. Then go to the Generate Scripts node.

Settings

Generate Scripts

Find
Use the search filter to find the required option. To substitute the characters, use the "_" symbol.

Common

Check for object existence
Check whether the object already exists on the server.

Generate comments in the script
Select to insert comments in the script.

Script authorization
Includes script authorization clauses.

Script collation
Includes collation information in the script.

Script default constraints
Includes default constraints and schema defaults.

Script extended properties
If checked, extended properties for database objects are added to the script.

Script logins
Includes all logins available on the server. Passwords will not be included.

Script security permissions
Includes security permissions.

Script statistics
Includes statistics.

Script USE DATABASE
Generates the USE DATABASE statement.

Tables/Views

Script change tracking
Includes CHANGE_TRACKING clauses and statements when comparing and synchronizing databases.

Script check constraints
Includes CHECK constraints in the script.

Script DATA_COMPRESSION for indexes, primary and unique constraints
When selected, the DATA_COMPRESSION clause is included for indexes, primary and unique key constraints.

Script DML triggers
Includes the CREATE statement for triggers in the tables.

Script foreign keys
Includes the CREATE statement for foreign keys in the tables.

Script full-text search
Includes full-text stop lists, catalogs, and indexes.

Script indexes
Includes the CREATE statement for indexes in the tables.

Script primary keys
Includes the CREATE statement for primary keys in the tables.

Script unique keys
Includes the CREATE statement for unique keys in the tables.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default settings.

My Defaults
Click this button to restore your default settings, previously saved with the Save As My Defaults button.

ExpandedToggleIcon(9x12) See Also

Query Execution Options

Options


Query Execution Options

The Query Execution options in the Options dialog box provide a variety of ways to customize the performance of query execution.

ExpandedToggleIcon(9x12) In This Section

General, Query Execution, Options Dialog Box
Use the Options window to adjust the query execution to your needs.

ExpandedToggleIcon(9x12) See Also

Options

Reference


General, Query Execution, Options Dialog Box

Use the Options window to adjust the query exectution behavior to your needs. To access this dialog box, select Options from the Tools menu and choosing the General page from the Query Execution folder.

The Query Execution General section of the Options window contains the following options:

ExpandedToggleIcon(9x12) General

ROWCOUNT
Causes SQL Server to stop processing the qurey after the specified number of rows are returned.

TEXTSIZE
Specifies the size of varchar (max), varbinary (max), text, ntext and image data returned by a SELECT statement.

ExpandedToggleIcon(9x12) Advanced

ARITHABORT
Select it to terminate a query when an overflow or divide-zero error occurs during query execution.

CONTACT_NULL_YIELDS_NULL
Controls whether concatenation results are treated as null or as empty string values.

DEADLOCK_PRIORITY
Specifies the relative importance that the current session continue processing if it is deadlocked with another session.

LOCK_TIMEOUT
Specifies the number of milliseconds a statement waits for a lock to be released. A value of -1 (default) indicates no time-out period (that is, wait forever). When a wait for a lock exceeds the time-out value, an error is returned. A value of 0 means to not wait at all and return a message as soon, as a lock is encountered.

NOCOUNT
Stops the message that shows the count of the number of rows affected by a Transact-SQL statement or stored procedure form being returned as a part of the result set.

NOEXEC
Complies each query, but does not execute it.

PARSEONLY
Examines the syntax of each Transact-SQL statement and returnes any error messages without compiling or executing the statement.

QUERY_GOVERNOR_COST_LIMIT
Overrides the currently configured query governor cost limit value for the current connection. Specifying 0 (the default) for this option turns off the query governor, and all queries are allowed to run indefinitely. The query governor disallows exectution of any query that has an estimated cost exceeding that value.

SHOWPLAN_TEXT
Causes Microsoft SQL Server not to execute Transact-SQL statements. Instead, SQL Server returns detailed information about how the statements are executed.

STATISTICS IO
Causes SQL Server to display information regarding the amount of disk activity generated by Transact-SQL statements.

STATISTICS TIME
Displays the number of milliseconds required to parse, compile and execute each statement.

TRANSACTION ISOLATION LEVEL
Controls the locking and row versioning behavior of Transact-SQL statements issued by a connection to SQL Server.

ExpandedToggleIcon(9x12) ANSI

ANSI_NULL_DFLT_ON
Modifies the behavior of the session to override default nullability of new columns when the ANSI null default option for the database is false.

ANSI_NULLS
Specifies ISO compliant behavior of the Equals (=) and Not Equal To (<>) comparison operators when they are used with null values in SQL Server.

ANSI_PADDING
Controls the way the column stores values shorter, than the defined size of the column, and the way the column stores values that have trailing blanks in char, varchar, binary and varbinary data.

ANSI_WARNINGS
Specifies ISO standard behavior for several error conditions.

CURSOR_CLOSE_ON_COMMIT
Controls the behavior of the Tranasact-SQL COMMIT TRANSACTION statement. The default value for this settign is OFF. This means that the sevrver will not close cursors when you commit a transaction.

IMPLICIT_TRANSACTIONS
Sets implicit transaction mode for the connection.

QUOTED IDENTIFIER
Causes SQL Server to follow the ISO rules regarding the quotation mark delimiting identifiers and literal strings. Identifiers delimited by double quotation marks can be either Transact-SQL reserved keywords or can contain characters not generally allowed by the Transact-SQL syntax rules for identifiers.

ExpandedToggleIcon(9x12) Other

Reset to Default
Click to reset options on this page to their default values.

ExpandedToggleIcon(9x12) See Also

Query Execution Options

Options


Service Windows

This section describes user interface elements of service windows and dialogs.

ExpandedToggleIcon(9x12) In This Section

Error List
The topic describes the Error List that helps you speed application development.

Output Window
The topic describes the Output window that displays status messages for various features.

Edit Value Dialog Box
The topic describes the Edit Value dialog box.

Save of Read-Only File Dialog Box
The topic describes the Save Prompt dialog box.

Save Prompt Dialog Box
The topic describes the Save of Read-Only File dialog box.

Windows Dialog Box
This topic describes the dialog box that allows you to display, close, and arrange documents that are open in editors and designers.

Product Update Manager
This topic describes the dialog box that allows you to see the update information of dbForge Schema Compare for SQL Server.


Error List

The Error List contains errors, warnings, and messages with their location. To display the Error List, click the Error List button in the View menu. You can double-click error messages to locate errors quickly in multiple files.

The Error List window allows you to:

· Display the Errors, Warnings, and Messages produced as you edit and compile code.
· Find syntax errors
· Double-click any error message entry to open the file where the problem occurs, and move to the error location.
· Filter which entries are displayed, and which columns of information appear for each entry.

ExpandedToggleIcon(9x12) Error List Columns

Icon
Displays error or warning icon for the message.

Description
Display text of error or warning.

Location
Contains name of the document where the error occurred.

Line
Displays the line in the document, where the problem occurs.

Column
Shows the column on the indicated line where the problem begins.

ExpandedToggleIcon(9x12) Error List Shortcut Menu Commands

Goto Error
Opens the document on the place, where the error have occurred.

Copy
Copies the message to the clipboard.

Word Wrap
Enables or disables word wrap in the Description column of Error List.

Clear All
Clears Error List.

ExpandedToggleIcon(9x12) Error List Toolbar

Use the Errors, Warnings, and Messages buttons to select which entries to display.

Errors
Indicates the number of errors in the list. Click to toggle whether errors are displayed.

Warnings
Indicates the number of warnings in the list. Click to toggle whether warnings are displayed.

Messages
Indicates the number of messages in the list. Click to toggle whether messages are displayed.

In Active Document
Allows to review the errors, warnings, and messages either in the current document or in other opened documents.

ExpandedToggleIcon(9x12) See Also

Service Windows

Output Window


Output Window

This window can display status messages for various features. To display the Output window, select Output from the View menu.

Output messages can be divided into several categories. To view messages of the certain category click on its name on the Output window toolbar. If there is no such a name on the toolbar, right-click on the toolbar and select a required name from the shortcut menu.

General
Displays message statuses on general operations.

SQL Log
Displays all SQL queries executed by the application during the current session.

ExpandedToggleIcon(9x12) See Also

Service Windows

Properties Window


Edit Value Dialog Box

Use this dialog box to enter the option value. This dialog can be opened by clicking the button button for corresponding option.

ExpandedToggleIcon(9x12) See Also

Service Windows

Save of Read-Only File Dialog Box


Save of Read-Only File Dialog Box

When an attempt is made to save a read-only file, Save of Read-Only File dialog box appears. It contains following buttons.

Save As
Click to save the file to a different location.

Overwrite
Click to remove file's read-only attribute and replace original file with the changed one.

Cancel
Click to cancel save operation.

ExpandedToggleIcon(9x12) See Also

Service Windows

Save Prompt Dialog Box


Save Prompt Dialog Box

When an attempt is made to close a document or project that is modified and not saved, Save Prompt dialog box appears. It comprises of list, containing modified project and documents, and buttons you can use to proceed. Documents are grouped by project and miscellaneous files.

Yes
Click Yes button to save selected documents and project. If a document is not implicitly named, a Save dialog will appear where you can give a name to the document.

No
Click No to discard all changes made to the documents you are closing.

Cancel
Click Cancel button to return to IDE without closing any of the documents.

ExpandedToggleIcon(9x12) See Also

Service Windows

Windows Dialog Box


Windows Dialog Box

Use this dialog box to activate, save, and close documents. To access this dialog box, in the Window menu, click Windows. Note that you must have at least one document open for this option to be available.

The Windows dialog box allows you to manipulate several documents at single click. The dialog is not closed when you apply any actions, so it is extremely useful when you have many documents currently open.

Windows list
All documents currently open are enumerated in the list. Click on a document's line to select or deselect it. Use Ctrl and Shift keys to perform group operations.

Activate
Click this button to view the selected document without closing the dialog. Available only when single document is selected in the list.

Save
Save selected documents.

Close Window(s)
Close selected documents. If some are not saved, a dialog appears where you can save them if you need.

Close
Close the current dialog.

ExpandedToggleIcon(9x12) See Also

Service Windows

Product Update Manager


Product Update Manager

Use this dialog to see the update information of dbForge Schema Compare for SQL Server.

To open the Product Update Manager dialog window, click the Check for Updates button in the Help menu.

To make Schema Compare for SQL Server check for updates automatically:

1. In the Tools menu, click Options.
2. Expand the Environment folder in the Options window.
3. Check the Check updates on startup once a week check box.

The Product Update Manager window contains the following details:

Product information
This section shows the product's name, version, and file size.

Refresh
Click it to update the product information.

View revision history
Click it to view the history file of dbForge Schema Compare for SQL Server.

Devart authentication
Contains the Login, and the Password text boxes. Allows registered users to pre-save the login credentials.

Save downloaded installation
Check it if you want to save an installation file. Then you should specify the file location in the File name field.

File name
Enter the location of the installation file or click the Browse button to select it in the Browse for Folder dialog.

Browse
Click it to select the installation file location in the Browse for Folder dialog.

Just download a file (do not start installation)
Select it to download the installation file without starting it.

Update
Click it to start downloading the installation file.

Cancel
Click it to close the dialog. Note, this won't stop installation download. To stop downloading, close dbForge Schema Compare for SQL Server.

ExpandedToggleIcon(9x12) See Also

Service Windows

Reference


Schema Compare

This section describes all the wizards, documents, windows and other UI elements related to schema comparison and synchronization processes.

ExpandedToggleIcon(9x12) In This Section

Schema Comparison Wizard
Explains the elements of the Schema Comparison wizard and how to use them.

Schema Synchronization Wizard
Use the Schema Synchronization Wizard to synchronize database differences.

Schema Comparison Document
Describes how to manage object and DDL differences in the Schema Comparison document.

Schema Update Script Window
Describes how to preview synchronization script excerpts for any compared object.

Generate Comparison Report Dialog Box
Describes how to generate comparison reports.

Source Control Repository Properties Dialog Box
Describes fields and options of the Source Control Repository dialog box.

Repository Manager Dialog Box
Describes fields and options of the Repository Manager dialog box.

Create Folder Dialog Box
Describes fields and options of the Create Folder dialog box.

New Workspace Dialog Box
Describes fields and options of the New Workspace dialog box.

Select Database Scripts Folder Dialog Box
Describes fields and options of the Select Database Scripts Folder dialog box.

Database Creation Dilaog Box
Describes fields and options of the Database Creation dialog box.


Schema Comparison Wizard

This section describes the pages of the Schema Comparison wizard and how to use them.

To open the Schema Comparison wizard:

· On the Start page, click New Schema Comparison

or

· On the Standard toolbar click New Schema Comparison.

note Note

Database Explorer is not available in dbForge Data Compare for SQL Server, dbForge Schema Compare for SQL Server, dbForge Event Profiler for SQL Server and dbForge Data Generator for SQL Server.

ExpandedToggleIcon(9x12) In This Section

Source and Target, Schema Comparison Wizard
Tells how to select source and target schemas for comparison.

Options, Schema Comparison Wizard
Explains the options available to tune schema comparison.

Schema Mapping, Schema Comparison Wizard
This page allows you to change the automatic schema mapping. The page is available if Database, Backup or Snapshot is selected as Source or Target.

Table Mapping, Schema Comparison Wizard
This page allows you to change the automatic table mapping. The page is available if Database, Backup or Snapshot is selected as Source or Target.

Object Mapping Dialog Box
This page allows you to change the automatic object mapping.

Column Mapping Dialog Box
This page allows you to change the automatic column mapping.

Object Filter, Schema Comparison Wizard
The topic describes object types filters.

ExpandedToggleIcon(9x12) See Also

Schema Compare

Schema Synchronization Wizard


Source and Target, Schema Comparison Wizard

Use the Source and Target wizard page to select source and target connections and databases for comparison. The page contains the following details:

Type
Select the type of comparison you want to implement: Database, Backup, Scripts Folder, Source Control, Snapshot.

ExpandedToggleIcon(9x12) Database

Connection
Select a Source SQL Server server connection in the left part of the wizard and a Target SQL Server server connection in the right part. In the drop-down lists of the fields you can click the <Manage...> link to open the Connection Manager dialog box. It will help you to create, edit, and delete database connections.

Edit
Click to edit the selected connection.

New
Click to create a new connection for SQL Server server.

SQL Server Version
The version of the database server used in the connection is specified.

Database
Select a server database for comparison from the drop-down list box. In Target, you can select <Create New Database> from the drop-down list to create a new target database with help of the Database Creation dialog box.

ExpandedToggleIcon(9x12) Backup

Add
Click the button to add a backup file to a comparison table below.

Remove
Click the button to delete a backup file from a comparison table.

Clear
Click the button to delete all the files from the comparison table.

Database
The database of a created backup is specified.

Date
The backup creation date is specified.

Server
The server connection name of a created backup is specified.

ExpandedToggleIcon(9x12) Scripts Folder

Database Scripts Folder
Specify the path to the existing scripts folder. You can open an existing scripts folder by clicking the <Browse..> link.

Browse
Click the button to open an existing scripts folder.

New
Click the button to open the Create Scripts Folder or Snapshot dialog box and create a scripts folder for a required database.

Server version
Select the required server version from the drop-down list.

Default collation
Select the required default collation from the drop-down list.

ExpandedToggleIcon(9x12) Source Control

Repository
Select a required source control repository from the drop-down list. Select <Manage...> to create, edit, or delete source control repositories with help of the Repository Manager Dialog Box.

Edit
Click to edit the source control repository properties

New
Click to create a new connection to source control repository.

Revision
Select a required revision from the drop-down list.

Latest (Head)
Select to use the latest revision copy of the version control.

<Select a specified revision...>
Select to use a required revision copy of the version control.

Server version
Select the required server version from the drop-down list.

Default collation
Select the required default collation from the drop-down list.

ExpandedToggleIcon(9x12) Snapshot

Snapshot
Select a snapshot file for comparison. You can open an existing snapshot file clicking the <Browse..> link.

New
Click the button to open the Create Schema Snapshot dialog box and create a snapshot for a required database.

Browse
Click the button to open an existing snapshot file.

Server
The server connection name is specified.

Server Version
The version of the snapshot database server used in the connection is specified.

Database
A database of the used snapshot is specified.

Created
A snapshot creation date is specified.

Swaps the Source and Target settings.

Click to copy the Source settings to the Target.

Click to copy the Target settings to the Source.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Options, Schema Comparison Wizard


Options, Schema Comparison Wizard

Use the Options wizard page to tune schema comparison.

Auto Mapping

Associate column names having similar name options, ...%
Select to consider similar column names equal. Click "..." to configure the similarity percent. The default value is 80%.

Ignore case in object names
Select to ignore cases in object names during mapping and comparison.

Ignore spaces in objects names
Select to ignore spaces in object names during mapping and comparison.

Common

Compare database properties
Select it to include a database object into comparison and synchronization. Note, that a database object will be synchronized even if this option is disabled, if the database object depends on other objects that are selected for synchronization.

Convert user data types into SQL Server system data types
Select to convert user data types into SQL Server system during comparison and synchronization.

Disable dependency analysis
Select to perform FAST COMPARISON. The option disables dependency building algorithms. Only object types selected in Object filer will be described. Synchronization script cannot be generated if this option is enabled.

Ignore authorization
Select it to ignore AUTHORIZATION clauses and statements on database-contained object when comparing and synchronizing databases.

Ignore CHANGE_TRACKING
Select it to ignore CHANGE_TRACKING clauses and statements when comparing and synchronizing databases.

Ignore CLR datatypes in column
When selected, CLR datatypes in column are ignored during comparison and synchronization. Columns' CLR dataypes in the target table will be reserved, if possible.

Ignore collations
Select it to ignore collations of columns during comparison and synchronization. Collations will be canceled if data type in column was changed to a non-text one, no matter, either you selected this option, or not

Ignore DATA_COMPRESSION for tables, indexes, primary and unique constraints.
Select it to ignore the DATA_COMPRESSION clause for tables, indexes, primary and unique key constraints. It will be preserved in Target.

Ignore database and sever names for synonyms
When selected, database and server names are ignored for synonyms during comparison and synchronization.

Ignore database extended properties
Select to ignore extended properties of database objects during comparison and synchronization. They will be preserved after synchronization if an object, referring to these extended properties, is rebuilt.

Ignore database object extended properties
Select to ignore extended properties of database objects during comparison and synchronization. These properties will be preserved after synchronization if an object that refers to them is rebuilt.

Ignore datatypes in column
When selected, datatypes in column are ignored during comparison and synchronization. Column datatypes in the target tables will be preserved, if possible.

Ignore event notification on queues
Select it to ignore an event notification on queues during comparison and synchronization.

Ignore filegroups and partition schemes/functions.
Select to ignore filegroup, partition schemes and partition functions during comparison and synchronization. The option is selected by default, as the tool does not synchronize the aforementioned clauses, but synchronizes the corresponding properties of tables, indexes, primary keys and unique constraints.

Ignore full-text catalog path
Select it to ignore the path in the full-text catalog during comparison.

Ignore full-text search
Select it to ignore full-text stoplists, full-text catalogers and full-text indexes during comparison and synchronization. If these objects are altered or deleted during synchronization, they will be restored if it is possible.

Ignore next filegroups
Select to ignore next filegroups during comparison and synchronization. Next filegroups in the target partition scheme will be preserved if possible.

Ignore semicolons
Select to ignore semicolons in the end of statements during comparison and synchronization.

Ignore sequence max value
Select to ignore sequence max value.

Ignore sequence min value
Select to ignore sequence min value.

Ignore sequence start value
Select to ignore sequence start value.

Ignore tSQLt framework and unit tests
Select to exclude tSQLt Framework objects during comparison and synchronization.

Ignore user DEFAULT_SCHEMA
Select it to ignore DEFAULT_SCHEMA for users during comparison and synchronization.

Ignore permissions
Select it to ignore security permissions during comparison and synchronization. The Target database permissions will be preserved if it is possible.

Ignore users' permissions
Select to ignore user permissions and role memberships during comparison and synchronization.

Ignore user DEFAULT_LANGUAGE
Select to ignore DEFAULT_LANGUAGE for users during comparison and synchronization.

Ignore logins, certificates, asymmetric keys for users
It is selected by default as the tool does not synchronize logins, certificats and asymmetric keys, but it synchronizes the corresponding user's properties. Logins for users existing in the Target database will be preserved.

Populate full-text indexes
When selected, populate full-text indexes are populated. The option is cleared by default, since creation of the full-text indexes i a time-consuming task.

Quote object names with square brackets
When selected, quote object names with square parentheses during script generation.

Tables

Force column order
When selected, adding a column to a table will cause its recreation. As a result, the column order will be preserved. Otherwise, difference in column order will be ignored and objects will be equal.

Ignore bound rules and defaults
Ignore bind of rules and defaults with a column, that is set with sp_bindrule or sp_bindefault during comparison and synchronization.

Ignore default column collations
Select to ignore default column collations during comparison and synchronization. If a column data type is changed to non-numeric, column collation will be canceled, regardless of the setting.

Ignore identity on columns
Select it to ignore identity on columns during comparison and synchronization. When selected, Ignore identity seed and increment values option is applied as well. Identity and its and and increment values will be restored in Target.

Ignore identity seed and increment values
Select it to ignore the identity seed and increment values during comparison and synchronization. Identity seed and increment values will be preserved after synchronization. If the Target column does not have the IDENTITY property, it will get this property after synchronization, but with default seed and increment values.

Ignore LOCK_ESCALATION
Select to ignore LOCK_ESCALATION.

Triggers

Ignore table DML triggers
Select it to ignore table DML triggers during comparison and synchronization. If they prevent synchronization, triggers will be dropped and then restored. If a table is dropped, then its triggers will be dropped in both cases either you have selected this option, or not.

Ignore INSTEAD OF triggers
Select to ignore INSTEAD OF triggers during comparison and synchronization. If a view is dropped, then its triggers will be dropped in both cases, either your have selected this option or not.

Ignore state of DML triggers
Select to ignore state of DML triggers during comparison and synchronization. State of DML triggers in the target database will be preserved if possible.

Ignore state of DDL triggers
Select to ignore state of DDL triggers during comparison and synchronization. State of DDL triggers in the target database will be preserved if possible.

Ignore firing order for DDL and DML triggers
Select it to ignore the setting of trigger fire order, that is set with sp_settriggerorder. Trigger fire order in the Target database will be preserved if possible.

Indexes and constraints

Ignore check constraints
Select to ignore constraints during comparison and synchronization. Check constraints won't be restored after synchronization.

Ignore column order in indexes
Select to ignore column order for included columns in indexes during comparison and synchronization.

Ignore constraints' names
Select to ignore constraints' names during comparison and synchronization. They will be preserved in Target.

Ignore constraints' system names
Select to ignore constraint system names during comparison and synchronization.

Ignore default constraints
Select to ignore default constraints and schema defaults during comparison and synchronization. Default constraint and schema defaults won't be restored after synchronization.

Ignore foreign keys
Select to ignore foreign keys during comparison and synchronization. Foreign keys won't be restored after synchronization.

Ignore foreign keys actions ON UPDATE and ON DELETE
Select to ignore referential integrity constraints for foreign keys during comparison and synchronization.

Ignore indexes
Select it to ignore indexes in tables and views during comparison.

Ignore indexes' names
Select to ignore names of indexes in tables and views during co indexes in tables and views during comparison and synchronization. Indexes' names will be preserved in Target.

Ignore NOCHECK state on constraints
Select to ignore NOCHECK clause for foreign keys and check constraints during comparison and synchronization. It will be preserved in Target.

Ignore NOT NULL constraint for a column
Select to ignore NOT NULL constraint for a column during comparison and synchronization. The option is not applicable to columns defines as PRIMARY KEY constraints.

Ignore PAD_INDEX and FILLFACTOR for indexes and constraints
Select to ignore PAD_INDEX and FILLFACTOR options for indexes and constraints during comparison and synchronization, The options will be preserved in Target.

Ignore PAGE_LOCK and ROW_LOCK for indexes and constraints
Select to ignore ALLOW_PAGE_LOCK and ALLOW_ROW_LOCK options for indexes and constraints during comparison and synchronization. The options will be preserved in Target.

Ignore primary keys
Select to ignore differences in primary keys during comparison and synchronization. Primary keys won't be restored after synchronization. For example, if one of their columns have no NOT NULL property.

Ignore sort direction (ASC/DESC) for index columns
Select to ignore sort direction for index columns during comparison and synchronization. It will be preserved in Target.

Ignore statistics
Select to ignore statistics related to a column during comparison and synchronization. If it prevents synchronization, it be be dropped and then restored with default options. Statistics won't be restored after synchronization, for example, if its column is dropped.

Ignore STATISTICS_NORECOMPUTE for indexes and constraints
Select it to ignore the STATISTICS_NORECOMPUTE option for indexes and constraints during comparison and synchronization. It will be reserved in Target.

Ignore unique keys
Select it to ignore unique keys during comparison and synchronization. Unique keys won't be restored after synchronization, for example if one of their columns was dropped.

Ignore WITH NOCHECK state on constraints
Select to ignore WITH NOCHECK clause for constraints during comparison and synchronization. It will be preserved in Target.

Keep objects in target

Ignore DML and INSTEAD OF triggers present only in Target
Select to ignore dropped DML triggers in target when comparing and synchronizing tables or views.

Ignore indexes present only in Target
Select to ignore dropped indexes in target when comparing and synchronizing tables or views.

Replications

Ignore NOT FOR REPLICATION for indexes, constraints and triggers
Select to ignore NOT FOR REPLICATION for indexes, constraints and triggers during compariosn and synchroniztion. They will be preserved in Target.

Ignore replicated tables
Select to ignore replicated tables during comparison.

Ignore replication procedures
Select to ignore replication procedures during comparison.

Ignore replication roles
Select to ignore replication roles ruing comparison.

Ignore replication schemas
Select to ignore replication schemas during comparison.

Ignore replication triggers
Select to ignore triggers created for replication needs during compassion and synchronization.

Script Objects

Decrypt encrypted objects
It is selected by default to make took decrypt encrypted objects' bodies for comparison and synchronization. They are shown in the comparison results as usual script objects. If you compare encrypted objects in databases with large bulks of data, selecting this option will slightly slow down a comparison.

Ignore case
Select it to ignore any case difference during comparison. Case differences in a script objects' body are preserved during synchronization.

Ignore comments
Select it to ignore comments when comparing views, stored procedures, etc. Comments in a script object's body are preserved during synchronization.

Ignore keyword reduction
Select it to ignore differences in full and short names of keywords during comparison.

Ignore object names in definitions
Select to ignore object names that appear in definitions during comparison.

Ignore QUOTED_IDENTIFIER and ANSI_NULLS
Select it to ignore QUOTED_IDENTIFIER and ANSI_NULLS options for functions, procedures, triggers, etc. during comparison and synchronization. They will be preserved in Target.

Ignore signatures
Select it to ignore signatures when comparing and synchronizing procedures, functions, triggers and assemblies.

Ignore white spaces
Select it to ignore any differences in white spaces (new lines, tabs, spaces, etc.) during comparison and synchronization. Original white spaces in a script object's body are preserved during synchronization.

Ignore WITH ENCRYPTION
Select to ignore difference in WITH ENCRYPTION attribute.

Ignore WITH option order
Select it to ignore elements order of WITH clause for views, procedures, functions, triggers, etc. during comparison and synchronization.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default comparison settings.

My Defaults
Click this button to restore your default comparison settings, previously saved with the Save As My Defaults button.

Other Elements

Save settings to a command line arguments file
Click to save settings of options to use them in an arguments file when comparing databases through the command line or scheduling a task.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Schema Comparison Document


Schema Mapping, Schema Comparison Wizard

This page allows you to change the automatic schema mapping and map schemas manually based on your needs.

note Note

The page is available if Database, Backup or Snapshot is selected as Source or Target.

It contains the following details:

Refresh
Click the button to discard the owners you have chosen.

Restore Default Mapping
Click it to discard your manual mapping and restore the default one.

Clear All Mapping
Click it to discard mapping. All fields in the Target part of the grid will have the <None> value. After that you can click the button to select the required schema from the drop-down list.

Source schema
Lists all schemas in the Source database.

Target schema
Contains Target schemas mapped to the Source ones. Note if dbForge Schema Compare cannot find the corresponding schema in the Target, you will see the <None> value in the fields.

Compare only mapped schemas
Select the check box to see only mapped schemas and their objects in the comparison results and synchronize them.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Object Filter, Schema Comparison Wizard


Table Mapping, Schema Comparison Wizard

Select tables and their columns to compare on this page.

This page displays the grid with compared tables and comparison columns. The grid contains the following columns:

Column with check boxes
Select check boxes to include tables to comparison.

Object Name
Displays table names.

Columns in Comparison
See the quantity of columns (the first number) that are compared and the whole quantity of columns existing in the object (the second number). Click the button to open the Column Mapping dialog box and select columns to include into comparison and map them in this column.

note Note

The Caution icon informs you about mapping warnings.

You may select several tables and include or exclude them from comparison together. To select several tables click them holding the CTRL key. To select all tables and views press CTRL+A.

Filter Text Box
Enter filter here to see only objects, containing the filter string in their names.

ExpandedToggleIcon(9x12) Mapping Toolbar

Icon | Name | Description
Filter | Filter | Allows using some predefined filters in addition to filtering by object name
RefreshButton | Refresh | Click to refresh mapping
MapObjects | Map Objects | Click to call the Object Mapping dialog box to customize the object mapping
Unmap | Unmap | Click to unmap the object pairs, selected in the grid
Reset | Reset | Click to restore automatic mapping

Predefined Filters

Name | Description
All | Shows all object pairs
Valid Mappings | Shows object pairs without table level warnings
Invalid Mappings | Shows object pairs with table level warnings
Auto Mapped Objects | Objects, that were mapped automatically by dbForge Data Compare
User Mapped Objects | Objects, that were mapped manually by user
Fully Mapped Objects | Objects that were fully mapped
Partially Mapped Objects | Objects that were fully mapped
Included Objects | Object pairs, included to comparison
Excluded Objects | Object pairs, excluded from comparison

note Note

If not all the objects are mapped, an information link that shows the number of unmapped objects is displayed in the bottom right corner of the wizard page. Click this link to go to the Object Mapping dialog box.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Object Mapping Dialog Box


Object Mapping Dialog Box

This dialog allows you to set custom mapping for tables.

Source objects

Lists tables of the source database. If there are several schemas in the database, tables are grouped by these schemas.

Filter
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Check this option to show only unmapped objects in the list.

Target objects

Lists tables of the target database. If there are several schemas in the database, tables are grouped by these schemas.

Filter
To quickly find a required object, enter characters available in the required object's name. Only objects, names of which contain the required characters, will be shown in the list.

Hide mapped objects
Check this option to show only unmapped objects in the list.

Buttons

OK
Click to map the selected source and target object and close the dialog.

Close
Click to close the dialog.

Map
Click to map the selected source and target object without closing the dialog.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Column Mapping Dialog Box


Column Mapping Dialog Box

This dialog allows you to set custom mapping for columns.

Select columns for comparison
This grid allows controlling column mapping.

Source column
Contains all source columns.

Target columns
Contains Target columns, mapped to the Source columns. Click to map or unmap a Target column. The icon shows the state of the pair - normal or warning.

Column details
This grid displays properties of a Source and Target column from the selected column pair in the Select columns for comparison grid.

Reset
Click to restore the automatic mapping.

Cancel
Click to cancel changes and close the dialog.

OK
Click to apply changes and close the dialog.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Object Filter, Schema Comparison Wizard


Object Filter, Schema Comparison Wizard

Select check boxes next to required object types to include them in the comparison.

Select All
Allows you to select all the database object types.

Group by Server Version
Select the check box to group the list of supported object types by SQL Server versions.

note Note

Objects are filtered according to the compatibility properties of the source database. Objects that are not compatible with the source database are disabled.

ExpandedToggleIcon(9x12) See Also

Schema Comparison Wizard

Schema Comparison Document


Schema Synchronization Wizard

Use Schema Synchronization Wizard to synchronize database differences. To access the wizard, click the Synchronize button on the Comparison toolbar. The wizard pages are listed below.

To switch between the wizard pages, either use the Next and the Back buttons or click page names on the left side of the wizard.

ExpandedToggleIcon(9x12) In This Section

Output, Schema Synchronization Wizard
Learn how to manage the synchronization script.

Options, Schema Comparison Wizard
Use the topic to specify general synchronization options.

Dependencies, Schema Synchronization Wizard
Use the topic to specify additional objects to synchronize.

Issues, Schema Synchronization Wizard
Learn how to resolve issues for synchronization actions.

Summary, Schema Synchronization Wizard
Use the topic to review the synchronization actions and warnings.

ExpandedToggleIcon(9x12) See Also

Schema Compare

Schema Comparison Wizard


Output, Schema Synchronization Wizard

Select output options to manage a synchronization script.

Open the synchronization script in the internal editor
Select the check box to open the synchronization script in an SQL document. The file name is generated automatically.

Save the script to a file
Select the check box to output your script to a file.

Browse
Click the button to specify the path to save a file.
Open in the internal editor
Select the check box to open the synchronization script in dbForge Schema Compare for SQL Server. The file name is generated by a user. If not selected, the synchronization script will not open.

Execute the script directly against the target database
Select the check box to synchronize the target database immediately without generating a synchronization script.

Refresh comparison results after synchronization
Select the check box to refresh comparison results after synchronization if synchronization was executed successfully.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Options, Schema Synchronization Wizard


Options, Schema Synchronization Wizard

Select general synchronization options including script execution.

ExpandedToggleIcon(9x12) Database backup

Backup path: (Path)
Select to backup the target database before synchronization and specify a backup file location. The backup file name will be generated in the current format: <database_name>_<yyyyy>_<MM>_<dd>_<hh>_<mm>.bak.

Backup type: (Type)
When selected, the backup will be created in the selected mode. Creating a differential database backup required a previous full database backup. If your database has never been backed up, a full database backup wil be created. The copy-only mode option is available for SQL Server 2008 or higher versions.

Create folder for database backup
Select to create a folder on the server for the database backup.

Extension for backup file: (Extension)
Select to setup extension for backup file. Click "..." to specify the required extension. If this option is not selected, the default extension (.back) will be used.

Use compression for backup
Select to perform backup compression. This option is available for SQL Server 2008 or higher versions.
ExpandedToggleIcon(9x12) Transactions

Use a single transaction
Select to execute a synchronization script as a single transaction. If selected, all the changes to the database will be rolled back in case of any error when executing the synchronization script.

Add error handling statements
If you run the script and the option is selected, the script will stop executing after encountering error.

Set Transaction isolation level to <LEVEL NAME>
Select this option to configure Transaction isolation level. Click "..." to select Transaction isolation level from the drop-down list box.

ExpandedToggleIcon(9x12) Common

Add constraints and keys to tables using WITH NOCHECK
Select to add WITH NOCHECK clause to foreign keys and constraints created during synchronization.

Add WITH ENCRYPTION
Adds WITH ENCRYPTION when stored procedures, functions, views and triggers are included to the synchronization script.

Check for object existence
Check for object existence.

Disable DDL triggers
Select to disable DDL triggers in the beginning of synchronization. After the synchronization they will be enabled.

Generate fully qualified object names
When selected, the fully qualified object names will be generated in the synchronization script. If the option is enabled, names of objects in the synchronization script will include a schema name.

Include USE <database_name>
When selected, the USE <database_name> clause will be added to the script.

Specify the folder for assemblies: (Enter a path)
When selected, the assembly synchronization will be performed by copying the files to the specified folder. Specify a local path or network location to copy the target assemblies to.

Synchronize database in the single user mode
When selected, database will be synchronized in the single user mode.

Update views
Updates the meta data for the specified non-schema-bound view.

Use ALTER SCHEMA TRANSFER expression
Use this expression to transfer tables between schemas. This option can be applied.

Use DROP and CREATE instead of ALTER
Select to replace ALTER statements with DROP and CREATE statements in synchronization script for views, procedures, functions and triggers. If this option is selected, the "Check for object existence" option will be used.

Use DROP and CREATE instead of ALTER for assemblies
When selected, ALTER statements will be replaced with DROP and CREATE statements in synchronization script for assemblies. If this option is selected, the 'Check for object existence' option will be used.

Use DROP and CREATE instead of ALTER for tables
When selected, ALTER statements will be replaced with DROP and CREATE statements in synchronization script for tables. If this option is selected, the 'Check for object existence' option will be used.

Verify table data using checksum
Select to enable the tool to check if any table data was lost after synchronization. If any data was lost, you could see a warning in the Error List window after synchronization.

ExpandedToggleIcon(9x12) Script Comments

Comment DDL statements for signatures, certificates, asymmetric and symmetric keys
If this option is selected, DDL for signatures, symmetric, asymmetric keys and certificates will be commented. This option is disabled by default, since the tool is unable to retrieve some options and passwords.

Exclude comments
Select to prevent comments generation in a synchronization script.

Include print comments
If the option is selected, comments will be printed into output while executing the script.

Buttons

Save As My Defaults
Click this button to save current settings as your default settings.

Devart Defaults
Click this button to restore the application default comparison settings.

My Defaults
Click this button to restore your default comparison settings, previously saved with the Save As My Defaults button.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Dependencies, Schema Synchronization Wizard


Dependencies, Schema Synchronization Wizard

Select additional objects to synchronize.

Synchronize the following objects, which have not been explicitly selected for synchronization, but which are used by one or more objects that you have included in the synchronization.

Affected Object
Specify the objects you want to include into the synchronization. All the objects are selected by default.

Details
Displays how a referencing object depends on an affected object.

Referencing or Referenced by
Objects that are referencing to the affected objects.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Issues, Schema Synchronization Wizard


Issues, Schema Synchronization Wizard

Resolve issues for synchronization actions.

Column
A column that has a conflict with the specified constraint.

Action
To make the synchronization successful, specify the action to do with a conflict column.

Value
Specify a new column value.

Warning
Learn the messages of conflicts that can occur while synchronization.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Summary, Schema Synchronization Wizard


Summary, Schema Synchronization Wizard

Review the synchronization actions and warnings.

Action Plan
Displays synchronization actions in the order in which they occur.

Search
Type filter string here. Use "_" symbol to substitute any character.

Expand All
Click to expand all synchronization actions.

Collapse All
Click to collapse all synchronization actions.

Warnings
Displays conflict messages.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard

Schema Compare


Schema Comparison Document

Use this document to see, analyze schema comparison results, and set up synchronization. It contains the following:

Comparison toolbar

The Comparison toolbar appears automatically when the Schema Comparison document opens. The toolbar contains the following buttons to help you manage comparison results:

ChangeCompProperties Edit Comparison
Click it to change the Source and Target connections and databases. The Change Schema Comparison Properties wizard opens. Click the down arrow near the Group by field and select the corresponding option in the appeared menu.

RefreshButton Refresh
Click it to restart the comparison and refresh the comparison results.

Stop Execution
Click it to stop the comparison.

Group-by-field
Use it to filter the comparison results by their status, operation, object type, or cancel grouping.

Filter
Use it to filter the comparison results by their status. Click the down arrow near the Filter button and select the corresponding option in the appeared menu, e.g., to show only in Source objects.

View Schema Update Script
Click it to preview the synchronization script, generated by Schema Compare for SQL Server, for any compared object. The Schema Update Script window opens.

GenerateComparisonReport Generate Comparison Report
Click it to preview the comparison report, generated by Schema Compare for SQL Server. The Generate Comparison Report window opens.

Synch-btn Show Synchronization Wizard
Click it when you have reviewed the comparison results and want to synchronize them. The Schema Synchronization wizard opens.

Document Header
Document header shows:

1. The search field that allows you to find an object.
2. Source and Target databases with their connections.
3. Number of selected objects.

Grid
The grid shows the following details:

Type
Shows objects type that is being compared.

Owner
Shows an owner of a source object

Source Object
The object of the Source database that will be compared with the corresponding object of the Target database.

Check box
Select the check boxes to include compared objects into synchronization. If you don't want to synchronize some objects, clear the check boxes for them.

Operation
The operation related to a compared object that will be executed during synchronization. You can click the Operation field and select other operation from the drop-down list. To avoid changing of the Target object during synchronization, you can select the None operation.

Target Object
The object of the Target database which contents you compare and synchronize with the Source one.

Owner
Shows an owner of a target object.

Text Comparer

Text comparer displays DDL differences of Source and Target objects. You can use the following buttons to customize the view of Text Comparer:

detached-window-btn - click to show Text Comparer in a detached window.

collapse-btn - click to collapse Text Comparer

expand-btn - click to expand Text Comparer. The button appears only if Text Comparer was collapsed previously.

- click it to turn on/off word wrap.

- click it to show or hide line numbers.

AZ - click it to sort columns and constraints in alphabetical order.

Tip: To better understand comparison results, you can filter them by their status or name and group by their status, operation, and object type.

Preview Tooltip

Simply put your mouse pointer over any part of the vertical scroll bar and you will get a preview of the code at that position in the document.

Enhanced Scroll Bar

Enhanced Scroll Bar

ExpandedToggleIcon(9x12) See Also

Schema Update Script Window


Schema Update Script Window

Use the Schema Update Script window to preview a synchronization script for any compared object. To open the window, select any object (or several ones) in the grid and do either of these actions:

· Right-click the grid with comparison results and select View Schema Update Script from the shortcut menu
· Click the [image] View Schema Update Script button on the toolbar
· Click the View Schema Update Script button from the Comparison menu.

Also you can copy the synchronization script in the Schema Update Script window and paste into the SQL editor or other file for further editing or saving.

ExpandedToggleIcon(9x12) See Also

Generate Comparison Report Dialog Box


Generate Comparison Report Dialog Box

Use this dialog box to generate a report after schema comparison is completed. Select Generate Comparison Report from the Comparison menu to open the Generate Comparison Report dialog box. It contains the following details:

Format
Select what format you need for a comparison report. HTML, Excel, XML and XML for Excel are available.

Name
Change the default name for the comparison report file. Enter a required one.

Location
Change the default location to store the comparison report file. You can specify the location either manually or click the [image] button to select a required folder in the Browse for Folder dialog box.

Include
Select what objects to include into the comparison report, either objects with differences or all the objects selected for comparison. Besides you can include or exclude identical objects and comparison options.

Group objects by
Select how to group objects to display in the comparison report.

View a report on completion
Select this check box if you want to see a generated comparison report opened.

ExpandedToggleIcon(9x12) See Also

Schema Synchronization Wizard


Repository Manager Dialog Box

Repository Manager dialog box allows you to create, edit, and delete source control repositories.

Dialog Box Controls

Repositories
The list of the existing repositories.

New
Click to open Source Control Repository Properties Dialog Box for setting a new source control repository.

Edit
Click to open Source Control Repository Properties Dialog Box for editing a source control repository.

Delete
Click to delete the source control repository.

Repository Info
Displays a string, containing the properties for the selected source control repository.

ExpandedToggleIcon(9x12) See Also

Source Control Repository Properties Dialog Box


Source Control Repository Properties Dialog Box

Use this dialog box to modify or set up properties of the source control repository.

Source control system
Select source control system from the drop-down list box.

Source control settings
Specify source control settings for the selected source control system.

ExpandedToggleIcon(9x12) For Team Foundation Server (TFS)

Server URL
Specify the URL for the TFS Server.

Username
Specify the username for the TFS Server.

Password
Specify the password for the TFS Server.

Use Windows authentication
Select to use Windows authentication when logging in to the repository.

Database folder
Specify the path to the repository folder containing SQL scripts that represent the database.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Subversion (SVN)

Server URL
Specify the URL of your SVN server.

Username
Specify the username for the SVN server.

Password
Specify the password for the SVN server.

Database folder
Specify the path to the repository folder containing SQL scripts that represent the database.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For SourceGear Vault

Server
Specify the SourceGear Vault server address in this box.

Use SSL
Select the check-box to use SSL connection.

Username
Specify the username for the SourceGear Vault server.

Password
Specify the password for the SourceGear Vault server.

Repository
Specify the SourceGear Vault repository name.

Database folder
Specify the path to the repository folder containing SQL scripts that represent the database.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Perforce (P4)

P4PORT
Specify the protocol, host and port number for the Perforce server.

Username
Specify the username for the Perforce server.

Password
Specify the password for the Perforce server.

Workspace
Select the workspace from the drop-down list box.

New
Click to create a new workspace with the New Workspace Dialog Box.

Mapping
Select mapping from the drop-down list box, if required. Mapping specifies the depot and the remote folder, that will be used by dbForge Schema Compare for SQL Server.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Git

Remote repository
Specify URL for the remote repository in this box.

Security settings: HTTP

Login
Specify login for the remote repository.

Password
Specify password for the remote repository. .

Client Certificate
If the server is set up for authentication using the client certificate, select client certificate from the drop-down list box.

Security settings: SSH

Password
Select to use password authentication.

Password:
Type your password in this box.

Key
Select to use key authentication.

Key file
Specify path to the key in this box.

Passphrase
Type the passphrase in this box.

Use existing local clone
Select to use a ready local clone instead of the technical clone created by dbForge Schema Compare for SQL Server. In this case, all settings (including address of the remote repository) will be taken from the selected local clone. Specify the path to the local clone in the box.

Branch
Select required branch of the remote repository from the drop-down list box.

User name
Specify your Git user name in this box.

E-mail
Specify your Git e-mail address in this box.

Repository name
Specify repository name in this box.
ExpandedToggleIcon(9x12) For Mercurial

Server URL:
Specify the URL of the Mercurial server in this box.

Use existing local repository
Select to use existing local repository instead of the remote repository. Specify the path to the local repository in the box.

Repository name
Specify repository name in this box.
ExpandedToggleIcon(9x12) For Working Folder

Database folder
Specify the path to the database folder.

Repository name
Specify repository name here.
ExpandedToggleIcon(9x12) For Command Line Interaction

Database folder
Specify the path to the database folder.

Command line configuration preset
Select the required command line configuration preset from the drop-down list box. The following presets are available: Template, Plastic SCM.

Command line configuration
Shows config file with command line hooks according to the selected command line configuration preset.

Repository name
Specify repository name here.

Buttons

OK
Click to apply changes.

Test
Click to test the connection to the source control repository.

Cancel
Click to cancel changes.

ExpandedToggleIcon(9x12) See Also

Select Database Scripts Folder Dialog Box

Schema Compare


Create Folder Dialog Box

Use this dialog box to create a new folder to store database scripts. To open this dialog box, click Create Folder in the Select Database Scripts Folder dialog box. If you specified a nonexistent folder in the Source Control Repository Properties Dialog Box, this box appears automatically during the attempt to link a database to a selected source control system.

Folder name
Type the folder name here.

Comment
Specify the comment for the folder to be created.

Buttons

OK
Click to apply changes.

Cancel
Click to cancel changes and close the dialog box.

ExpandedToggleIcon(9x12) See Also

New Workspace Dialog Box

Schema Compare


Select Database Scripts Folder Dialog Box

Use this dialog box to select the folder to store database scripts.

Select or create folder to link to database
Select the required folder from the list or create a new folder by clicking the Create Folder button.

Selected path
Shows the path to the selected folder.

Buttons

Create Folder
Click to open the Create Folder dialog box to create a new folder.

OK
Click to apply changes.

Cancel
Click to cancel changes and close the dialog box.

ExpandedToggleIcon(9x12) See Also

New Workspace Dialog Box

Schema Compare


New Workspace Dialog Box

Use this dialog box to create a new workspace.

Name
Type the name of a new workspace in this field.

Depot
Specify the depot to store database scripts.

Folder
Specify a path to a database scripts folder. Click "..." to open the Select Database Scripts Folder dialog box.

note Note

If you leave the Folder field empty, it will be considered that the whole depot contains database scripts. If such folder does not exist, it will be created automatically on the first commit.

Buttons

OK
Click to apply changes.

Cancel
Click to cancel changes and close the dialog box.

ExpandedToggleIcon(9x12) See Also

Select Database Scripts Folder Dialog Box

Schema Compare


Shortcut Keys

Several pre-defined keyboard shortcut collections are included in Schema Compare for SQL Server. All shortcuts can be customized.

ExpandedToggleIcon(9x12) Global Shortcut Keys

The following shortcut key combinations can be used in any Schema Compare for SQL Server document or tool window.

Icon | Command Name | Shortcut Keys | Description | Where is used
 | Output | Ctrl+W, O | Reveal the Output window | Global
 | Error List | Ctrl+W, E | Reveal Error List window | Global
 | Data Viewer | Ctrl+W, R | Reveal Data Viewer window | Global
 | Web Browser | Ctrl+W, W | Reveal Web Browser | Global
 |  | Ctrl+PLUS (+) KEY | Zoom font size in | Global
 |  | Ctrl+MINUS (-) KEY | Zoom font size out | Global
 |  | Ctrl+0 | Reset font size to the default value | Global

ExpandedToggleIcon(9x12) Document Management Shortcut Keys

These are default shortcuts. All shortcuts can be customized.

Icon | Command Name | Shortcut Keys | Action | Where is used
 |  | Ctrl+Tab | Switch to last used document | Global
 |  | Ctrl+Shift+Tab | Cycle through all open documents | Global
 |  | F7 | Cycle through document views | Global
 |  | Shift+F7 | Cycle through document views backwards | Global
Save | Save | Ctrl+S | Save current document | Global
SaveAll | Save All | Ctrl+Shift+S | Save all documents | Global
 | Open | Ctrl+O | Open document | Global
 | Close Document | Ctrl+F4 | Close current document | Global
 | SQL | Ctrl+N | New SQL document | Global
Print | Print | Ctrl+P | Print | Text or data view of a document Data window

ExpandedToggleIcon(9x12) See Also

Reference


SQL Document

This section describes Query Editor user interface elements.

ExpandedToggleIcon(9x12) In This Section

SQL Editor Window
This topic describes the SQL document window interface elements.

Edit Parameters Dialog Box
This topic describes content of dialog box where you can edit query parameters.


SQL Editor

The SQL editor is a word processing utility where you enter and edit SQL statements. The statements are colorized so you can easily read them.

You can open multiple SQL editors to view SQL code and copy and paste among them. A list of all open SQL editors is available in the Windows menu.

Every Schema Compare for SQL Server document has Text View that is shown in SQL editor. You can use the SQL History to speed up your work. To learn how to use SQL Editor features, see the Writing and Executing SQL Statements section.

You can launch SQL editor in several ways. For example:

1. Click File -> NewSQL New SQL in the application main menu.
2. Click NewSQL New SQL on the Standard toolbar.
3. Open an SQL file by selecting File -> Open File.

You can always save a SQL document for future use.

SQL Editor Interface Elements

Code Pane

An area where SQL code is displayed and edited.

Margin Indicator Bar

A grey area at the left of the editor. Margin indicators, such as bookmarks are displayed there. You can show or hide it by setting the corresponding option in the General, Text Editor Options Dialog Box.

Selection Margin

White area between the margin bar and code. Click here to select the line.

Horizontal and Vertical Scroll Bars

Allows scrolling the code. You can show or hide them by setting corresponding options in General, Text Editor Options Dialog Box.

ExpandedToggleIcon(9x12) See Also

SQL Document

Edit Parameters Dialog Box


Edit Parameters Dialog Box

This window allows you to add, delete, or modify existing parameters in the query. Click edit-parameters Edit Parameters button on the SQL toolbar to invoke this window.

Name
Displays the list of parameters that are currently used. Click on a parameter to select it and fill the fields to the right of the list with values that correspond to the selected parameter. Click it again to rename the parameter.

The following fields are specific for every parameter. Their content depends on what parameter is currently selected.

Type
Lets you choose the data type of the parameter.

Direction
Indicates whether the parameter is input, output, or bidirectional.

Nullable
Specifies whether the value of this parameter is NULL. Checking this option clears the Value field.

Value
Value of the parameter. Note that character or date and time values should not be quoted. If you want to set value sample text you should just enter sample text without quotes.

ExpandedToggleIcon(9x12) See Also

SQL Document


Create Schema Snapshot

This topic describes how to create a schema snapshot file. Snapshot is a file generated by Schema Compare for SQL Server that contains an information about a database structure in XML format.

To create a new snapshot:

1. In the Database menu, point to Tasks, and then click Create Schema Snapshot.
2. Right-click the database, point to Tasks, and then click Create Schema Snapshot.
3. Optionally, you can change a *. snap file name.
4. Optionally, you can change the file location. You can store the file in a repository. To do this, select the Version Control radio button.
5. Optionally, you can add a comment to the *. snap file.
6. Optionally, you can select the Compress check box to archive the created file.
7. Optionally, you can either select or clear the Decrypt encrypted objects option.
8. Click Create.

To create a new snapshot with help of command line:

You can automate creation of target database snapshots using the command line.

To create a snapshot of target database through the command line, do the following:

1. Open Command Prompt by pressing Win+R, and typing 'cmd' in the Open line.

note Note

To run the Command Line in Windows 8:

From the Desktop Mode

· Move the mouse cursor to the exact lower left corner until the desktop shortcuts menu appears.
· Right-click to see the shortcut menu and than click Run.

From the Charms Bar

· Move your mouse to the upper right corner until the Charms Bar appears.
· Select Apps from the list and type “run” in the search box.
· Click Run from the search results.

Use Windows + R Shortcut Keys

· In desktop mode, press the Windows + R keys, to show the Run command line.
2. Type a path to the datacompare.com file, located in dbForge Schema Compare for SQL Server installation folder on your PC, and press the SPACE bar.

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com"

3. Specify the action you want to perform:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot

4. Specify the connection string and schemas:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server>schemacompare.com /snapshot /connection:"User Id=hr;Server=SQL;Unicode=True" /s:"SH,SH"

5. Press ENTER to run the process.

Tip: To see a quick help on the switches available for the /snapshot operation, type the following:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /?

ExpandedToggleIcon(9x12) Arguments Used in Command Line

Select a corresponding command line switch to perform a required operation:

Argument | Action and Usage
/alias | Use the switch to define a version control alias. Command usage looks like: /alias:<value>
/comment | Use the switch to write a comment. Command usage looks like: /comment:<value>
/compress | Use the switch to apply compression to a snapshot file. Command usage looks like: /compression:<value> To turn this option on, type Yes, Y, On, True, T. To turn this option off, type No, N, Off, False, F.
/connection | Use the switch to specify a full connection string with additional parameters. This argument is required. Command usage looks like: /connection:<connection_string>
/database | Use the switch to specify a target database name. Define this argument to override the database specified in the connection string. Command usage looks like: /database:<database_name>
/file | Use the switch to specify a file name and its path to save a created snapshot file. Command usage looks like: /file:<file_path> If a path is not specified, a snapshot file will be saved to a current directory.
/password | Use the switch to specify a server password. Define this argument to override the password specified in the connection string. Command usage looks like: /password:<pw>

Command line used to make a snapshot of a schema may look like:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /connection:"User Id=hr;Server=SQL;Unicode=True;" /password:my_pass /schema:"HR" /file:"result.snap"

If you connect to the server in the Direct mode, the connection parameters will differ and the command line used to make a snapshot of a schema will look like:

"C:\Program Files\Devart\dbForge Schema Compare for SQL Server\schemacompare.com" /snapshot /connection:"User Id=hr;Server=dbSQL;Connect Mode=SysDba;Unicode=True;Direct=True;Service Name=SQL" /password:my_pass /schema:"HR" /file:"result.snap"

ExpandedToggleIcon(9x12) See Also

Database Tasks

Generate Scripts


Database Creation Dilaog Box

Use this dialog box to create a new target database.

Name
Specify the name of the database.

Owner
Select the name of the database owner from the drop-down list box.

Description
Provide the database with meaningful description here.

Files

Add
Add a new file to the database.

Remove
Delete the selected file from the database. A file cannot be removed unless it is empty. The primary data file and log file cannot be removed.

Logical name
Enter or modify the name of the file.

File type
Specify the file type here. The Data, Log, or Filestream Data values are available. You cannot modify the file type of an existing file.

Filegroup
Select the filegroup for the file here. By default, the filegroup is PRIMARY. You can create a new filegroup by selecting <new> and entering information about the filegroup in the New Filegroup dialog box. A new filegroup can also be created on the Filegroups tab. You cannot modify the filegroup of an existing file.

Initial size (MB)
Enter or modify the initial size for the file in megabytes.

Autogrowth/Max Size
Displays the autogrowth file properties. These properties control how the file expands when its maximum file size is reached. To edit autogrowth values, click the edit button next to the autogrowth properties for the required В file, and change the values in the Change Autogrowth dialog box.

Path
Displays the path to the selected file. To specify a path for a new file, click the edit button next to the path for the file, and navigate to the destination folder. Note that you cannot modify the path of an existing file.

File name
Displays the name of the file. Is not valid for the FILESTREAM files.

ExpandedToggleIcon(9x12) See Also

Schema Compare


SQL Document Overview

Most of the time you interact with a database by writing and executing SQL queries. In this way, SQL document is an essential part of every database tool in dbForge product line. It is a place where you create SQL statements in order to run them against a database server. This topic gives you an overview of SQL document layout, views, and functions.

To create a new SQL Document:

On the Standard toolbar, click New SQL.

The following image is the example of an SQL document.

note Note

Actual document look may slightly vary from the image above, depending on the product you use.

ExpandedToggleIcon(9x12) SQL Document Overview

Each SQL document includes different representations of the content. They are called document views. On the above screen-shot you can see two document views: Text and Data.

· Text view contains SQL editor which allows you to write SQL statements.
· Data view, typically shown after a query is executed, displays a data editor with result sets returned by a database server.

To switch to a specific view:

· Click a button with a view name on the bottom-panel of the document.
· Right-click document bottom-panel to open the shortcut menu and select a view from the list.

ExpandedToggleIcon(9x12) Representing Query Execution Results

The query execution results can be represented in two ways - in text and in grid formats.

To represent results as text, on the SQL toolbar, click the results-as-text Results as Text button before query execution. The following image represents a sample of query execution results in text format.

To represent results as grid, on the SQL toolbar, click the results-as-grid Results as Grid button before query execution. The following image represents a sample of query execution results in grid format.

CollapsedToggleIcon(9x12) Document Layout

SQL document has two types of view layout: Split Layout and Combined Layout. To switch document layout use appropriate buttons at the bottom-right corner of the document.

Split Layout

In the split layout a document has one prominent (main) view which is aligned to the top of the document view port. Other views are called additional, they are displayed in the bottom area of the document view port.

Main view remains always in split layout visible and you can toggle only additional views. But you can see two views at a time to avoid unnecessary switching.

To temporary hide additional document views, click the hideshow-views Hide/Show additional document views button at the bottom-right corner of the document, or just press CTRL+R.

To change the main document view, use the swap-views Swap main and additional documents views button to swap the main view and active additional view.

Combined Layout

In the combined layout you can see only one view at a time. A document view fills entire document view port. Typically, you need this layout when you a focusing on one specific document representation (for example, when you extensively work with data).

ExpandedToggleIcon(9x12) See Also

Writing and Executing SQL Statements

Writing SQL Statements


What's New in dbForge Schema Compare for SQL Server, v4.0

Compatibility

· Windows 10 support

Schema Comparison

· Custom mapping for tables
· Updated Synchronization wizard
· Zooming font size in Text Comparer
· Option for update metadata for the specified non-schema-bound view

SQL Editing and Execution

· Command-line interface for SQL formatting
· Query execution pane
· Easy way to hide data results
· Encoding switch in the /execute command-line operation
· Updated Find&Replace feature for documents and files

Generate Script

· SQL Azure support

Data Editor

· Data Viewer, LOB Editor, and Redirect Data to Output are combined in a single control
· Zooming font size in Data Viewer and Editor Window

User Interface

· Support of multiple monitors
· New skins
· Create Schema Snapshot wizard window works in modeless mode

ExpandedToggleIcon(9x12) See Also

Welcome to Schema Compare for SQL Server

Editions